<?php

namespace Application\Migrations;

use Topalis\Database\Migrations\AuralisMigration020100;
use Doctrine\DBAL\Schema\Schema;

/**
 * Auto-generated Migration: Please modify to your need!
 */
class Version020100 extends AuralisMigration020100
{
    public function up(Schema $schema)
    {
        // this up() migration is autogenerated, please modify it to your needs
        $this->abortIf($this->connection->getDatabasePlatform()->getName() != "mysql");

        $this->addSql("RENAME TABLE reverse_proxy_url TO reverseproxy_urls");

        $this->addSql("CREATE TABLE configgroups (id INT UNSIGNED AUTO_INCREMENT NOT NULL, comment VARCHAR(255) DEFAULT NULL, allowProfileRemoval TINYINT(1) NOT NULL, syncDays INT NOT NULL, allowMove TINYINT(1) NOT NULL, fromAnyApp TINYINT(1) NOT NULL, name VARCHAR(255) NOT NULL, profile TEXT DEFAULT NULL, customProfile TINYINT(1) DEFAULT NULL, customProfileName VARCHAR(255) DEFAULT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $this->addSql("CREATE TABLE configgroups_reverseproxyurls (configgroup_id INT UNSIGNED NOT NULL, reverseproxyurl_id INT UNSIGNED NOT NULL, INDEX IDX_75FFCB31FF00FACA (configgroup_id), INDEX IDX_75FFCB31D460FB91 (reverseproxyurl_id), PRIMARY KEY(configgroup_id, reverseproxyurl_id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $this->addSql("ALTER TABLE configgroups_reverseproxyurls ADD CONSTRAINT FK_75FFCB31FF00FACA FOREIGN KEY (configgroup_id) REFERENCES configgroups (id) ON DELETE CASCADE");
        $this->addSql("ALTER TABLE configgroups_reverseproxyurls ADD CONSTRAINT FK_75FFCB31D460FB91 FOREIGN KEY (reverseproxyurl_id) REFERENCES reverseproxy_urls (id) ON DELETE CASCADE");

        $this->addSql("ALTER TABLE admins CHANGE id id INT UNSIGNED AUTO_INCREMENT NOT NULL, CHANGE level level INT UNSIGNED NOT NULL COMMENT 'User level: 0=admin, 1=monitor', CHANGE login login VARCHAR(50) NOT NULL COMMENT 'The unique login name', CHANGE pwhash pwhash VARCHAR(80) DEFAULT NULL COMMENT 'Password hash for GUI', CHANGE davhash davhash VARCHAR(80) DEFAULT NULL COMMENT 'HTTP password hash for WebDAV access', CHANGE realname realname VARCHAR(50) DEFAULT NULL COMMENT 'The real name'");
        $this->addSql("ALTER TABLE clientcerts CHANGE id id INT UNSIGNED AUTO_INCREMENT NOT NULL, CHANGE device_id device_id INT UNSIGNED DEFAULT NULL, CHANGE cert cert VARCHAR(8192) DEFAULT NULL COMMENT 'The PEM encoded X.509 certificate', CHANGE privatekey privatekey VARCHAR(8192) DEFAULT NULL COMMENT 'The certificates private key (only available if generated on server side)'");
        $this->addSql("ALTER TABLE access_stat_daily CHANGE traffic traffic BIGINT UNSIGNED NOT NULL COMMENT 'Accrued traffic in bytes at that day', CHANGE access_count access_count INT UNSIGNED NOT NULL COMMENT 'Number of accesses at that day', CHANGE distinct_ips distinct_ips INT UNSIGNED NOT NULL COMMENT 'Number of different IPs at that day', CHANGE distinct_devices distinct_devices INT UNSIGNED NOT NULL COMMENT 'Number of different devices at that day'");
        $this->addSql("ALTER TABLE mailaccounts DROP FOREIGN KEY fk_mailaccounts_device_id");
        $this->addSql("ALTER TABLE mailaccounts CHANGE id id INT UNSIGNED AUTO_INCREMENT NOT NULL, CHANGE device_id device_id INT UNSIGNED NOT NULL, CHANGE cert_id cert_id INT UNSIGNED DEFAULT NULL, CHANGE user user VARCHAR(255) NOT NULL COMMENT 'email account login user', CHANGE email email VARCHAR(255) NOT NULL COMMENT 'email address'");
        $this->addSql("ALTER TABLE mailaccounts ADD CONSTRAINT FK_643DFEBE94A4C7D4 FOREIGN KEY (device_id) REFERENCES devices (id)");
        $this->addSql("ALTER TABLE accesslog CHANGE id id BIGINT UNSIGNED AUTO_INCREMENT NOT NULL, CHANGE cert_id cert_id INT UNSIGNED NOT NULL, CHANGE device_id device_id INT UNSIGNED NOT NULL, CHANGE tstamp tstamp TIMESTAMP NOT NULL COMMENT 'Timestamp of access', CHANGE status status INT NOT NULL COMMENT 'The HTTP status code of access', CHANGE traffic traffic INT UNSIGNED NOT NULL COMMENT 'Traffic of access in bytes'");
        $this->addSql("DROP INDEX fk_devices_profile_id ON devices");
        $this->addSql("ALTER TABLE devices CHANGE id id INT UNSIGNED AUTO_INCREMENT NOT NULL, CHANGE deviceid deviceid VARCHAR(50) DEFAULT NULL COMMENT 'The unique ID of this device (iPhone: serial-number, or a hash value for other devices)', CHANGE password password VARCHAR(80) DEFAULT NULL COMMENT 'The one-time activation password', CHANGE password_stamp password_stamp TIMESTAMP NOT NULL COMMENT 'Timestamp for password expiry', CHANGE comment comment VARCHAR(255) DEFAULT NULL COMMENT 'A comment without functional meaning', CHANGE os os INT UNSIGNED NOT NULL COMMENT 'Operating system: 0=iOS, 1=Other', CHANGE cert_id cert_id INT UNSIGNED DEFAULT NULL, CHANGE challenge challenge VARCHAR(255) DEFAULT NULL COMMENT 'The challenge to authenticate the user/device during the rollout process', CHANGE product product VARCHAR(64) DEFAULT NULL COMMENT 'The devices product name', CHANGE mdm_cert_id mdm_cert_id INT UNSIGNED DEFAULT NULL, CHANGE mdmtoken mdmtoken VARBINARY(255) DEFAULT NULL, CHANGE mdmpushmagic mdmpushmagic VARCHAR(255) DEFAULT NULL, CHANGE profile_id configgroup_id INT UNSIGNED DEFAULT NULL");

        $this->addSql("DROP TRIGGER bu_devices");
        $this->addSql("UPDATE devices SET user_id = NULL WHERE NOT EXISTS (SELECT 1 FROM users WHERE id = devices.user_id)");

        $this->addSql("ALTER TABLE devices ADD CONSTRAINT FK_11074E9AA76ED395 FOREIGN KEY (user_id) REFERENCES users (id)");
        $this->addSql("ALTER TABLE devices ADD CONSTRAINT FK_11074E9A81448FA9 FOREIGN KEY (cert_id) REFERENCES clientcerts (id)");
        $this->addSql("ALTER TABLE devices ADD CONSTRAINT FK_11074E9A15C91997 FOREIGN KEY (mdm_cert_id) REFERENCES clientcerts (id)");

        $this->addSql("ALTER TABLE reverseproxy_urls ADD visible TINYINT(1) DEFAULT '1' NOT NULL, CHANGE external_path_hash external_path_hash BINARY(20) NOT NULL");
        $this->addSql("ALTER TABLE users ADD configGroup_id INT UNSIGNED NOT NULL, CHANGE id id INT UNSIGNED AUTO_INCREMENT NOT NULL, CHANGE login login VARCHAR(50) NOT NULL COMMENT 'The unique login name', CHANGE realname realname VARCHAR(50) DEFAULT NULL COMMENT 'The real name', CHANGE email email VARCHAR(50) NOT NULL COMMENT 'The email address', CHANGE comment comment VARCHAR(255) DEFAULT NULL COMMENT 'A comment without functional meaning'");

        parent::up($schema);

        $this->addSql("ALTER TABLE devices ADD CONSTRAINT FK_11074E9AFF00FACA FOREIGN KEY (configgroup_id) REFERENCES configgroups (id)");
        $this->addSql("CREATE INDEX IDX_11074E9AA76ED395 ON devices (user_id)");
        $this->addSql("CREATE INDEX IDX_11074E9AFF00FACA ON devices (configgroup_id)");
        $this->addSql("ALTER TABLE access_cert_stat DROP FOREIGN KEY fk_access_cert_stat_device_id");
        $this->addSql("ALTER TABLE access_cert_stat CHANGE cert_id cert_id INT UNSIGNED NOT NULL, CHANGE device_id device_id INT UNSIGNED NOT NULL, CHANGE last_tstamp last_tstamp TIMESTAMP NOT NULL COMMENT 'Timestamp of last access'");
        $this->addSql("ALTER TABLE access_cert_stat ADD CONSTRAINT FK_1AA4E41994A4C7D4 FOREIGN KEY (device_id) REFERENCES devices (id)");
        $this->addSql("ALTER TABLE mdmcommands CHANGE id id BIGINT UNSIGNED AUTO_INCREMENT NOT NULL, CHANGE admin_id admin_id INT UNSIGNED DEFAULT NULL, CHANGE device_id device_id INT UNSIGNED DEFAULT NULL, CHANGE uuid uuid VARCHAR(255) NOT NULL COMMENT 'UUID of the MDM command', CHANGE status status VARCHAR(64) DEFAULT 'New' NOT NULL COMMENT 'The current status of the command', CHANGE response response TEXT DEFAULT NULL COMMENT 'The device response to the MDM command'");
        $this->addSql("ALTER TABLE mdmqueue DROP INDEX fk_mdmqueue_command, ADD UNIQUE INDEX UNIQ_5C80960F33E1689A (command_id)");
        $this->addSql("ALTER TABLE mdmqueue CHANGE id id BIGINT UNSIGNED AUTO_INCREMENT NOT NULL, CHANGE command_id command_id BIGINT UNSIGNED NOT NULL, CHANGE device_id device_id INT UNSIGNED NOT NULL");
        $this->addSql("ALTER TABLE profiles CHANGE id id INT UNSIGNED AUTO_INCREMENT NOT NULL, CHANGE name name VARCHAR(50) NOT NULL, CHANGE comment comment VARCHAR(255) DEFAULT NULL, CHANGE content content TEXT NOT NULL");

        $this->addSql("ALTER TABLE users ADD CONSTRAINT FK_1483A5E9676989C FOREIGN KEY (configGroup_id) REFERENCES configgroups (id)");
        $this->addSql("CREATE INDEX IDX_1483A5E9676989C ON users (configGroup_id)");
    }

    public function down(Schema $schema)
    {
        // this down() migration is autogenerated, please modify it to your needs
        $this->abortIf($this->connection->getDatabasePlatform()->getName() != "mysql");

        parent::down($schema);

        $this->addSql("ALTER TABLE configgroups_reverseproxyurls DROP FOREIGN KEY FK_75FFCB31FF00FACA");
        $this->addSql("ALTER TABLE devices DROP FOREIGN KEY FK_11074E9AFF00FACA");
        $this->addSql("ALTER TABLE users DROP FOREIGN KEY FK_1483A5E9676989C");

        $this->addSql("DROP TABLE configgroups");
        $this->addSql("DROP TABLE configgroups_reverseproxyurls");
        $this->addSql("ALTER TABLE access_cert_stat DROP FOREIGN KEY FK_1AA4E41994A4C7D4");
        $this->addSql("ALTER TABLE access_cert_stat CHANGE device_id device_id INT UNSIGNED DEFAULT NULL, CHANGE last_tstamp last_tstamp DATETIME DEFAULT CURRENT_TIMESTAMP NOT NULL COMMENT 'Timestamp of last access'");
        $this->addSql("ALTER TABLE access_cert_stat ADD CONSTRAINT fk_access_cert_stat_device_id FOREIGN KEY (device_id) REFERENCES devices (id) ON DELETE CASCADE");
        $this->addSql("ALTER TABLE access_stat_daily CHANGE traffic traffic BIGINT UNSIGNED DEFAULT NULL COMMENT 'Accrued traffic in bytes at that day', CHANGE access_count access_count INT UNSIGNED NOT NULL COMMENT 'Number of accesses in the period', CHANGE distinct_ips distinct_ips INT UNSIGNED NOT NULL COMMENT 'Number of different IPs in the period', CHANGE distinct_devices distinct_devices INT UNSIGNED NOT NULL COMMENT 'Number of different devices in the period'");
        $this->addSql("ALTER TABLE accesslog CHANGE id id INT UNSIGNED AUTO_INCREMENT NOT NULL COMMENT 'Primary key', CHANGE device_id device_id INT UNSIGNED DEFAULT NULL, CHANGE tstamp tstamp DATETIME DEFAULT '0000-00-00 00:00:00' NOT NULL COMMENT 'Timestamp of access', CHANGE status status INT DEFAULT 0 COMMENT 'HTTP status code of access', CHANGE traffic traffic INT DEFAULT 0 NOT NULL COMMENT 'Traffic of access in bytes'");
        $this->addSql("ALTER TABLE admins CHANGE level level INT UNSIGNED DEFAULT 0 COMMENT 'User level: 0=admin, 1=monitor', CHANGE login login VARCHAR(50) NOT NULL COMMENT 'The unique login name.', CHANGE pwhash pwhash VARCHAR(80) DEFAULT NULL COMMENT 'Password hash for GUI.', CHANGE davhash davhash VARCHAR(80) DEFAULT NULL COMMENT 'http password hash for WebDAV access.', CHANGE realname realname VARCHAR(50) DEFAULT NULL COMMENT 'The real name.'");
        $this->addSql("ALTER TABLE clientcerts CHANGE device_id device_id INT UNSIGNED NOT NULL, CHANGE cert cert VARCHAR(8192) DEFAULT NULL, CHANGE privatekey privatekey VARCHAR(8192) DEFAULT NULL");
        $this->addSql("DROP INDEX IDX_11074E9AA76ED395 ON devices");
        $this->addSql("DROP INDEX IDX_11074E9AFF00FACA ON devices");
        $this->addSql("ALTER TABLE devices ADD profile_id INT UNSIGNED DEFAULT NULL COMMENT 'Id of profile template', DROP configgroup_id, CHANGE deviceid deviceid VARCHAR(50) DEFAULT NULL COMMENT 'The unique ID of this device (iPhone: serial-number, or a hash value for other devices).', CHANGE password password VARCHAR(80) DEFAULT NULL COMMENT 'The one-time activation password.', CHANGE password_stamp password_stamp DATETIME DEFAULT CURRENT_TIMESTAMP NOT NULL COMMENT 'Timestamp for password expiry', CHANGE comment comment VARCHAR(255) DEFAULT NULL COMMENT 'A comment', CHANGE os os INT UNSIGNED DEFAULT 0 NOT NULL COMMENT 'Operating system: 0=iOS, 1=Android, 2=Windows', CHANGE challenge challenge VARCHAR(256) DEFAULT NULL COMMENT 'The challenge to authenticate the user/device during the rollout process', CHANGE product product VARCHAR(64) DEFAULT NULL COMMENT 'The device's product name', CHANGE mdmtoken mdmtoken LONGBLOB DEFAULT NULL, CHANGE mdmpushmagic mdmpushmagic VARCHAR(256) DEFAULT NULL");
        $this->addSql("CREATE INDEX fk_devices_profile_id ON devices (profile_id)");
        $this->addSql("ALTER TABLE mailaccounts DROP FOREIGN KEY FK_643DFEBE94A4C7D4");
        $this->addSql("ALTER TABLE mailaccounts CHANGE user user VARCHAR(255) NOT NULL COMMENT 'EMail Account Login user', CHANGE email email VARCHAR(255) NOT NULL COMMENT 'EMail Account email'");
        $this->addSql("ALTER TABLE mailaccounts ADD CONSTRAINT fk_mailaccounts_device_id FOREIGN KEY (device_id) REFERENCES devices (id) ON DELETE CASCADE");
        $this->addSql("ALTER TABLE mdmcommands CHANGE device_id device_id INT UNSIGNED NOT NULL COMMENT 'Id of the device the MDM command is bound for', CHANGE uuid uuid VARCHAR(256) NOT NULL COMMENT 'UUID of the MDM command', CHANGE status status VARCHAR(64) DEFAULT NULL COMMENT 'The current status of the command', CHANGE response response LONGTEXT DEFAULT NULL COMMENT 'The response to the MDM command'");
        $this->addSql("ALTER TABLE mdmqueue DROP INDEX UNIQ_5C80960F33E1689A, ADD INDEX fk_mdmqueue_command (command_id)");
        $this->addSql("ALTER TABLE reverseproxy_urls DROP visible, CHANGE external_path_hash external_path_hash LONGBLOB NOT NULL");
        $this->addSql("DROP INDEX IDX_1483A5E9676989C ON users");
        $this->addSql("ALTER TABLE users DROP configGroup_id, CHANGE login login VARCHAR(50) NOT NULL COMMENT 'The unique login name.', CHANGE realname realname VARCHAR(50) DEFAULT NULL COMMENT 'The real name.', CHANGE email email VARCHAR(50) DEFAULT NULL COMMENT 'The mail address.', CHANGE comment comment VARCHAR(255) DEFAULT NULL COMMENT 'A comment'");

        $this->addSql("RENAME TABLE reverseproxy_urls TO reverse_proxy_url");
    }
}
