<?php

namespace Application\Migrations;

use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version020400 extends AbstractMigration
{
    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        // this up() migration is auto-generated, please modify it to your needs
        $this->abortIf($this->connection->getDatabasePlatform()->getName() != 'mysql', 'Migration can only be executed safely on \'mysql\'.');

        $this->addSql('CREATE TABLE web_clips (id INT UNSIGNED AUTO_INCREMENT NOT NULL, url VARCHAR(255) NOT NULL, visible TINYINT(1) DEFAULT \'1\' NOT NULL, icon VARCHAR(4095) NOT NULL, name VARCHAR(255) NOT NULL, removable TINYINT(1) NOT NULL, precomposed TINYINT(1) NOT NULL, fullscreen TINYINT(1) NOT NULL, UNIQUE INDEX UNIQ_5661F7A5E237E06 (name), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB');
        $this->addSql('CREATE TABLE web_clip_config_group (web_clip_id INT UNSIGNED NOT NULL, config_group_id INT UNSIGNED NOT NULL, INDEX IDX_9C348C6BD6B6413B (web_clip_id), INDEX IDX_9C348C6B439C3799 (config_group_id), PRIMARY KEY(web_clip_id, config_group_id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB');
        $this->addSql('ALTER TABLE web_clip_config_group ADD CONSTRAINT FK_9C348C6BD6B6413B FOREIGN KEY (web_clip_id) REFERENCES web_clips (id) ON DELETE CASCADE');
        $this->addSql('ALTER TABLE web_clip_config_group ADD CONSTRAINT FK_9C348C6B439C3799 FOREIGN KEY (config_group_id) REFERENCES configgroups (id) ON DELETE CASCADE');
        $this->addSql('ALTER TABLE androidappstates ADD rejection_reason VARCHAR(255) DEFAULT NULL, CHANGE state state VARCHAR(255) NOT NULL, CHANGE rejected rejected SMALLINT NOT NULL');
        $this->addSql('ALTER TABLE iosappstates ADD rejection_reason VARCHAR(255) DEFAULT NULL, CHANGE state state VARCHAR(255) NOT NULL, CHANGE rejected rejected SMALLINT NOT NULL');
        $this->addSql('ALTER TABLE mdmcommands ADD copy_count SMALLINT UNSIGNED NOT NULL');
        $this->addSql('CREATE UNIQUE INDEX UNIQ_DDB61E0D5E237E06 ON reverseproxy_urls (name)');
        $this->addSql('ALTER TABLE syncml_commands ADD copy_count SMALLINT UNSIGNED NOT NULL');
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        // this down() migration is auto-generated, please modify it to your needs
        $this->abortIf($this->connection->getDatabasePlatform()->getName() != 'mysql', 'Migration can only be executed safely on \'mysql\'.');

        $this->addSql('ALTER TABLE web_clip_config_group DROP FOREIGN KEY FK_9C348C6BD6B6413B');
        $this->addSql('DROP TABLE web_clips');
        $this->addSql('DROP TABLE web_clip_config_group');
        $this->addSql('ALTER TABLE androidappstates DROP rejection_reason, CHANGE state state VARCHAR(255) DEFAULT NULL COLLATE utf8_unicode_ci, CHANGE rejected rejected TINYINT(1) NOT NULL');
        $this->addSql('ALTER TABLE iosappstates DROP rejection_reason, CHANGE state state VARCHAR(255) DEFAULT NULL COLLATE utf8_unicode_ci, CHANGE rejected rejected TINYINT(1) NOT NULL');
        $this->addSql('ALTER TABLE mdmcommands DROP copy_count');
        $this->addSql('DROP INDEX UNIQ_DDB61E0D5E237E06 ON reverseproxy_urls');
        $this->addSql('ALTER TABLE syncml_commands DROP copy_count');
    }
}
