<?php

namespace Application\Migrations;

use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version020500 extends AbstractMigration
{
    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        // this up() migration is auto-generated, please modify it to your needs
        $this->abortIf($this->connection->getDatabasePlatform()->getName() != 'mysql', 'Migration can only be executed safely on \'mysql\'.');

        $this->addSql('CREATE TABLE vpp_licenses (id INT UNSIGNED AUTO_INCREMENT NOT NULL, app_id INT UNSIGNED DEFAULT NULL, user_id INT UNSIGNED DEFAULT NULL, license_id INT NOT NULL, status VARCHAR(255) NOT NULL, INDEX IDX_F326BE17987212D (app_id), INDEX IDX_F326BE1A76ED395 (user_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB');
        $this->addSql('CREATE TABLE compliance_rules (id INT UNSIGNED AUTO_INCREMENT NOT NULL, compliance_id INT UNSIGNED NOT NULL, os VARCHAR(255) DEFAULT NULL, type VARCHAR(255) NOT NULL, rule_condition VARCHAR(1023) NOT NULL, last_condition_change INT UNSIGNED NOT NULL, INDEX IDX_F298DBFDAA24AB19 (compliance_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB');
        $this->addSql('CREATE TABLE compliances (id INT UNSIGNED AUTO_INCREMENT NOT NULL, win_phone_app_policy_id INT UNSIGNED DEFAULT NULL, name VARCHAR(255) NOT NULL, description VARCHAR(255) NOT NULL, actions TEXT DEFAULT NULL COMMENT \'(DC2Type:json_array)\', check_interval INT UNSIGNED NOT NULL, job_id BIGINT UNSIGNED DEFAULT NULL, last_rule_change INT UNSIGNED DEFAULT NULL, UNIQUE INDEX UNIQ_47085985E237E06 (name), UNIQUE INDEX UNIQ_4708598595D65AE (win_phone_app_policy_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB');
        $this->addSql('CREATE TABLE compliances_configgroups (compliance_id INT UNSIGNED NOT NULL, group_id INT UNSIGNED NOT NULL, INDEX IDX_DCE05FDCAA24AB19 (compliance_id), INDEX IDX_DCE05FDCFE54D947 (group_id), PRIMARY KEY(compliance_id, group_id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB');
        $this->addSql('CREATE TABLE compliance_rule_validations (id BIGINT UNSIGNED AUTO_INCREMENT NOT NULL, device_id INT UNSIGNED NOT NULL, rule_id INT UNSIGNED NOT NULL, last_check_time INT UNSIGNED NOT NULL, violation_time INT UNSIGNED DEFAULT NULL, violated TINYINT(1) NOT NULL, parameters TEXT NOT NULL COMMENT \'(DC2Type:json_array)\', INDEX IDX_858C14B294A4C7D4 (device_id), INDEX IDX_858C14B2744E0351 (rule_id), UNIQUE INDEX validation_result_unique (device_id, rule_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB');
        $this->addSql('CREATE TABLE compliance_device_actions (id INT UNSIGNED AUTO_INCREMENT NOT NULL, device_id INT UNSIGNED NOT NULL, action VARCHAR(255) NOT NULL, time INT UNSIGNED DEFAULT NULL, performed TINYINT(1) NOT NULL, INDEX IDX_BD8016C294A4C7D4 (device_id), INDEX IDX_BD8016C26F949845 (time), UNIQUE INDEX UNIQ_BD8016C294A4C7D447CC8C92 (device_id, action), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB');
        $this->addSql('ALTER TABLE compliance_device_actions ADD CONSTRAINT FK_BD8016C294A4C7D4 FOREIGN KEY (device_id) REFERENCES devices (id) ON DELETE CASCADE');
        $this->addSql('ALTER TABLE vpp_licenses ADD CONSTRAINT FK_F326BE17987212D FOREIGN KEY (app_id) REFERENCES iosapps (id)');
        $this->addSql('ALTER TABLE vpp_licenses ADD CONSTRAINT FK_F326BE1A76ED395 FOREIGN KEY (user_id) REFERENCES users (id)');
        $this->addSql('ALTER TABLE compliance_rules ADD CONSTRAINT FK_F298DBFDAA24AB19 FOREIGN KEY (compliance_id) REFERENCES compliances (id) ON DELETE CASCADE');
        $this->addSql('ALTER TABLE compliances ADD CONSTRAINT FK_4708598595D65AE FOREIGN KEY (win_phone_app_policy_id) REFERENCES win_phone_app_policy (id) ON DELETE SET NULL');
        $this->addSql('ALTER TABLE compliances_configgroups ADD CONSTRAINT FK_DCE05FDCAA24AB19 FOREIGN KEY (compliance_id) REFERENCES compliances (id) ON DELETE CASCADE');
        $this->addSql('ALTER TABLE compliances_configgroups ADD CONSTRAINT FK_DCE05FDCFE54D947 FOREIGN KEY (group_id) REFERENCES configgroups (id) ON DELETE CASCADE');
        $this->addSql('ALTER TABLE compliance_rule_validations ADD CONSTRAINT FK_858C14B294A4C7D4 FOREIGN KEY (device_id) REFERENCES devices (id) ON DELETE CASCADE');
        $this->addSql('ALTER TABLE compliance_rule_validations ADD CONSTRAINT FK_858C14B2744E0351 FOREIGN KEY (rule_id) REFERENCES compliance_rules (id) ON DELETE CASCADE');
        $this->addSql('ALTER TABLE iosappstates ADD vpp_license_id INT UNSIGNED DEFAULT NULL');
        $this->addSql('ALTER TABLE iosappstates ADD CONSTRAINT FK_9B5CCE21136BAD9B FOREIGN KEY (vpp_license_id) REFERENCES vpp_licenses (id)');
        $this->addSql('CREATE INDEX IDX_9B5CCE21136BAD9B ON iosappstates (vpp_license_id)');
        $this->addSql('ALTER TABLE iosapps ADD use_vpp TINYINT(1) DEFAULT \'0\' NOT NULL');
        $this->addSql('CREATE INDEX managed_idx ON iosapps (managed)');
        $this->addSql('ALTER TABLE devices ADD active_sync_disabled TINYINT(1) NOT NULL, ADD last_compliance_check INT UNSIGNED DEFAULT NULL, ADD locale VARCHAR(255) DEFAULT NULL, ADD last_access INT UNSIGNED DEFAULT NULL, ADD flags INT NOT NULL, DROP timedout');
        $this->addSql('ALTER TABLE users ADD vpp_user_id INT DEFAULT NULL, ADD vpp_status VARCHAR(255) DEFAULT \'unregistered\', ADD vpp_invite_link VARCHAR(255) DEFAULT NULL');
        $this->addSql('CREATE UNIQUE INDEX UNIQ_1483A5E9CDFE8290 ON users (vpp_user_id)');
        $this->addSql('ALTER TABLE reverseproxy_urls ADD use_remote_proxy TINYINT(1) NOT NULL');
        $this->addSql('DROP INDEX UNIQ_372191145E237E06 ON win_phone_app_policy');
        $this->addSql('ALTER TABLE win_phone_app_policy DROP name');
        $this->createGroupCompliances();
        $this->addSql('ALTER TABLE configgroups DROP FOREIGN KEY FK_C77887AC595D65AE');
        $this->addSql('DROP INDEX IDX_C77887AC595D65AE ON configgroups');
        $this->addSql('ALTER TABLE configgroups DROP win_phone_app_policy_id, DROP device_timeout');
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        // this down() migration is auto-generated, please modify it to your needs
        $this->abortIf($this->connection->getDatabasePlatform()->getName() != 'mysql', 'Migration can only be executed safely on \'mysql\'.');

        $this->addSql('ALTER TABLE iosappstates DROP FOREIGN KEY FK_9B5CCE21136BAD9B');
        $this->addSql('ALTER TABLE compliance_rule_validations DROP FOREIGN KEY FK_858C14B2744E0351');
        $this->addSql('ALTER TABLE compliance_rules DROP FOREIGN KEY FK_F298DBFDAA24AB19');
        $this->addSql('ALTER TABLE compliances_configgroups DROP FOREIGN KEY FK_DCE05FDCAA24AB19');
        $this->addSql('DROP TABLE vpp_licenses');
        $this->addSql('DROP TABLE compliance_device_actions');
        $this->addSql('DROP TABLE compliance_rules');
        $this->addSql('DROP TABLE compliances');
        $this->addSql('DROP TABLE compliances_configgroups');
        $this->addSql('DROP TABLE compliance_rule_validations');
        $this->addSql('ALTER TABLE configgroups ADD win_phone_app_policy_id INT UNSIGNED DEFAULT NULL, ADD device_timeout INT UNSIGNED NOT NULL');
        $this->addSql('ALTER TABLE configgroups ADD CONSTRAINT FK_C77887AC595D65AE FOREIGN KEY (win_phone_app_policy_id) REFERENCES win_phone_app_policy (id)');
        $this->addSql('CREATE INDEX IDX_C77887AC595D65AE ON configgroups (win_phone_app_policy_id)');
        $this->addSql('ALTER TABLE devices ADD timedout TINYINT(1) NOT NULL, DROP active_sync_disabled, DROP last_compliance_check, DROP locale, DROP last_access, DROP flags');
        $this->addSql('DROP INDEX managed_idx ON iosapps');
        $this->addSql('ALTER TABLE iosapps DROP use_vpp');
        $this->addSql('DROP INDEX IDX_9B5CCE21136BAD9B ON iosappstates');
        $this->addSql('ALTER TABLE iosappstates DROP vpp_license_id');
        $this->addSql('DROP INDEX UNIQ_1483A5E9CDFE8290 ON users');
        $this->addSql('ALTER TABLE users DROP vpp_user_id, DROP vpp_status, DROP vpp_invite_link');
        $this->addSql('ALTER TABLE win_phone_app_policy ADD name VARCHAR(255) NOT NULL COLLATE utf8_unicode_ci');
        $this->addSql('CREATE UNIQUE INDEX UNIQ_372191145E237E06 ON win_phone_app_policy (name)');
        $this->addSql('ALTER TABLE reverseproxy_urls DROP use_remote_proxy');
    }

    private function createGroupCompliances()
    {
        $usedAppPolicies = array();
        $i = 1;
        $stmt = $this->connection->prepare("SELECT id, name, device_timeout, win_phone_app_policy_id FROM configgroups WHERE device_timeout > 0 OR win_phone_app_policy_id IS NOT NULL");
        $stmt->execute();
        while (false !== ($row = $stmt->fetch(\PDO::FETCH_ASSOC))) {
            // ensure that every app policy is only used once
            $appPolicyId = $row['win_phone_app_policy_id'];
            if (null !== $appPolicyId && in_array($appPolicyId, $usedAppPolicies)) {
                $appPolicyId = $this->connection->fetchColumn("SELECT AUTO_INCREMENT FROM information_schema.tables WHERE table_name = 'win_phone_app_policy' AND table_schema = DATABASE()");
                $this->addSql('INSERT INTO win_phone_app_policy (type, policy) SELECT type, policy FROM win_phone_app_policy');
            } else {
                $usedAppPolicies[] = $appPolicyId;
            }
            $now = time();
            $this->addSql('INSERT INTO compliances (id, name, description, win_phone_app_policy_id, actions, check_interval, last_rule_change) VALUES (:id, :name, :description, :win_phone_app_policy_id, :actions, :check_interval, :last_rule_change)', array(
                "id"                      => $i,
                "name"                    => $row['name'],
                "description"             => "Automatically created for group \"" . $row['name'] . "\"",
                "win_phone_app_policy_id" => $appPolicyId,
                "actions"                 => json_encode(array("sendAdminMail" => array())),
                "check_interval"          => 12 * 3600, // twice per day
                "last_rule_change"        => $now,
            ));

            $this->addSql('INSERT INTO compliances_configgroups VALUES(:compliance_id, :group_id)', array(
                "compliance_id" => $i,
                "group_id"      => $row['id'],
            ));

            if ($row['device_timeout'] > 0) {
                $this->addSql('INSERT INTO compliance_rules (compliance_id, type, rule_condition, last_condition_change) VALUES (:compliance_id, :type, :rule_condition, :last_condition_change)', array(
                    "compliance_id"         => $i,
                    "type"                  => "timeout",
                    "rule_condition"        => $row['device_timeout'],
                    "last_condition_change" => $now,
                ));
            }

            $i++;
        }
    }
}
