<?php
/**
 * MDM Push message.
 *
 * @author Dominic Tubach <dominic.tubach@topalis.com>
 */
class ApnsPHP_MdmMessage extends ApnsPHP_Message {
    const APPLE_RESERVED_NAMESPACE = 'mdm';

    /**
     * Get the payload dictionary.
     *
     * @return @type array The payload dictionary.
     */
    protected function _getPayload() {
        $aPayload[self::APPLE_RESERVED_NAMESPACE] = (string) $this->_sText;
        if (is_array($this->_aCustomProperties)) {
            foreach ($this->_aCustomProperties as $sPropertyName => $mPropertyValue) {
                $aPayload[$sPropertyName] = $mPropertyValue;
            }
        }
        return $aPayload;
    }
}