<?php
namespace Topalis\ActiveSyncFilter\Command;

use Symfony\Bundle\FrameworkBundle\Command\ContainerAwareCommand;

class FilterServerStatusCommand extends ContainerAwareCommand
{
    /**
     * @return \Topalis\ActiveSyncFilter\FilterServer
     */
    private function getFilterServer()
    {
        return $this->getContainer()->get("asf.filter_server");
    }

    protected function configure()
    {
        $this
        ->setName("filterserver:status")
        ->setDescription("Check status of the ActiveSync Filter Server.")
        ->setHelp("Check status of the ActiveSync Filter Server. Returns 0 if reachable.");
    }

    protected function execute(\Symfony\Component\Console\Input\InputInterface $input,
        \Symfony\Component\Console\Output\OutputInterface $output)
    {
        $input; // unused

        if ($this->getFilterServer()->isReachable()) {
            $output->writeln("reachable");
            return 0;
        }

        $output->writeln("not reachable");
        return 1;
    }
}
