<?php
namespace \Topalis\ActiveSyncFilter\Config\Form;

class FormGlobalConfig
{
    /**
     * @var \Topalis\ActiveSyncFilter\Apache\ASFApacheMod
     */
    private $apacheMod;

    /**
     * @var \Topalis\ActiveSyncFilter\Apache\ModConfig
     */
    private $apacheModConfig;

    /**
     * @param \Topalis\ActiveSyncFilter\Apache\ASFApacheMod $apacheMod
     */
    public function __construct(\Topalis\ActiveSyncFilter\Apache\ASFApacheMod $apacheMod)
    {
        $this->apacheMod = $apacheMod;
        $this->apacheModConfig = $apacheMod->getConfig();
    }

    /**
     * Save form.
     */
    public function save()
    {
        $this->apacheMod->enable($this->apacheModConfig);
    }

    /**
     * @param integer $minWbxmlLen
     */
    public function setMinWbxmlLen($minWbxmlLen)
    {
        $this->apacheModConfig->setMinWbxmlLen($minWbxmlLen);
    }

    /**
     * @return integer
     */
    public function getMinWbxmlLen()
    {
        return $this->apacheModConfig->getMinWbxmlLen();
    }
}
