<?php
namespace Topalis\ActiveSyncFilter\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * AsfConfPlugin
 *
 * @ORM\Table(name="asf_conf_plugin")
 * @ORM\Entity
 */
class AsfConfPlugin
{
    /**
     * @var integer
     *
     * @ORM\Column(name="configid", type="integer", nullable=false)
     * @ORM\Id
     */
    private $configId;

    /**
     * @var string
     *
     * @ORM\Column(name="key", type="string", length=255, nullable=false)
     * @ORM\Id
     */
    private $key;

    /**
     * @var string
     *
     * @ORM\Column(name="pluginkey", type="string", length=255, nullable=false)
     * @ORM\Id
     */
    private $pluginKey;

    /**
     * @var string
     *
     * @ORM\Column(name="value", type="string", length=255, nullable=true)
     */
    private $value;

    /**
     * @return integer The configuration id.
     */
    public function getConfigId()
    {
        return $this->configId;
    }

    /**
     * Get key
     *
     * @return string
     */
    public function getKey()
    {
        return $this->key;
    }

    /**
     * @return string The plugin key.
     */
    public function getPluginKey()
    {
        return $this->pluginKey;
    }

    /**
     * Set value
     *
     * @param string $value
     * @return AsfPluginImagecompressor
     */
    public function setValue($value)
    {
        $this->value = $value;

        return $this;
    }

    /**
     * Get value
     *
     * @return string
     */
    public function getValue()
    {
        return $this->value;
    }
}
