<?php
namespace Topalis\ActiveSyncFilter\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * AsfConfPlugins
 *
 * @ORM\Table(name="asf_conf_plugins")
 * @ORM\Entity
 */
class AsfConfPlugins
{
    /**
     * @var integer
     *
     * @ORM\Column(name="configid", type="integer", nullable=false)
     * @ORM\Id
     */
    private $configId;

    /**
     * @var string
     *
     * @ORM\Column(name="key", type="string", length=255, nullable=false)
     * @ORM\Id
     */
    private $key;

    /**
     * @var string
     *
     * @ORM\Column(name="enabled", type="string", length=255, nullable=true)
     */
    private $enabled;

    /**
     * @return integer The configuration id.
     */
    public function getConfigId()
    {
        return $this->configId;
    }

    /**
     * Get key
     *
     * @return string
     */
    public function getKey()
    {
        return $this->key;
    }

    /**
     * Set enabled
     *
     * @param string $enabled
     * @return AsfConfPlugins
     */
    public function setEnabled($enabled)
    {
        $this->enabled = $enabled;

        return $this;
    }

    /**
     * Get enabled
     *
     * @return string
     */
    public function getEnabled()
    {
        return $this->enabled;
    }
}
