<?php
namespace Topalis\ActiveSyncFilter\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;
use Topalis\ActiveSyncFilter\Form\Extension\Type\PluginType;

/**
 * Form for active sync filter configuration
 * @author Florian Pfitzer <florian.pfitzer@topalis.com>
 */
class ASFConfigForm extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $options; // unused
        $builder
            ->add("errorBehavior", "choice", array(
                "label" => "admin.asf.errorBehavior",
                "choices" => array(
                    "IGNORE" => "admin.asf.ignore",
                    "REMOVE" => "admin.asf.remove",
                    "HALT" => "admin.asf.halt"
                ),
                "help" => "admin.asf.errorDescription"
            ))
            ->add("removeUnfiltered", "checkbox", array(
                "label" => "admin.asf.removeUnfiltered",
                "required" => false,
            ))
            ->add("mimeTypes", "mime_type", array(
                "required" => false,
                "error_bubbling" => false, // show errors at the this field
            ))
            ->add("plugins", "collection", array(
                "type" => new PluginType()
            ))
        ;
    }

    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver
            ->setDefaults(array(
                "data_class" => "Topalis\ActiveSyncFilter\Config\Form\FormConfig"
            ))
        ;
    }

    /**
     * Returns the name of this type.
     * @return string The name of this type
     */
    public function getName()
    {
        return "asf";
    }
}
