<?php
namespace Topalis\ActiveSyncFilter\Form\Extension\EventListener;

use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use Symfony\Component\Form\Exception\UnexpectedTypeException;
use Symfony\Component\Form\FormEvent;
use Symfony\Component\Form\FormEvents;

/**
 * @author Florian Pfitzer <florian.pfitzer@topalis.com>
 */
class ConfigKeyFixListener implements EventSubscriberInterface
{
    public static function getSubscribedEvents()
    {
        return array(
            FormEvents::PRE_SET_DATA => array("setData", 10) // must be called before collection resize listener
        );
    }

    public function setData(FormEvent $event)
    {
        $data = $event->getData();

        if (null === $data) {
            return null;
        }

        if (!is_array($data)) {
            throw new UnexpectedTypeException($data, "array");
        }

        $output = array();
        foreach ($data as $key => $entry) {
            $key = str_replace(" ", "___", $key);
            $key = str_replace(".", "::", $key);
            $output[$key] = $entry;
        }

        $event->setData($output);

    }
}
