<?php
namespace Topalis\ActiveSyncFilter\Form\Extension\Type;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;
use Topalis\ActiveSyncFilter\Form\Extension\EventListener\ConfigEntryListener;

/**
 * @author Florian Pfitzer <florian.pfitzer@topalis.com>
 */
class ConfigEntryType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $options; // unused
        $builder
            ->addEventSubscriber(new ConfigEntryListener($builder->getFormFactory()))
        ;
    }

    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver
            ->setDefaults(array(
                "data_class" => "Topalis\ActiveSyncFilter\Config\Form\FormConfigEntry"
            ))
        ;
    }

    /**
     * Returns the name of this type.
     * @return string The name of this type
     */
    public function getName()
    {
        return "config_entry";
    }
}
