<?php
namespace Topalis\Apache\DependencyInjection;

use Symfony\Component\Config\Definition\Builder\TreeBuilder;
use Symfony\Component\Config\Definition\ConfigurationInterface;

/**
 *
 *
 * @author Dominic Tubach <dominic.tubach@topalis.com>
 */
class Configuration implements ConfigurationInterface
{

    /**
     * Generates the configuration tree builder.
     *
     * @return \Symfony\Component\Config\Definition\Builder\TreeBuilder The tree builder
     */
    public function getConfigTreeBuilder()
    {
        $treeBuilder = new TreeBuilder();
        $rootNode = $treeBuilder->root("apache");

        if (is_dir("/etc/apache2")) {
            $defaultHttpdConfDir = "/etc/apache2";
        } else {
            $defaultHttpdConfDir = "/etc/httpd";
        }

        $rootNode->children()
            ->arrayNode("config")->addDefaultsIfNotSet()->children()
                ->arrayNode("dir")->addDefaultsIfNotSet()->children()
                    ->scalarNode("base")->isRequired()->defaultValue($defaultHttpdConfDir)->end()
                    ->scalarNode("auralis")->isRequired()->defaultValue("auralis.d")->end()
                ->end()
            ->end()
        ->end();

        return $treeBuilder;
    }
}
