<?php
namespace Topalis\Apns;

use Topalis\Device\Entity\Device;

class AuralisMdmMessage extends \ApnsPHP_MdmMessage
{
    private $deviceId;

    public function __construct(Device $device)
    {
        parent::__construct($device->getMdmToken());
        // don't store the device because the message is written into shared
        // memory which leads to exeptions
        $this->deviceId = $device->getId();
        $this->setText($device->getMdmPushMagic());
        $this->setCustomIdentifier("auralismdm-" . $this->getDeviceId());
    }

    public function getDeviceId()
    {
        return $this->deviceId;
    }
}
