<?php
namespace Topalis\Apns\DependencyInjection;

use Symfony\Component\Config\Definition\Builder\TreeBuilder;
use Symfony\Component\Config\Definition\ConfigurationInterface;

/**
 *
 *
 * @author Dominic Tubach <dominic.tubach@topalis.com>
 */
class Configuration implements ConfigurationInterface
{

    /**
     * Generates the configuration tree builder.
     *
     * @return \Symfony\Component\Config\Definition\Builder\TreeBuilder The tree builder
     */
    public function getConfigTreeBuilder()
    {
        $treeBuilder = new TreeBuilder();
        $rootNode = $treeBuilder->root('apns');
        $rootNode->children()
            ->scalarNode("is_development")->defaultValue(false)->end()
        ->end();

        return $treeBuilder;
    }
}
