<?php
namespace Topalis\App;

use Topalis\App\Entity\App;

/**
 *
 *
 * @author Florian Pfitzer <pfitzer@w3p.cc>
 */
interface AppStore
{

    /**
     * Sync apps with store data
     * @param App[] $apps
     */
    public function refreshApps(array $apps);

    /**
     * Searches an app by its identifier.
     *
     * @param string $identifier
     *
     * @return App|null The found app, or null if no app was found.
     */
    public function lookupByIdentifier($identifier);

    /**
     * @param string $term search term
     *
     * @return App[] found apps
     */
    public function search($term);
}
