<?php
namespace Topalis\App\DependencyInjection\Compiler;

use Symfony\Component\DependencyInjection\Compiler\CompilerPassInterface;
use Symfony\Component\DependencyInjection\ContainerBuilder;
use Symfony\Component\DependencyInjection\Reference;

/**
 * Collect services with the tag app.mdm_admin and add them to the AppMdmAdminRegistry
 *
 * @author Florian Pfitzer <pfitzer@w3p.cc>
 */
class AppMdmAdminPass implements CompilerPassInterface
{
    public function process(ContainerBuilder $container)
    {
        if (!$container->hasDefinition("app.mdm_admin.registry")) {
            return;
        }
        $admins = array();
        foreach (array_keys($container->findTaggedServiceIds("app.mdm_admin")) as $serviceId) {
            $admins[] = new Reference($serviceId);
        }

        $container
            ->getDefinition("app.mdm_admin.registry")
            ->replaceArgument(0, $admins)
        ;
    }
}
