<?php
namespace Topalis\App\DependencyInjection;

use Symfony\Component\Config\Definition\Builder\TreeBuilder;
use Symfony\Component\Config\Definition\ConfigurationInterface;

/**
 * @author Florian Pfitzer<pfitzer@w3p.cc>
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class Configuration implements ConfigurationInterface
{

    /**
     * Generates the configuration tree builder.
     *
     * @return \Symfony\Component\Config\Definition\Builder\TreeBuilder The tree builder
     */
    public function getConfigTreeBuilder()
    {
        $treeBuilder = new TreeBuilder();
        $rootNode = $treeBuilder->root("app");
        $rootNode
            ->children()
                ->arrayNode("vpp")->addDefaultsIfNotSet()->children()
                    ->arrayNode("token")->addDefaultsIfNotSet()->children()
                        ->arrayNode("expire_warn_days")
                            ->prototype("integer")->end()->defaultValue(array(60, 30, 15, 7))
                        ->end()
                    ->end()
                ->end()
            ->end()
        ;


        return $treeBuilder;
    }
}
