<?php
namespace Topalis\App\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 *
 *
 * @author Florian Pfitzer <pfitzer@w3p.cc>
 */
abstract class MdmAppState extends AppState
{
    /**
     *
     * @var \Topalis\MDM\Entity\MdmCommand
     * @ORM\OneToOne(targetEntity="Topalis\MDM\Entity\MdmCommand", cascade={"persist"})
     */
    protected $installCommand;

    /**
     *
     * @var \Topalis\MDM\Entity\MdmCommand
     * @ORM\OneToOne(targetEntity="Topalis\MDM\Entity\MdmCommand", cascade={"persist"})
     */
    protected $removeCommand;

    /**
     * @var integer
     * @ORM\Column(type="integer")
     */
    protected $installAttempts = 0;

    /**
     * @var \Datetime
     * @ORM\Column(type="datetime", nullable=true)
     */
    protected $lastInstallAttempt;

    /**
     * @return \Topalis\MDM\Entity\MdmCommand
     */
    public function getInstallCommand()
    {
        return $this->installCommand;
    }

    /**
     * @param \Topalis\MDM\Entity\MdmCommand $installCommand
     *
     * @return $this
     */
    public function setInstallCommand(\Topalis\MDM\Entity\MdmCommand $installCommand)
    {
        $this->installCommand = $installCommand;

        return $this;
    }

    /**
     * @return \Topalis\MDM\Entity\MdmCommand
     */
    public function getRemoveCommand()
    {
        return $this->removeCommand;
    }

    /**
     * @param \Topalis\MDM\Entity\MdmCommand $removeCommand
     *
     * @return $this
     */
    public function setRemoveCommand(\Topalis\MDM\Entity\MdmCommand $removeCommand)
    {
        $this->removeCommand = $removeCommand;

        return $this;
    }

    /**
     * @param int $installAttempts
     *
     * @return MdmAppState $this
     */
    public function setInstallAttempts($installAttempts)
    {
        $this->installAttempts = $installAttempts;

        return $this;
    }

    /**
     * @return int
     */
    public function getInstallAttempts()
    {
        return $this->installAttempts;
    }

    /**
     * Add one install attempt
     *
     * @return $this
     */
    public function addInstallAttempt()
    {
        $this->installAttempts++;

        return $this;
    }

    /**
     * @return \Datetime
     */
    public function getLastInstallAttempt()
    {
        return $this->lastInstallAttempt;
    }

    /**
     * @param \Datetime $lastInstallAttempt
     *
     * @return self
     */
    public function setLastInstallAttempt(\DateTime $lastInstallAttempt)
    {
        $this->lastInstallAttempt = $lastInstallAttempt;

        return $this;
    }

}
