<?php
namespace Topalis\App\EventListener\ORM;

use Doctrine\ORM\Event\LifecycleEventArgs;
use Topalis\App\Android\GooglePlayStore;
use Topalis\App\Entity\AndroidApp;

/**
 * Mark system android system apps
 *
 * @author Florian Pfitzer <pfitzer@w3p.cc>
 */
class AndroidSystemEventListener
{

    /**
     * @var GooglePlayStore
     */
    private $playStore;

    /**
     * @param GooglePlayStore $playStore
     */
    public function __construct(GooglePlayStore $playStore)
    {
        $this->playStore = $playStore;
    }

    public function prePersist(LifecycleEventArgs $eventArgs)
    {
        $app = $eventArgs->getEntity();
        if (!$app instanceof AndroidApp) {
            return;
        }
        $app->setSystem($this->playStore->isSystemApp($app));
    }

    public function preUpdate(LifecycleEventArgs $eventArgs)
    {
        $app = $eventArgs->getEntity();
        if (!$app instanceof AndroidApp) {
            return;
        }
        $app->setSystem($this->playStore->isSystemApp($app));
    }
}
