<?php
namespace Topalis\App\Exception;

use Buzz\Message\Request;
use Buzz\Message\Response;

/**
 * Exception if the HTTP status code of the VPP service response is not between
 * 200 and 299.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class VppResponseException extends VppException
{
    /**
     * @var \Buzz\Message\Request
     */
    private $request;

    /**
     * @var \Buzz\Message\Response
     */
    private $response;

    public function __construct(Request $request, Response $response, $message = null, $code = null, $previous = null)
    {
        parent::__construct($message, $code, $previous);
        $this->request = $request;
        $this->response = $response;
    }

    /**
     * @return \Buzz\Message\Request
     */
    public function getRequest()
    {
        return $this->request;
    }

    /**
     * @return \Buzz\Message\Response
     */
    public function getResponse()
    {
        return $this->response;
    }
}
