<?php
namespace Topalis\App\Job;

use Topalis\App\Entity\IosAppState;
use Topalis\Kernel\Job\AbstractDeferredQueue;

/**
 * VppAssociateQueue puts jobs to associate or disassociate VPP licenses.
 *
 * @author Florian Pfitzer <pfitzer@w3p.cc>
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class VppAssociateQueue extends AbstractDeferredQueue
{
    public function associate(IosAppState $appState)
    {
        $this->putDeferred(
            array(
                "action"    => "associate",
                "appState"  => $appState->getId(),
            )
        );
    }

    public function disassociate(IosAppState $appState)
    {
        $this->putDeferred(
            array(
                "action"    => "disassociate",
                "appState"  => $appState->getId(),
            )
        );
    }
}
