<?php
namespace Topalis\CLI;

use Symfony\Bundle\FrameworkBundle\Console\Application;

class SingleCommandApplication extends Application
{
    private $commandName;

    public function __construct($commandName, $kernel)
    {
        $this->commandName = $commandName;
        parent::__construct($kernel);
    }

    /**
     * Gets the name of the command based on input.
     *
     * @param \Symfony\Component\Console\Input\InputInterface $input The input interface
     *
     * @return string The command name
     */
    protected function getCommandName(\Symfony\Component\Console\Input\InputInterface $input)
    {
        $input; // unused
        // This should return the name of your command.
        return $this->commandName;
    }

    /**
     * Overridden so that the application doesn't expect the command
     * name to be the first argument.
     */
    public function getDefinition()
    {
        $inputDefinition = parent::getDefinition();
        // clear out the normal first argument, which is the command name
        $inputDefinition->setArguments();

        return $inputDefinition;
    }
}
