<?php
namespace Topalis\Certificate\Form;

use Symfony\Component\Form\FormBuilderInterface;

/**
 * Extends Certifcate form with push cert specific fields
 *
 * @author Florian Pfitzer <florian.pfitzer@to.com>
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class PushCertForm extends CertForm
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        parent::buildForm($builder, $options);
        $builder->remove("commonName");
        $builder
            ->add("firstname", "text", array(
                "label" => "admin.cert.firstname"
            ))
            ->add("lastname", "text", array(
                "label" => "admin.cert.lastname"
            ))
            ->add("zipCode", "text", array(
                "label" => "admin.cert.zipCode"
            ))
            ->add("street", "text", array(
                "label" => "admin.cert.street"
            ))
            ->add("houseNo", "text", array(
                "label" => "admin.cert.houseNo"
            ))
            ->add("phone", "text", array(
                "label" => "admin.cert.phone"
            ))
        ;
    }

}
