<?php
namespace Topalis\Certificate\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Validator\Constraints\File;
use Topalis\Certificate\Validator\PushCertificate;

/**
 * Upload form for push certs
 * @author Florian Pfitzer <florian.pfitzer@topalis.com>
 */
class PushCertUploadForm extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $options; // unused
        $builder
            ->add("file", "file", array(
                "label" => "admin.cert.push.file",
                "constraints" => array(new File(), new PushCertificate())
            ))
        ;
    }

    /**
     * Returns the name of this type.
     * @return string The name of this type
     */
    public function getName()
    {
        return "push_cert_upload";
    }
}
