<?php
namespace Topalis\Certificate\Validator;

use Symfony\Component\Validator\Constraint;
use Symfony\Component\Validator\ConstraintValidator;
use Symfony\Component\Validator\Exception\UnexpectedTypeException;

/**
 * Ascii content validator
 * @author Florian Pfitzer <florian.pfitzer@topalis.com>
 */
class CertificateFieldValidator extends ConstraintValidator
{
    public function validate($value, Constraint $constraint)
    {
        /** @var $constraint CertificateField */
        if (null === $value || '' === $value) {
            return;
        }

        if (!is_string($value)) {
            throw new UnexpectedTypeException($value, "string");
        }

        if (preg_match("/[^A-Za-z0-9.\-_\* ]/si", $value)) {
            $this->context->addViolation($constraint->message);
        }

    }

}
