<?php
namespace Topalis\Compliance\Action;

/**
 * This class represents the result of a compliance action.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class ComplianceActionResult
{
    /**
     * true if the action has been performed, false otherwise.
     *
     * @var bool
     */
    public $performed;

    /**
     * UNIX timestamp depending on the performance status of the action: The
     * time the action has been performed, the time the action is planned to be
     * performed, or null if the action has not been performed and is not
     * planned to be performed.
     *
     * @var int
     */
    public $time;

    /**
     * Constructor.
     *
     * @param bool $performed true if the action has been performed, false otherwise.
     * @param int $time UNIX timestamp depending on the performance status of
     *    the action: The time the action has been performed, the time the
     *    action is planned to be performed, or null if the action has not been
     *    performed and is not planned to be performed.
     */
    public function __construct($performed, $time)
    {
        $this->performed = $performed;
        $this->time = $time;
    }
}
