<?php
namespace Topalis\Compliance;

use Topalis\Device\Entity\Device;
use Topalis\Compliance\Entity\Compliance;

/**
 * A compliance verifier verifies if a device is compliant to a compliance.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
interface ComplianceVerifierInterface
{
    /**
     * Verifies if the specified device is compliant to the specified compliance
     * and returns the result.
     *
     * @param Compliance $compliance
     * @param Device $device
     * @param PreviousComplianceVerificationResultInterface $previousResult
     *
     * @return ComplianceVerificationResultInterface
     */
    public function verify(Compliance $compliance, Device $device,
        PreviousComplianceVerificationResultInterface $previousResult);
}
