<?php
namespace Topalis\Compliance\DependencyInjection\Compiler;

use Symfony\Component\DependencyInjection\Compiler\CompilerPassInterface;
use Symfony\Component\DependencyInjection\ContainerBuilder;
use Symfony\Component\DependencyInjection\Exception\InvalidArgumentException;

class RuleTypePass implements CompilerPassInterface
{
    public function process(ContainerBuilder $container)
    {
        $types = array();
        foreach ($container->findTaggedServiceIds("topalis.compliance.rule.type") as $serviceId => $tag) {
            $key = $tag[0]['key'];
            if (isset($types[$key])) {
                throw new InvalidArgumentException(sprintf("Duplicate rule type key \"%s\"", $key));
            }
            $types[$key] = $serviceId;
        }

        $container->getDefinition("compliance.rule.type_container")->addArgument($types);
    }
}
