<?php
namespace Topalis\Compliance\Entity;

use Topalis\Database\EntityManager;
use Topalis\Device\Entity\Device;
use Doctrine\ORM\Query\Expr\Join;

/**
 * WinPhoneAppPolicyEntityManager
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class WinPhoneAppPolicyEntityManager extends EntityManager
{
    public function __construct(\Doctrine\ORM\EntityManager $em)
    {
        parent::__construct($em, "Topalis\Compliance\Entity\WinPhoneAppPolicy");
    }

    public function findForDevice(Device $device)
    {
        return $this->createQueryBuilder("p")
            ->join("p.compliance", "c")
            ->join("c.groups", "g")
            ->join("g.devices", "d", Join::WITH, "d = :device")
            ->setParameter("device", $device)
            ->getQuery()->getOneOrNullResult();
    }
}
