<?php
namespace Topalis\Compliance\Exception;

/**
 * Exception can be thrown if a validator for a specified key does not exist.
 */
class NoSuchValidatorException extends ValidatorException
{
    private $os;

    private $type;

    public function __construct($message, $os, $type, $code = null, $previous = null)
    {
        parent::__construct($message, $code, $previous);
        $this->os = $os;
        $this->type = $type;
    }

    public function getOs()
    {
        return $this->os;
    }

    public function getType()
    {
        return $this->type;
    }
}
