<?php
namespace Topalis\Compliance\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Topalis\Compliance\Entity\Compliance;
use Topalis\Compliance\Form\Type\ComplianceType;
use Topalis\App\WinPhone\WinPhoneStore;

/**
 * ComplianceForm
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class ComplianceForm extends AbstractType
{
    /**
     *
     * @var \Topalis\Compliance\Entity\Compliance
     */
    private $compliance;

    /**
     * @var \Topalis\App\WinPhone\WinPhoneStore
     */
    private $winPhoneStore;

    public function __construct(Compliance $compliance, WinPhoneStore $winPhoneStore)
    {
        $this->compliance = $compliance;
        $this->winPhoneStore = $winPhoneStore;
    }

    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $options; // unused

        $builder->add("compliance", new ComplianceType($this->compliance, $this->winPhoneStore));
        $builder->get("compliance")->setData($this->compliance);
    }

    /**
     * Returns the name of this type.
     *
     * @return string The name of this type
     */
    public function getName()
    {
        return "compliance";
    }
}
