<?php
namespace Topalis\Compliance\Form\Transformer;

use Symfony\Component\Form\DataTransformerInterface;
use Topalis\Compliance\Entity\WinPhoneAppPolicy;

/**
 * This transforms the app policy entity so that it can be used in the
 * collection that is limited to one element.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class WinPhoneAppPolicyCollectionTransformer implements DataTransformerInterface
{
    /**
     * @var \Topalis\Compliance\Entity\WinPhoneAppPolicy
     */
    private $entity;

    public function transform($value)
    {
        $rv = array("policy" => array());
        if (null !== $value) {
            $this->entity = $value;
            $rv['policy'][] = $this->entity->getPolicy();
        }

        return $rv;
    }

    public function reverseTransform($value)
    {
        $policy = reset($value['policy']);
        if ($policy) {
            if (null === $this->entity) {
                $this->entity = new WinPhoneAppPolicy();
            }
            $this->entity->setPolicy($policy);
            return $this->entity;
        }

        return null;
    }
}
