<?php
namespace Topalis\Compliance\Form\Type;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;
use Symfony\Component\Form\FormInterface;
use Symfony\Component\Form\FormView;

/**
 * AppRuleCollectionType
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class AppRuleCollectionType extends AbstractType
{
    public function buildView(FormView $view, FormInterface $form, array $options)
    {
        $form; // unused
        $view->vars = array_replace($view->vars, array(
            "operating_system" => $options['operating_system'],
            "store"            => $options['store'],
            "inventory"        => $options['inventory'],
            "custom"           => $options['custom'],
            "managed"          => $options['managed'],
        ));
    }

    public function getName()
    {
        return "app_rule_collection";
    }

    public function getParent()
    {
        return "collection";
    }

    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(array(
            "allow_add"        => true,
            "allow_delete"     => true,
            "type"             => new AppRuleType(),
            "prototype"        => true,
            "operating_system" => null,
            "required"         => false,
            "store"            => true,
            "inventory"        => true,
            "custom"           => true,
            "managed"          => null,
        ));
        $resolver->setRequired(array("operating_system"));
    }
}
