<?php
namespace Topalis\Compliance\Form\Type;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Validator\Constraints as Assert;
use Topalis\Compliance\Form\Transformer\AppRuleConditionTransformer;
use Topalis\Form\Validator\Constraint\UniqueInCollection;

/**
 * AppRuleType
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class AppRuleType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $options; // unused
        $builder
            ->add("identifier", "text", array(
                "constraints" => array(
                    new Assert\NotBlank(),
                    new Assert\Length(array("min" => 2, "max" => 200)),
                    new UniqueInCollection()
                ),
                "max_length" => 200,
            ))
            ->add("name", "text", array(
                "constraints" => array(
                    new Assert\NotBlank(),
                    new Assert\Length(array("min" => 2, "max" => 200))
                ),
                "max_length" => 200,
            ))
            ->addViewTransformer(new AppRuleConditionTransformer())
        ;
    }

    public function getName()
    {
        return "app_rule";
    }
}
