<?php
namespace Topalis\Compliance\Form\Type;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Validator\Constraints as Assert;
use Topalis\Compliance\Form\Transformer\RulesTransformer;
use Topalis\Form\Validator\Constraint\VersionNumber;

/**
 * RulesWinphoneType
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class RulesWinphoneType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $options; // unused
        $prefix = "admin.compliance.rule.";
        $builder
            ->add("minOS", "text", array(
                "label" => $prefix . "minOS.label",
                "description" => $prefix . "minOS.description",
                "constraints" => new VersionNumber(),
                "required" => false,
            ))
            ->add("maxOS", "text", array(
                "label" => $prefix . "maxOS.label",
                "description" => $prefix . "minOS.description",
                "constraints" => new VersionNumber(),
                "required" => false,
            ))
            ->addViewTransformer(new RulesTransformer())
        ;
    }

    public function getName()
    {
        return "winphone";
    }
}
