<?php
namespace Topalis\Compliance\Form\Type\WinPhone;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Topalis\App\WinPhone\WinPhoneStore;
use Topalis\Compliance\Form\Transformer\WinPhoneAppPolicyCollectionTransformer;

/**
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class WinPhoneAppPolicyForm extends AbstractType
{
    /**
     * @var \Topalis\App\WinPhone\WinPhoneStore
     */
    private $store;

    public function __construct(WinPhoneStore $store)
    {
        $this->store = $store;
    }

    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $options; // unused

        $builder
            ->add("policy", "jquery_collection", array(
                "type"  => new WinPhoneAppPolicyType($this->store),
                "limit" => 1,
                "label" => "admin.compliance.winphone.appPolicy.title",
                "label_attr" => array("style" => "padding-top: 0px;"),
                "add_attr" => array("class" => "controls"),
                "add_text" => "admin.compliance.winphone.appPolicy.configure",
            ))
            ->addViewTransformer(new WinPhoneAppPolicyCollectionTransformer())
            ;
    }

    public function getName()
    {
        return "winPhoneAppPolicy";
    }
}
