<?php
namespace Topalis\Compliance\Form\Type\WinPhone;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;
use Topalis\App\WinPhone\WinPhoneStore;

/**
 * @author Dominic Tubach <dominic.tubach@topalis.com>
 */
class WinPhoneAppProductIdCollectionType extends AbstractType
{
    /**
     * @var \Topalis\App\WinPhone\WinPhoneStore
     */
    private $store;

    public function __construct(WinPhoneStore $store)
    {
        $this->store = $store;
    }

    public function getName()
    {
        return "winphone_app_product_id_collection";
    }

    public function getParent()
    {
        return "jquery_collection";
    }

    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(array(
            "allow_add" => true,
            "allow_delete" => true,
            "type" => new WinPhoneAppProductIdType($this->store),
            "prototype" => true,
        ));
    }
}
