<?php
namespace Topalis\Compliance\Job;

use Topalis\Compliance\Entity\Compliance;
use Topalis\Compliance\Entity\ComplianceEntityManager;

class ComplianceControlJobEnsurer implements ComplianceControlJobEnsurerInterface
{
    /**
     * @var \Topalis\Compliance\Entity\ComplianceEntityManager
     */
    private $em;

    /**
     * @var \Topalis\Compliance\Job\ComplianceControlQueueInterface
     */
    private $queue;

    public function __construct(ComplianceControlQueueInterface $queue, ComplianceEntityManager $em)
    {
        $this->queue = $queue;
        $this->em = $em;
    }

    public function ensureJobExists(Compliance $compliance)
    {
        if (!$this->queue->containsCompliance($compliance)) {
            $this->queue->putCompliance($compliance, false, $compliance->getCheckInterval(), false);
        }
    }

    public function ensureJobsExist()
    {
        foreach ($this->em->findAll() as $compliance) {
            $this->ensureJobExists($compliance);
        }
    }
}
