<?php
namespace Topalis\Compliance\Job;

use Topalis\Compliance\Entity\Compliance;

/**
 * A compliance control job ensurer ensures that a control job exists in the
 * queue for compliances.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
interface ComplianceControlJobEnsurerInterface
{
    /**
     * Ensures that a compliance control job is in the job queue for the
     * specified compliance. If there's no such job a job will be put into the
     * queue.
     *
     * @param Compliance $compliance
     */
    public function ensureJobExists(Compliance $compliance);

    /**
     * Ensures that a compliance control job is in the job queue for every
     * compliance. If a job is missing a job will be put into the queue.
     */
    public function ensureJobsExist();
}
