<?php
namespace Topalis\Compliance\Job;

use Doctrine\ORM\EntityManagerInterface;
use Psr\Log\LoggerInterface;
use Topalis\Device\Entity\Device;
use Topalis\Kernel\Job\AbstractDeferredQueue;

/**
 * ComplianceVerifyQueue
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class ComplianceVerifyQueue extends AbstractDeferredQueue implements ComplianceVerifyQueueInterface
{
    /**
     * @var \Psr\Log\LoggerInterface
     */
    private $logger;

    /**
     * Constructor.
     *
     * @param \Pheanstalk_PheanstalkInterface $pheanstalk
     * @param string $tube
     * @param LoggerInterface $logger
     */
    public function __construct(\Pheanstalk_PheanstalkInterface $pheanstalk, $tube,
        LoggerInterface $logger, EntityManagerInterface $entityManager = null)
    {
        parent::__construct($pheanstalk, $tube, $entityManager);
        $this->logger = $logger;
    }

    public function putDevice(Device $device)
    {
        $this->getLogger()->debug("Put compliance verification job in queue",
            array("device" => $device->getCombinedId()));
        $this->putDeferred(array("device" => $device->getId()));
    }

    /**
     * @return \Psr\Log\LoggerInterface
     */
    protected function getLogger()
    {
        return $this->logger;
    }
}
