<?php
namespace Topalis\Compliance\Rule;

use Topalis\App\Mdm\AppMdmAdminRegistry;

/**
 * The AppForbidden rule checks if forbidden apps are installed.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class AppForbiddenRuleType implements RuleTypeInterface
{
    private $appMdmAdminRegistry;

    public function __construct(AppMdmAdminRegistry $appMdmAdminRegistry)
    {
        $this->appMdmAdminRegistry = $appMdmAdminRegistry;
    }

    public function getKey()
    {
        return "appForbidden";
    }

    public function getName()
    {
        return "compliance.rule.appForbidden.name";
    }

    public function getShortViolationMessage($os)
    {
        $os; // unused

        return AppForbiddenRuleValidationResult::SHORT_MESSAGE;
    }

    public function getValidator($os)
    {
        $os; // unused

        return new AppForbiddenRuleValidator($this->appMdmAdminRegistry);
    }

    public function getViolationMessage($os)
    {
        $os; // unused

        return AppForbiddenRuleValidationResult::MESSAGE;
    }
}
