<?php
namespace Topalis\Compliance\Rule;

use Topalis\App\Mdm\AppMdmAdminRegistry;

/**
 * The AppRequired rule checks if required apps are installed.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class AppRequiredRuleType implements RuleTypeInterface
{
    private $appMdmAdminRegistry;

    public function __construct(AppMdmAdminRegistry $appMdmAdminRegistry)
    {
        $this->appMdmAdminRegistry = $appMdmAdminRegistry;
    }

    public function getKey()
    {
        return "appRequired";
    }

    public function getName()
    {
        return "compliance.rule.appRequired.name";
    }

    public function getShortViolationMessage($os)
    {
        $os; // unused

        return AppRequiredRuleValidationResult::SHORT_MESSAGE;
    }

    public function getValidator($os)
    {
        $os; // unused

        return new AppRequiredRuleValidator($this->appMdmAdminRegistry);
    }

    public function getViolationMessage($os)
    {
        $os; // unused

        return AppRequiredRuleValidationResult::MESSAGE;
    }
}
