<?php
namespace Topalis\Compliance\Rule;

use Topalis\Compliance\Rule\RuleValidatorInterface;
use Topalis\Device\Entity\Device;

/**
 * Validator for the DataRoamingRule.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class DataRoamingRuleValidator extends AbstractRuleValidator
{
    public function validate(Device $device, $condition)
    {
        $condition; // unused

        $violated = false;
        $deviceInfo = $device->getType()->getDeviceInfo($device);
        if ($deviceInfo->contains("DataRoamingEnabled")) {
            $violated = $deviceInfo->get("DataRoamingEnabled") ? true : false;
        }

        return new DataRoamingRuleValidationResult($violated);
    }
}
