<?php
namespace Topalis\Compliance\Rule;

use Topalis\App\Mdm\AppMdmAdminRegistry;

/**
 * The Encrypted rule checks if encryption is enabled.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class EncryptedRuleType implements RuleTypeInterface
{
    public function getKey()
    {
        return "encrypted";
    }

    public function getName()
    {
        return "compliance.rule.encrypted.name";
    }

    public function getShortViolationMessage($os)
    {
        $os; // unused

        return EncryptedRuleValidationResult::SHORT_MESSAGE;
    }

    public function getValidator($os)
    {
        $os; // unused

        return new EncryptedRuleValidator();
    }

    public function getViolationMessage($os)
    {
        $os; // unused

        return EncryptedRuleValidationResult::MESSAGE;
    }
}
