<?php
namespace Topalis\Compliance\Rule;

/**
 * The result of the EncryptedRule.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class EncryptedRuleValidationResult implements RuleValidationResultInterface
{
    const MESSAGE = "admin.compliance.rule.encrypted.violation";
    const SHORT_MESSAGE = "admin.compliance.rule.encrypted.violationShort";

    private $parameters = array();

    private $violated;

    /**
     * Constructor.
     *
     * @param boolean $violated
     */
    public function __construct($violated)
    {
        $this->violated = $violated;
    }

    public function getMessage()
    {
        return self::MESSAGE;
    }

    /**
     * @return array Empty array.
     *
     * @see \Topalis\Compliance\Rule\RuleValidationResultInterface::getParameters()
     */
    public function getParameters()
    {
        return $this->parameters;
    }

    public function getShortMessage()
    {
        return self::SHORT_MESSAGE;
    }

    public function isViolated()
    {
        return $this->violated;
    }
}
