<?php
namespace Topalis\Compliance\Rule;

/**
 * The MaxOS rule checks if the installed OS version exceeds a configured
 * version number.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class MaxOSRuleType implements RuleTypeInterface
{
    public function getKey()
    {
        return "maxOS";
    }

    public function getName()
    {
        return "compliance.rule.maxOS.name";
    }

    public function getShortViolationMessage($os)
    {
        $os; // unused

        return MaxOSRuleValidationResult::SHORT_MESSAGE;
    }

    public function getValidator($os)
    {
        $os; // unused

        return new MaxOSRuleValidator();
    }

    public function getViolationMessage($os)
    {
        $os; // unused

        return MaxOSRuleValidationResult::MESSAGE;
    }
}
