<?php
namespace Topalis\Compliance\Rule;

/**
 * The MinOS rule checks if the installed OS version deceeds a configured
 * version number.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class MinOSRuleType implements RuleTypeInterface
{
    public function getKey()
    {
        return "minOS";
    }

    public function getName()
    {
        return "compliance.rule.minOS.name";
    }

    public function getShortViolationMessage($os)
    {
        $os; // unused

        return MinOSRuleValidationResult::SHORT_MESSAGE;
    }

    public function getValidator($os)
    {
        $os; // unused

        return new MinOSRuleValidator();
    }

    public function getViolationMessage($os)
    {
        $os; // unused

        return MinOSRuleValidationResult::MESSAGE;
    }
}
