<?php
namespace Topalis\Compliance\Rule;

use Topalis\Compliance\Entity\RuleValidation;

/**
 * PreviousRuleValidationResult
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class PreviousRuleValidationResult implements PreviousRuleValidationResultInterface
{
    /**
     * @var string
     */
    private $message;

    /**
     * @var \Topalis\Compliance\Entity\RuleValidation
     */
    private $ruleValidation;

    /**
     * @var string
     */
    private $shortMessage;

    /**
     * Constructor.
     *
     * @param RuleValidation $ruleValidation The result of the previous
     *     validation.
     * @param string $message The violation message.
     * @param string $shortMessage The short violation message.
     */
    public function __construct(RuleValidation $ruleValidation, $message, $shortMessage)
    {
        $this->ruleValidation = $ruleValidation;
        $this->message = $message;
        $this->shortMessage = $shortMessage;
    }

    public function getLastCheckTime()
    {
        return $this->ruleValidation->getLastCheckTime();
    }

    public function getMessage()
    {
        return $this->message;
    }

    public function getParameters()
    {
        return $this->ruleValidation->getParameters();
    }

    public function getRuleValidation()
    {
        return $this->ruleValidation;
    }

    public function getShortMessage()
    {
        return $this->shortMessage;
    }

    public function getViolationTime()
    {
        return $this->ruleValidation->getViolationTime();
    }

    public function isViolated()
    {
        return $this->ruleValidation->isViolated();
    }

}
