<?php
namespace Topalis\Compliance\Rule;

/**
 * Result of a previous rule validation.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
interface PreviousRuleValidationResultInterface extends RuleValidationResultInterface
{
    /**
     * @return int UNIX timestamp the rule has been checked for the last time.
     */
    public function getLastCheckTime();

    /**
     * @return \Topalis\Compliance\Entity\RuleValidation The entity belonging to
     *     this result.
     */
    public function getRuleValidation();

    /**
     * @return int UNIX timestamp the rule has been violated.
     */
    public function getViolationTime();
}
