<?php
namespace Topalis\Compliance\Rule;

/**
 * Container for rule types.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
interface RuleTypeContainerInterface
{
    /**
     * @param string $key The key of the rule type to get.
     *
     * @return RuleTypeInterface The rule type with the specified key.
     *
     * @throws \Topalis\Compliance\Exception\NoSuchRuleTypeException
     *     If no rule type exists for the key.
     */
    public function get($key);

    /**
     * @param RuleTypeInterface $ruleType The rule type to add.
     *
     * @return RuleTypeContainerInterface
     */
    public function add(RuleTypeInterface $ruleType);

    /**
     * @param string $key The key of the rule type service to add.
     * @param string $serviceId The service id of the rule type to add.
     *
     * @return RuleTypeContainerInterface
     */
    public function addService($key, $serviceId);
}
