<?php
namespace Topalis\Compliance\Rule;

/**
 * RuleValidationResult
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class RuleValidationResult implements RuleValidationResultInterface
{
    /**
     * @var string
     */
    private $message;

    /**
     * @var array
     */
    private $parameters;

    /**
     * @var string
     */
    private $shortMessage;

    /**
     * @var boolean
     */
    private $violated;

    /**
     * Constructor.
     *
     * @param boolean $violated
     * @param string $message
     * @param string $shortMessage
     * @param string[] $parameters
     */
    public function __construct($violated, $message, $shortMessage, array $parameters = array())
    {
        $this->violated = $violated;
        $this->message = $message;
        $this->shortMessage = $shortMessage;
        $this->parameters = $parameters;
    }

    public function getMessage()
    {
        return $this->message;
    }

    public function getParameters()
    {
        return $this->parameters;
    }

    public function getShortMessage()
    {
        return $this->shortMessage;
    }

    public function isViolated()
    {
        return $this->violated;
    }
}
