<?php
namespace Topalis\Compliance\Rule;

/**
 * Result of a rule validation.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
interface RuleValidationResultInterface
{
    /**
     * @return string The violation message. May be a translation id.
     *     Placeholders will be replaced with values returned by getParameters().
     */
    public function getMessage();

    /**
     * @return array Array of strings used for the translation.
     */
    public function getParameters();

    /**
     * @return string The short violation message. May be a translation id. A
     *     short violation message is independent of the values used for the
     *     validation, so placeholders must not be used.
     */
    public function getShortMessage();

    /**
     * @return boolean true if the rule has been violated, false otherwise.
     */
    public function isViolated();
}
