<?php
namespace Topalis\Compliance\Rule;

use Topalis\Compliance\Entity\Rule;

/**
 * A rule validator factory creates rule validators for specified rules.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
interface RuleValidatorFactoryInterface
{
    /**
     * Creates and returns a rule validator for the specified rule.
     *
     * @param Rule $rule
     *
     * @return RuleValidatorInterface
     *
     * @throws \Topalis\Compliance\Exception\NoSuchValidatorException
     *     If no rule validator exists for the rule.
     */
    public function create(Rule $rule);
}
