<?php
namespace Topalis\Compliance\Rule;

use Topalis\Device\Entity\Device;

/**
 * A rule validator validates a rule for a specified device.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
interface RuleValidatorInterface
{
    /**
     * @return boolean true if the validator depends on device information, i.e.
     *    it only makes sense to validate of the device information changed
     *    since the last validation.
     */
    public function isDependsOnDeviceInformation();

    /**
     * @param Device $device The device to validate.
     * @param string $condition The rule's condition.
     *
     * @return RuleValidationResultInterface The result of the validation.
     */
    public function validate(Device $device, $condition);
}
