<?php
namespace Topalis\ConfigGroup;

/**
 * Interface for a section to be displayed on config group edit page
 *
 * @author Florian Pfitzer <florian.pfitzer@topalis.com>
 */
interface ConfigGroupSectionInterface
{
    /**
     * Name of the section
     *
     * @return string
     */
    public function getName();

    /**
     * Route for this section
     *
     * @return string
     */
    public function getRoute();

    /**
     * Translation key for section
     *
     * @return string
     */
    public function getTranslation();

    /**
     * @return string|null
     */
    public function getIcon();
}
