<?php
namespace Topalis\ConfigGroup\Controller;

use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Template;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Topalis\ConfigGroup\Entity\ConfigGroup;

/**
 *
 *
 * @author Florian Pfitzer <pfitzer@w3p.cc>
 * @Route("/admin/group/{group}/section/android")
 */
class AndroidProfileSectionController extends Controller
{
    /**
     * @Route("", name="admin_group_section_android")
     * @param ConfigGroup $group
     * @Template()
     *
     * @return array
     */
    public function indexAction(ConfigGroup $group)
    {
        $builder = $this->get("config_group.form.android_profile");
        $form = $builder->getForm();

        $formHandler = $this->get("config_group.form.android_profile.handler");
        $process = $formHandler->process($form, $group);
        if ($process) {
            $this->get("session")->getFlashBag()->add(
                "success",
                $this->get("translator")->trans("admin.group.saveSuccess")
            );

            return $this->redirect(
                $this->generateUrl("admin_group_section_android", array("group" => $group->getId()))
            );
        }

        return array(
            "group"            => $group,
            "form"             => $form->createView(),
            "selected_section" => "android",
        );
    }
}
