<?php
namespace Topalis\ConfigGroup\Controller;

use Topalis\ConfigGroup\Entity\ConfigGroup;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Template;
use Topalis\Kernel\Controller;
use Topalis\ConfigGroup\Form\Type\WinPhoneForm;
use Topalis\ConfigGroup\Form\Handler\WinPhoneFormHandler;

/**
 * @author Dominic Tubach <dominic.tubach@topalis.com>
 * @Route("/admin/group/{group}/section/winphone")
 */
class WinPhoneSectionController extends Controller
{
    /**
     * @return \Topalis\ConfigGroup\Entity\ConfigGroupEntityManager
     */
    private function getConfigGroupEntityManager()
    {
        return $this->container->get("config_group.entity.manager.config_group");
    }

    /**
     * @Route("", name="admin_group_section_winphone")
     * @param ConfigGroup $group
     *
     * @Template()
     *
     * @return array
     */
    public function indexAction(ConfigGroup $group)
    {
        $form = $this->createForm(new WinPhoneForm());
        $handler = new WinPhoneFormHandler($this->getRequest(), $this->getConfigGroupEntityManager());

        if ($handler->process($form, $group)) {
            $this->addSuccess($this->tr("admin.group.saveSuccess"));
            return $this->redirect(
                $this->generateUrl("admin_group_section_winphone", array("group" => $group->getId()))
            );
        }

        return array(
            "group"            => $group,
            "form"             => $form->createView(),
        );
    }
}
