<?php
namespace Topalis\ConfigGroup\Form\Transformer\Android;

use Symfony\Component\Form\DataTransformerInterface;
use Topalis\Profile\Payload\Android\PasscodePayload;

/**
 * Transformer for Android pass code configuration to set default values.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class AndroidPassCodeTransformer implements DataTransformerInterface
{
    public function transform($value)
    {
        if ($value === null) {
            $value = new PasscodePayload();
            $value->setMinLength(4);
        }

        return $value;
    }

    public function reverseTransform($value)
    {
        return $value;
    }
}
