<?php
namespace Topalis\ConfigGroup\Form\Transformer\Ios;

use Symfony\Component\Form\DataTransformerInterface;
use Topalis\Profile\Payload\PasscodePayload;

/**
 * Transformer for iOS pass code configuration to set default values.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class IosPassCodeTransformer implements DataTransformerInterface
{
    public function transform($value)
    {
        if ($value === null) {
            $value = new PasscodePayload();
        }

        if (strlen($value->getMaxFailedAttempts()) == 0) {
            $value->setMaxFailedAttempts(10);
        }

        if (strlen($value->getMinLength()) == 0) {
            $value->setMinLength(4);
        }

        return $value;
    }

    public function reverseTransform($value)
    {
        return $value;
    }
}
