<?php
namespace Topalis\ConfigGroup\Form\Transformer\WinPhone;

use Symfony\Component\Form\DataTransformerInterface;
use Topalis\ConfigGroup\Form\Transformer\WinPhone\Util\WinPhoneTransformerUtil;

/**
 * Transformer for Windows Phone pass code configuration.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class WinPhonePassCodeTransformer implements DataTransformerInterface
{
    public function transform($value)
    {
        if ($value) {
            WinPhoneTransformerUtil::addOrReplaceBool($value, "allowSimpleDevicePassword");
            WinPhoneTransformerUtil::addOrReplaceBool($value, "alphanumericDevicePasswordRequired", 0, false);
            $value['disableGracePeriod'] = isset($value['allowIdleReturnWithoutPassword'])
                && $value['allowIdleReturnWithoutPassword'] == 0;
        }

        return $value;
    }

    public function reverseTransform($value)
    {
        WinPhoneTransformerUtil::revReplaceBool($value, "allowSimpleDevicePassword");
        WinPhoneTransformerUtil::revReplaceBool($value, "alphanumericDevicePasswordRequired", 0, 1);
        if ($value['disableGracePeriod']) {
            $value['allowIdleReturnWithoutPassword'] = 0;
        } else {
            $value['allowIdleReturnWithoutPassword'] = 1;
        }
        unset($value['disableGracePeriod']);

        return $value;
    }
}
