<?php
namespace Topalis\ConfigGroup\Form\Transformer\WinPhone;

use Symfony\Component\Form\DataTransformerInterface;

/**
 * Transformer for Windows Phone WiFi configuration.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class WinPhoneWifiTransformer implements DataTransformerInterface
{
    public function transform($value)
    {
        return $value;
    }

    public function reverseTransform($value)
    {
        $wlanProfile = $value;
        // for some reason connectionMode MUST be set to "manual"
        $wlanProfile->setConnectionMode("manual");
        switch ($wlanProfile->getAuthentication()) {
            case "open":
                $wlanProfile->setEncryption("none");
                $wlanProfile->setKeyMaterial(null);
                break;
            case "shared":
                $wlanProfile->setEncryption("WEP");
                break;
            case "WPA":
                /* fall through */
            case "WPAPSK":
                $wlanProfile->setEncryption("TKIP");
                break;
            case "WPA2":
                /* fall through */
            case "WPA2PSK":
                $wlanProfile->setEncryption("AES");
                break;
            default:
                $wlanProfile->setEncryption(null);
                $wlanProfile->setKeyMaterial(null);
                break;
        }

        if ($wlanProfile->getEncryption() == "none") {
            $wlanProfile->setProtected(null);
            $wlanProfile->setKeyType(null);
        } else {
            $wlanProfile->setProtected(false);
            if ($wlanProfile->getEncryption() == "WEP") {
                $wlanProfile->setKeyType("networkKey");
            } else {
                $wlanProfile->setKeyType("passPhrase");
            }
        }

        return $value;
    }
}
