<?php
namespace Topalis\ConfigGroup\Form\Type\Android;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;

/**
 * @author Florian Pfitzer <pfitzer@w3p.cc>
 */
class RestrictionsType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $options; // unused

        $prefix = "admin.group.android_profile.restrictions.";
        $prefixProfile = "admin.group.profile.restrictions.";
        $prefixGeneral = "admin.group.general.restrictions.";
        $builder
            ->add("forceEncryption", "checkbox", array(
                "label" => $prefix . "forceEncryption",
            ))
            ->add("forceExternalEncryption", "checkbox", array(
                "label" => $prefix . "forceExternalEncryption",
                "os" => array("KNOX"),
            ))
            ->add("allowCamera", "checkbox", array(
                "label" => $prefixProfile . "allowCamera",
            ))
            ->add("allowVideoRecord", "checkbox", array(
                "label" => $prefix . "allowVideoRecord",
                "os" => array("KNOX"),
            ))
            ->add("allowMicrophone", "checkbox", array(
                "label" => $prefix . "allowMicrophone",
                "os" => array("KNOX"),
            ))
            ->add("allowAudioRecord", "checkbox", array(
                "label" => $prefix . "allowAudioRecord",
                "os" => array("KNOX"),
            ))
            ->add("allowClipboard", "checkbox", array(
                "label" => $prefix . "allowClipboard",
                "os" => array("KNOX"),
            ))
            ->add("allowClipboardShare", "checkbox", array(
                "label" => $prefix . "allowClipboardShare",
                "os" => array("KNOX"),
            ))
            ->add("allowSdCard", "checkbox", array(
                "label" => $prefixGeneral . "allowSdCard",
                "os" => array("KNOX"),
            ))
            ->add("allowSDCardWrite", "checkbox", array(
                "label" => $prefix . "allowSDCardWrite",
                "os" => array("KNOX"),
            ))
            ->add("allowUsbHostStorage", "checkbox", array(
                "label" => $prefix . "allowUsbHostStorage",
                "os" => array("KNOX"),
            ))
            ->add("allowUsbMediaPlayer", "checkbox", array(
                "label" => $prefix . "allowUsbMediaPlayer",
                "os" => array("KNOX"),
            ))
            ->add("allowSVoice", "checkbox", array(
                "label" => $prefix . "allowSVoice",
                "os" => array("KNOX"),
            ))
            ->add("allowVpn", "checkbox", array(
                "label" => $prefix . "allowVpn",
                "os" => array("KNOX"),
            ))
            ->add("allowShareList", "checkbox", array(
                "label" => $prefix . "allowShareList",
                "os" => array("KNOX"),
            ))
            ->add("allowAndroidBeam", "checkbox", array(
                "label" => $prefix . "allowAndroidBeam",
                "os" => array("KNOX"),
            ))
            ->add("allowSBeam", "checkbox", array(
                "label" => $prefix . "allowSBeam",
                "os" => array("KNOX"),
            ))
            ->add("allowBluetooth", "checkbox", array(
                "label" => $prefixGeneral . "allowBluetooth",
                "os" => array("KNOX"),
            ))
            ->add("allowNFC", "checkbox", array(
                "label" => $prefixGeneral . "allowNFC",
                "os" => array("KNOX"),
            ))
            ->add("allowCellularData", "checkbox", array(
                "label" => $prefix . "allowCellularData",
                "os" => array("KNOX"),
            ))
            ->add("allowUserMobileDataLimit", "checkbox", array(
                "label" => $prefix . "allowUserMobileDataLimit",
                "os" => array("KNOX"),
            ))
            ->add("allowWiFi", "checkbox", array(
                "label" => $prefixGeneral . "allowWiFi",
                "os" => array("KNOX"),
            ))
            ->add("allowWifiDirect", "checkbox", array(
                "label" => $prefix . "allowWifiDirect",
                "os" => array("KNOX"),
            ))
            ->add("allowTethering", "checkbox", array(
                "label" => $prefix . "allowTethering",
                "os" => array("KNOX"),
            ))
            ->add("allowBluetoothTethering", "checkbox", array(
                "label" => $prefix . "allowBluetoothTethering",
                "os" => array("KNOX"),
            ))
            ->add("allowUsbTethering", "checkbox", array(
                "label" => $prefix . "allowUsbTethering",
                "os" => array("KNOX"),
            ))
            ->add("allowWifiTethering", "checkbox", array(
                "label" => $prefix . "allowWifiTethering",
                "os" => array("KNOX"),
            ))
            ->add("allowSettingsChanges", "checkbox", array(
                "label" => $prefix . "allowSettingsChanges",
                "os" => array("KNOX"),
            ))
            ->add("allowWallpaperChange", "checkbox", array(
                "label" => $prefix . "allowWallpaperChange",
                "os" => array("KNOX"),
            ))
            ->add("allowStatusBarExpansion", "checkbox", array(
                "label" => $prefix . "allowStatusBarExpansion",
                "os" => array("KNOX"),
            ))
            ->add("allowLockScreenView", "checkbox", array(
                "label" => $prefix . "allowLockScreenView",
                "os" => array("KNOX"),
            ))
            ->add("allowScreenCapture", "checkbox", array(
                "label" => $prefix . "allowScreenCapture",
                "os" => array("KNOX"),
            ))
            ->add("allowOTAUpgrade", "checkbox", array(
                "label" => $prefix . "allowOTAUpgrade",
                "os" => array("KNOX"),
            ))
            ->add("allowNonMarketApps", "checkbox", array(
                "label" => $prefix . "allowNonMarketApps",
                "os" => array("KNOX"),
            ))
            ->add("allowNonTrustedAppInstall", "checkbox", array(
                "label" => $prefix . "allowNonTrustedAppInstall",
                "os" => array("KNOX"),
            ))
            ->add("allowGoogleCrashReport", "checkbox", array(
                "label" => $prefix . "allowGoogleCrashReport",
                "os" => array("KNOX"),
            ))
            ->add("allowBackup", "checkbox", array(
                "label" => $prefix . "allowBackup",
                "os" => array("KNOX"),
            ))
            ->add("allowPowerOff", "checkbox", array(
                "label" => $prefix . "allowPowerOff",
                "os" => array("KNOX"),
            ))
            ->add("allowFactoryReset", "checkbox", array(
                "label" => $prefix . "allowFactoryReset",
                "os" => array("KNOX"),
            ))
            ->add("allowKillingActivitiesOnLeave", "checkbox", array(
                "label" => $prefix . "allowKillingActivitiesOnLeave",
                "os" => array("KNOX"),
            ))
            ->add("allowStopSystemApp", "checkbox", array(
                "label" => $prefix . "allowStopSystemApp",
                "os" => array("KNOX"),
            ))
            ->add("allowBackgroundProcessLimit", "checkbox", array(
                "label" => $prefix . "allowBackgroundProcessLimit",
                "os" => array("KNOX"),
            ))
            ->add("allowBackgroundData", "checkbox", array(
                "label" => $prefix . "allowBackgroundData",
                "os" => array("KNOX"),
            ))
            ->add("allowSafeMode", "checkbox", array(
                "label" => $prefix . "allowSafeMode",
                "os" => array("KNOX"),
            ))
            ->add("allowUsbDebugging", "checkbox", array(
                "label" => $prefix . "allowUsbDebugging",
                "os" => array("KNOX"),
            ))
        ;
    }

    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(array(
            "data_class" => 'Topalis\Profile\Payload\Android\RestrictionsPayload',
            "required"   => false,
        ));
    }

    public function getName()
    {
        return "restrictions";
    }
}
