<?php
namespace Topalis\ConfigGroup\Form\Type;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;
use Topalis\ConfigGroup\Form\Type\Android\PassCodeType;
use Topalis\ConfigGroup\Form\Type\Android\RestrictionsType;
use Topalis\ConfigGroup\Form\Type\Android\WifiType;

/**
 * @author Florian Pfitzer <pfitzer@w3p.cc>
 */
class AndroidProfileForm extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $options; // unused

        $builder
            ->add("pass_code", "jquery_collection", array(
                "type"     => new PassCodeType(),
                "limit"    => 1,
                "add_text" => "admin.group.configure",
            ))
            ->add("restrictions", "jquery_collection", array(
                "type"     => new RestrictionsType(),
                "limit"    => 1,
                "add_text" => "admin.group.configure",
            ))
            ->add("wifi", "jquery_collection", array(
                "type"     => new WifiType(),
                "allow_add" => false,
            ))
            ->add("save", "submit", array(
                "label" => "Save",
                "attr"  => array("class" => "btn btn-primary")
            ));
    }

    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(array(
            "data_class" => 'Topalis\Profile\AndroidConfigurationProfile'
        ));
    }

    public function getName()
    {
        return "config_group_android_profile";
    }
}
