<?php
namespace Topalis\ConfigGroup\Form\Type;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * @author Florian Pfitzer <florian.pfitzer@to.com>
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class ConfigGroupForm extends AbstractType
{
    private $new;

    public function __construct($new = false)
    {
        $this->new = $new;
    }

    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $options; // unused
        $builder
            ->add("name", "text", array(
                "label" => "admin.group.name",
                "max_length" => 255,
            ))
            ->add("comment", "text", array(
                "label" => "admin.group.comment",
                "max_length" => 255,
                "required" => false,
            ))
        ;

        if ($this->new) {
            $builder->add("copyGroup", "entity", array(
                "label" => "admin.group.copyExisting",
                "class" => "TopalisConfigGroupBundle:ConfigGroup",
                "query_builder" => function($repository) {
                    return $repository->createQueryBuilder("g")->orderBy("g.name", "ASC");
                },
                "property" => "name",
                "mapped" => false,
                'required' => false,
            ));
        }
    }

    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(array(
            "data_class" => 'Topalis\ConfigGroup\Entity\ConfigGroup'
        ));
    }

    public function getName()
    {
        return "config_group";
    }
}
