<?php
namespace Topalis\ConfigGroup\Form\Type;

use Symfony\Component\Form\FormInterface;
use Symfony\Component\Form\FormView;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;
use Symfony\Component\Translation\TranslatorInterface;
use Symfony\Component\OptionsResolver\Options;
use Genemu\Bundle\FormBundle\Form\JQuery\Type\Select2Type;

/**
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class ConfigGroupSelectType extends Select2Type
{
    public function __construct(TranslatorInterface $translator)
    {
        parent::__construct("entity");
        $this->translator = $translator;
    }

    public function finishView(FormView $view, FormInterface $form, array $options)
    {
        $form; // unused

        if (null !== $options['placeholder']) {
            $view->vars['configs'] = array_replace($view->vars['configs'], array(
                "placeholder" => $this->translator->trans($options['placeholder'])
            ));
        }
    }

    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(array(
            "class" => 'Topalis\ConfigGroup\Entity\ConfigGroup',
            "property" => "name",
            "multiple" => true,
            "by_reference" => false,
            "placeholder" => "admin.group.type.select.placeholder",
            "configs" => array("width" => "element"),
        ));
    }

    public function getName()
    {
        return "configgroup_select";
    }
}
