<?php
namespace Topalis\ConfigGroup\Form\Type\Ios;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;

/**
 * @author Florian Pfitzer <pfitzer@w3p.cc>
 */
class ApnType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $options; // unused
        $prefix = "admin.group.profile.apn.";
        $builder
            ->add("apn", "text", array(
                "label" => $prefix."apn"
            ))
            ->add("username", "text", array(
                "label" => $prefix."username"
            ))
            ->add("password", "text", array(
                "label" => $prefix."password"
            ))
            ->add("proxy", "text", array(
                "label" => $prefix."proxy"
            ))
            ->add("proxy_port", "number", array(
                "label" => $prefix."proxy_port"
            ))
        ;
    }

    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(array(
            "data_class" => 'Topalis\Profile\Payload\ApnPayload',
            "required"   => false
        ));
    }

    public function getName()
    {
        return "apn";
    }
}
