<?php
namespace Topalis\ConfigGroup\Form\Type;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;
use Symfony\Component\Validator\Constraints\File;
use Symfony\Component\Validator\Constraints\NotBlank;
use Topalis\ConfigGroup\Validator\ConfigProfile;

/**
 * @author Florian Pfitzer <florian.pfitzer@topalis.com>
 */
class ProfileUploadForm extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $options; // unused
        $builder
            ->add("profile", "file", array(
                "label" => ".mobileconfig",
                "constraints" => array(
                    new NotBlank(),
                    new File(array(
                        "mimeTypes" => array("application/xml", "application/octet-stream")
                    )),
                    new ConfigProfile()
                ),
                "required" => false,
                "mapped"   => false
            ))
            ->add("upload", "submit", array(
                "label" => "Upload",
                "attr" => array("class" => "btn btn-warning")
            ))
        ;
    }

    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(array(
            "data_class" => 'Topalis\ConfigGroup\Entity\ConfigGroup'
        ));
    }

    public function getName()
    {
        return "config_group_profile_upload";
    }
}
