<?php
namespace Topalis\ConfigGroup\Form\Type\WinPhone;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Topalis\ConfigGroup\Form\Transformer\WinPhone\WinPhoneExchangeTransformer;

/**
 * @author Dominic Tubach <dominic.tubach@topalis.com>
 */
class WinPhoneExchangeType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $options; // unused
        $prefix = "admin.group.profile.exchange.";
        $prefixWin = "admin.group.winphone.exchange.";
        $builder
            ->add("mailAgeFilter", "choice", array(
                "label"   => $prefix . "syncdays",
                "description" => $prefix . "syncdaysDescr",
                "choices" => array(
                    "0"  => $prefix . "syncUnlimited",
                    "2"  => $prefix . "sync3days",
                    "3"  => $prefix . "sync1week",
                    "4" => $prefix . "sync2weeks",
                    "5" => $prefix . "sync1month",
                )
            ))
            ->add("schedule", "choice", array(
                "label" => $prefixWin . "schedule",
                "description" => $prefixWin . "scheduleDescr",
                "choices" => array(
                    "-1" => $prefixWin . "schedReceived",
                    "0" => $prefixWin . "schedManual",
                    "15" => $prefixWin . "sched15min",
                    "30" => $prefixWin . "sched30min",
                    "60" => $prefixWin . "sched60min"
                )
            ))
            ->addViewTransformer(new WinPhoneExchangeTransformer());
    }

    public function getName()
    {
        return "exchange";
    }
}
