<?php
namespace Topalis\ConfigGroup\Form\Type;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Topalis\ConfigGroup\Form\Type\WinPhone\WinPhonePassCodeType;
use Topalis\ConfigGroup\Form\Type\WinPhone\WinPhoneWifiType;
use Topalis\ConfigGroup\Form\Type\WinPhone\WinPhoneRestrictionsType;
use Topalis\ConfigGroup\Form\Type\WinPhone\WinPhoneExchangeType;

/**
 *
 * @author Dominic Tubach <dominic.tubach@topalis.com>
 */
class WinPhoneForm extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $options; // unsued
        $builder
        ->add("pass_code", "jquery_collection", array(
            "type"  => new WinPhonePassCodeType(),
            "limit" => 1,
            "add_text" => "admin.group.configure",
        ))
        ->add("restrictions", "jquery_collection", array(
            "type" => new WinPhoneRestrictionsType(),
            "limit" => 1,
            "add_text" => "admin.group.configure",
        ))
        ->add("wifi", "jquery_collection", array(
            "type" => new WinPhoneWifiType(),
            "allow_add" => false,
        ))
        ->add("exchange", new WinPhoneExchangeType())
        ->add("save", "submit", array(
            "label" => "Save",
            "attr" => array("class" => "btn btn-primary")
        ))
        ;

    }

    public function getName()
    {
        return "config_group_winphone";
    }
}
