<?php
namespace Topalis\Configuration\DependencyInjection;

use Symfony\Component\Config\Definition\Builder\TreeBuilder;
use Symfony\Component\Config\Definition\ConfigurationInterface;

/**
 *
 *
 * @author Florian Pfitzer <florian.pfitzer@to.com>
 */
class Configuration implements ConfigurationInterface
{

    /**
     * Generates the configuration tree builder.
     *
     * @return \Symfony\Component\Config\Definition\Builder\TreeBuilder The tree builder
     */
    public function getConfigTreeBuilder()
    {
        $treeBuilder = new TreeBuilder();
        $rootNode = $treeBuilder->root('configuration');
        $rootNode
            ->children()
                ->scalarNode("sysconfig")->defaultValue("/etc/auralis/conf")->end()
            ->end()
        ;

        return $treeBuilder;
    }
}
