<?php
namespace Topalis\Configuration\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Validator\Constraints\NotBlank;

/**
 * @author Florian Pfitzer <pfitzer@w3p.cc>
 */
class ExchangeConfigurationForm extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $options; // unused

        $builder
            ->add("exchangeHost", "text", array(
                "label"       => "admin.global.exchange.server",
                "constraints" => new NotBlank()
            ))
            ->add("exchangeSSL", "checkbox", array(
                "required" => false,
                "label"    => "admin.global.exchange.ssl",
            ))
            ->add("exchangeDomain", "text", array(
                "required" => false,
                "label"    => "admin.global.exchange.domain",
            ))
            ->add("exchangeAltLogin", "checkbox", array(
                "required" => false,
                "label"    => "admin.global.exchange.zlogon",
            ))
        ;
    }

    public function getName()
    {
        return "config_exchange";
    }
}
