<?php
namespace Topalis\Configuration\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;

/**
 * @author Florian Pfitzer <pfitzer@w3p.cc>
 * @author Dominic Tubach <dominic.tubach@topalis.com>
 */
class LdapConfigurationForm extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $options; // unused

        $builder
            ->add("hostname", "text", array(
                "label"    => "admin.global.ldap.hostname",
                "required" => false
            ))
            ->add("port", "integer", array(
                "label"       => "Port",
                "description" => "admin.global.ldap.port.description",
                "required"    => false
            ))
            ->add("security", "choice", array(
                "label"   => "admin.global.ldap.security.label",
                "choices" => array(
                    "None" => "admin.global.ldap.security.none",
                    "SSL"  => "SSL",
                    "TLS"  => "TLS"
                ),
            ))
            ->add("bind_name", "text", array(
                "label"       => "admin.global.ldap.bind_name",
                "required"    => false,
                "description" => "admin.global.ldap.bind_descr",
            ))
            ->add("bind_password", "password", array(
                "label"    => "admin.global.ldap.bind_password",
                "required" => false,
            ))
            ->add("base_dn", "text", array(
                "label"       => "admin.global.ldap.base_dn",
                "description" => "admin.global.ldap.base_dn_descr",
                "required"    => false
            ))
        ;
    }

    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(array(
            "data_class" => 'Topalis\Configuration\LdapConfig'
        ));
    }

    public function getName()
    {
        return "config_ldap";
    }
}
