<?php
namespace Topalis\Configuration\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Validator\Constraints\Range;

class PortConfigurationForm extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $options; // unused

        $builder
            ->add("primaryPort", "integer", array(
                "label"       => "admin.global.port.primary",
                "constraints" => new Range(array("min" => 1, "max" => 65535)),
            ))
            ->add("secondaryPort", "integer", array(
                "label"       => "admin.global.port.secondary",
                "constraints" => new Range(array("min" => 1, "max" => 65535)),
            ))
        ;
    }

    public function getName()
    {
        return "config_port";
    }
}
