<?php
namespace Topalis\Configuration\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;
use Topalis\Configuration\Validator\SNMPEnabled;

/**
 * @author Florian Pfitzer <pfitzer@w3p.cc>
 */
class SnmpConfigurationForm extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $options; // unused

        $builder
            ->add("enabled", "checkbox", array(
                "label"    => "admin.global.snmp.enable",
                "required" => false,
            ))
            ->add("community", "text", array(
                "required" => false,
                "label"    => "admin.global.snmp.community",
            ))
        ;
    }

    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(array(
            "constraints" => new SNMPEnabled()
        ));
    }

    public function getName()
    {
        return "config_snmp";
    }
}
