<?php
namespace Topalis\Configuration\Form\Type;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Intl\Intl;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;

/**
 * A choice type to choose a Windows Phone Store locale.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class WinPhoneStoreLocaleType extends AbstractType
{
    public function getName()
    {
        return "winPhoneStoreLocale";
    }

    public function getParent()
    {
        return "choice";
    }

    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $choices = array();
        foreach (Intl::getLocaleBundle()->getLocaleNames() as $key => $value) {
            if (preg_match('/^[a-z]{2}_[A-Z]{2}$/', $key)) {
                $key[2] = "-";
                $choices[strtolower($key)] = $value;
            }
        }
        $resolver->setDefaults(array(
            'choices' => $choices,
        ));
    }
}
