<?php
namespace Topalis\Dashboard\System;

use Topalis\Util\Process;

/**
 * Abstract class for common functions to get system information
 *
 * @author Florian Pfitzer <florian.pfitzer@topalis.com>
 */
abstract class SystemInformation
{
    public function execute($command, $input = null)
    {
        $stdout = '';
        $stderr = null;
        Process::execErr($command, $stdout, $stderr, $input);
        return $stdout;
    }

    public function readFile($file, $lines = false, $bytes = 4096)
    {
        if (!file_exists($file)) {
            return false;
        }

        if (!$fp = fopen($file, "r")) {
            return false;
        }

        $content = "";
        $line = 0;
        while (!feof($fp)) {
            $content .= fgets($fp, $bytes);
            if (false !== $lines && $lines <= $line) {
                break;
            } else {
                $line++;
            }
        }
        fclose($fp);

        return $content;
    }
}
