<?php
namespace Topalis\Device\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;
use Topalis\Device\Type\DeviceTypeFactory;

/**
 * @author Florian Pfitzer <pfitzer@w3p.cc>
 */
class DeviceTypeForm extends AbstractType
{
    /**
     * @var \Topalis\Device\Type\DeviceTypeFactory
     */
    private $typeFactory;

    public function __construct(DeviceTypeFactory $typeFactory)
    {
        $this->typeFactory = $typeFactory;
    }

    /**
     * Returns the name of this type.
     *
     * @return string The name of this type
     */
    public function getName()
    {
        return "device_type";
    }

    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $types = array();
        foreach ($this->typeFactory->getTypes() as $type) {
            $types[$type->getId()] = $type->getTranslation();
        }

        $resolver->setDefaults(array(
            "choices" => $types
        ));
    }

    public function getParent()
    {
        return "choice";
    }

}
