<?php
namespace Topalis\Device\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * Form for mail accounts
 * @author Florian Pfitzer <florian.pfitzer@topalis.com>
 */
class MailAccountForm extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $options; // unused
        $builder
            ->add("user", "text", array(
                "label" => "admin.users.login",
                "constraints" => new Assert\NotBlank()
            ))
            ->add("email", "email", array(
                "label" => "admin.users.email",
                "constraints" => array(new Assert\NotBlank(), new Assert\Email())
            ))
        ;
    }

    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver
            ->setDefaults(array(
                "data_class" => "Topalis\Device\Entity\MailAccount"
            ))
        ;
    }

    /**
     * Returns the name of this type.
     * @return string The name of this type
     */
    public function getName()
    {
        return "mail_account";
    }
}
