<?php
namespace Topalis\Device\Info;

use Topalis\Device\Entity\Device;

/**
 * A device info section extends the device info dialog.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
interface DeviceInfoSectionInterface
{
    /**
     * @return string The key of the section.
     */
    public function getKey();

    /**
     * @return array HTML attributes for the tab element.
     */
    public function getTabAttributes();

    /**
     * @return string The title of the section that will be displayed. It will
     *     be passed to the translator before.
     */
    public function getTitle();

    /**
     * @param Device $device
     *
     * @return boolean true if the section is visible for the specified device,
     *     false otherwise.
     */
    public function isVisible(Device $device);

    /**
     * Renders the content to display in the device info dialog.
     *
     * @param Device $device The device to render the content for.
     *
     * @return string The rendered content.
     */
    public function renderContent(Device $device);
}
