<?php
namespace Topalis\Form\Extension\Transformer;

use Symfony\Component\Form\DataTransformerInterface;

/**
 * @author Florian Pfitzer <pfitzer@w3p.cc>
 */
class ArrayToStringTransformer implements DataTransformerInterface
{
    public function transform($value)
    {
        if (null === $value) {
            return $value;
        }

        if (!is_array($value)) {
            $value = (array) $value;
        }

        return implode("\n", $value);
    }

    public function reverseTransform($value)
    {
        if (null === $value) {
            return $value;
        }
        if (is_array($value)) {
            return $value;
        }

        return explode("\n", $value);
    }
}
