<?php
namespace Topalis\Form\Extension\Type;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Form\FormInterface;
use Symfony\Component\Form\FormView;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;
use Topalis\Form\Extension\EventListener\CollectionLimitListener;

/**
 * @author Florian Pfitzer <pfitzer@w3p.cc>
 */
class JqueryCollectionType extends AbstractType
{

    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        if ($options['limit']) {
            $builder->addEventSubscriber(new CollectionLimitListener($options['limit']));
        }
    }

    public function buildView(FormView $view, FormInterface $form, array $options)
    {
        $form; // unused
        $view->vars = array_replace($view->vars, array(
            "limit"      => $options['limit'],
            "add_attr"   => $options['add_attr'],
            "add_text"   => $options['add_text'],
            "child_attr" => $options['child_attr'],
        ));
    }

    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(array(
            "limit"        => false,
            "allow_add"    => true,
            "allow_delete" => true,
            "add_attr"     => array(),
            "add_text"     => "+",
            "child_attr"   => array(),
        ));
    }

    public function getParent()
    {
        return "collection";
    }

    public function getName()
    {
        return "jquery_collection";
    }

}
