<?php
namespace Topalis\Form\Extension\Type;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;
use Symfony\Component\Validator\Constraints as Assert;

/**
 *
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class NetworkPortType extends AbstractType
{
    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(array(
            "max_length" => 5,
            "constraints" => new Assert\Range(array("min" => 1, "max" => 65535)),
        ));
    }

    public function getParent()
    {
        return "integer";
    }

    public function getName()
    {
        return "network_port";
    }
}
