<?php
namespace Topalis\Form\Extension\Type;

use Symfony\Component\Form\Extension\Core\Type\PasswordType as BasePasswordType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Form\FormInterface;
use Symfony\Component\Form\FormView;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;
use Topalis\Form\Extension\EventSubscriber\PasswordSubscriber;

/**
 * This type displays a password field that shows a place holder if a password
 * was already set.
 *
 * @author Florian Pfitzer <pfitzer@w3p.cc>
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class PasswordType extends BasePasswordType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $options; // unused
        $builder->addEventSubscriber(new PasswordSubscriber());
    }

    public function buildView(FormView $view, FormInterface $form, array $options)
    {
        $view->vars['had_value'] = $form->usePreviousValue || $options['had_value'];
        if ($view->vars['had_value']) {
            $view->vars['required'] = false;
        }

        parent::buildView($view, $form, $options);
    }

    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        parent::setDefaultOptions($resolver);
        $resolver->setDefaults(array(
            "had_value" => false
        ));
    }
}
