<?php
namespace Topalis\Form\Extension\Type;

use Symfony\Component\Form\AbstractTypeExtension;
use Symfony\Component\Form\FormInterface;
use Symfony\Component\Form\FormView;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;
use Symfony\Component\Translation\TranslatorInterface;

/**
 *
 *
 * @author Florian Pfitzer <pfitzer@w3p.cc>
 */
class Select2Type extends AbstractTypeExtension
{

    public function __construct(TranslatorInterface $translator)
    {
        $this->translator = $translator;
    }

    public function finishView(FormView $view, FormInterface $form, array $options)
    {
        $form; // unused

        if (null !== $options['placeholder']) {
            $view->vars['configs'] = array_replace($view->vars['configs'], array(
                "placeholder" => $this->translator->trans($options['placeholder'])
            ));
        }
    }

    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(array(
            "placeholder" => null,
            "configs" => array("width" => "element")
        ));
    }

    /**
     * Returns the name of the type being extended.
     *
     * @return string The name of the type being extended
     */
    public function getExtendedType()
    {
        return "genemu_jqueryselect2_entity";
    }
}
