<?php
namespace Topalis\Form\Upload;

use Oneup\UploaderBundle\Event\PostUploadEvent;
use Oneup\UploaderBundle\Uploader\Response\AbstractResponse;

/**
 * Upload listener for blueimp jquery uploader
 *
 * @author Florian Pfitzer <pfitzer@w3p.cc>
 */
class BlueimpUploadListener
{
    public function onUpload(PostUploadEvent $event)
    {
        /** @var \SplFileInfo $file */
        $file = $event->getFile();

        $name = $file->getFilename();
        if ($file instanceof DecoratedFile) {
            $name = $file->getClientOriginalName();
        }
        /** @var AbstractResponse $response */
        $response = $event->getResponse();

        $response->addToOffset(array(
            "id"   => $file->getFilename(),
            "name" => $name,
            "size" => $file->getSize(),
        ), array("files"));
    }
}
