<?php
namespace Topalis\Form\Validator\Constraint;

use Symfony\Component\Validator\ConstraintValidator;
use Symfony\Component\Validator\Constraint;

/**
 * Validates if a value is not empty.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class NotEmptyValidator extends ConstraintValidator
{
    public function validate($value, Constraint $constraint)
    {
        if (is_string($value) && strlen($value) === 0 || count($value) === 0) {
            $this->context->addViolation($constraint->message, array(
                '{{ value }}' => $this->formatValue($value),
            ));
        }
    }
}
