<?php
namespace Topalis\Form\Validator\Constraint;

use Symfony\Component\Validator\Constraint;

/**
 * Validates that a value is unique in a collection.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class UniqueInCollection extends Constraint
{
    /**
     * The message can be overriden using an options array in the constructor.
     * It may contain "%value%" as placeholder for the non unique value.
     *
     * @var string
     */
    public $message = "collection.notUnique";

    /**
     * Values with the same path must be unique. It is normally detected
     * automatically, but can be overriden using an options array in the
     * constructor.
     *
     * @var string
     */
    public $propertyPath = null;
}
