<?php
namespace Topalis\Form\Validator\Constraint;

use Symfony\Component\Validator\ConstraintValidator;
use Symfony\Component\Validator\Constraint;

/**
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class UniqueInCollectionValidator extends ConstraintValidator
{
    private $values = array();

    public function validate($value, Constraint $constraint)
    {
        $propertyPath = $this->context->getPropertyPath();
        // make property paths equal for values to validate by removing the last
        // [x] with [].
        $propertyPath = preg_replace("/(.*)\[[0-9]+\]/", "\$1[]", $propertyPath);
        if (isset($this->values[$propertyPath]) && in_array($value, $this->values[$propertyPath])) {
            $this->context->addViolation($constraint->message, array("%value%" => $value), $value);
        } else {
            $this->values[$propertyPath][] = $value;
        }
    }
}
