<?php
namespace Topalis\Kernel\Assets;

use Symfony\Bundle\AsseticBundle\Factory\AssetFactory as BaseAssetFactory;
use Topalis\Kernel\Assets\Asset\DynamicAsset;

/**
 * Factory replacement to create dynamic asset
 *
 * @author Florian Pfitzer <florian.pfitzer@topalis.com>
 */
class AssetFactory extends BaseAssetFactory
{
    // @codingStandardsIgnoreStart
    protected function createFileAsset($source, $root = null, $path = null, $vars)
    {
        $ext = pathinfo($source, PATHINFO_EXTENSION);
        if ("less" == $ext) {
            return new DynamicAsset($source, array(), $root, $path, $vars);
        }

        return parent::createFileAsset($source, $root, $path, $vars);
    }
    // @codingStandardsIgnoreEnd

}
