<?php
namespace Topalis\Kernel\EventListener;

use Symfony\Component\Security\Core\Event\AuthenticationFailureEvent;
use Symfony\Component\Security\Http\Event\InteractiveLoginEvent;

/**
 * This lisener is used to store the remember login setting choosen by the user
 * on login in the session.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class AuthenticationListener
{
    public function onAuthenticationSuccess(InteractiveLoginEvent $event)
    {
        $request = $event->getRequest();
        $session = $request->getSession();

        if ($request->get("rememberLogin")) {
            $session->set("rememberLogin", true);
        } else {
            $session->set("rememberLogin", false);
        }
    }
}
