<?php
namespace Topalis\Kernel\Exception\Database;

use Doctrine\DBAL\Exception\DriverException;

class DatabaseException extends \Exception
{
    private $pdoCode = 0;

    public function __construct($message = null, $code = null, $previous = null)
    {
        if ($previous instanceof \PDOException) {
            $this->pdoCode = $code;
        } else if ($previous instanceof DriverException) {
            $this->pdoCode = $previous->getErrorCode();
        }
        $code = is_numeric($code) ? intval($code) : null;
        parent::__construct($message, $code, $previous);
    }

    /**
     * @return string|int The PDOException code, if the previous exception is a
     *     PDOException, 0 otherwise. This method is used because the code
     *     of PDOExceptions may be a string which is not allowed in ordinary
     *     Exceptions (or sub classes).
     * @see http://www.php.net/manual/en/exception.getcode.php
     */
    final public function getPDOCode()
    {
        return $this->pdoCode;
    }

}
