<?php
namespace Topalis\Kernel\Exception\Http;

use Topalis\Kernel\Http\Response;

/**
 *
 *
 * @author Florian Pfitzer <pfitzer@w3p.cc>
 */
class RequestFailedException extends \Exception
{
    /**
     * @var Response
     */
    protected $response;

    public function __construct(Response $response)
    {
        $this->response = $response;

        $status = $response->getStatusCode();
        $message = $response->getReasonPhrase();
        if (0 === strlen($message) && isset(\Symfony\Component\HttpFoundation\Response::$statusTexts[$status])) {
            $message = \Symfony\Component\HttpFoundation\Response::$statusTexts[$status];
        }

        parent::__construct(
            sprintf(
                "Request to %s failed: (%d: %s)",
                $response->getRequest()->getUrl(),
                $status,
                $message
            ),
            $status
        );
    }

    /**
     * @return Response
     */
    public function getResponse()
    {
        return $this->response;
    }
}
