! function ($) {
    $(function() {
        $('body').on('click', '[data-toggle="modal-form"]', function(e) {
            e.preventDefault();
            var $this = $(this);
            openModalForm($this.attr('href'), function($modal) {
                $(document).trigger('modal-opened', [$modal]);
            });
        });
    });

    $.widget('to.modal2', {
        options: {
            url: null,
            callback: null
        },
        $button: null,
        $modalData: null,
        $parentModal: null,
        $childModal: null,
        _init: function() {
            var self = this;

            // get open parent modal
            this.$parentModal = $('.modal.in');
            if (this.hasParent()) {
                this.$parentModal.parent().modal2('setChildModal', this);
            }

            this.loadContent();
            if (this.options.callback) {
                this.element.on('set_content', function(event, $modalData) {
                    self.options.callback($modalData);
                });
            }
            this.element.on('click', ':submit', function(event) { // save which button was pressed
                self.$button = $(this);
            });
        },
        loadContent: function() {
            var self = this;
            var finished = loading();
            $.ajax(this.options.url, {
                success: function(data) {
                    if (self.hasParent()) {
                        self.$parentModal.modal('hide');
                    }
                    self.setContent(data);
                    finished();
                }
            });
        },
        setContent: function(data) {
            var self = this;
            var $container = this.element.html(data);
            this.$modalData = $container.find('>.modal');

            this.element.append(this.$modalData);
            this.element.trigger('set_content', [this.$modalData]);
            this.$modalData.modal().on('hidden', function() {
                console.log("hide");
                if (!self.hasChild()) {
                    self.$modalData.remove();
                    self.element.remove();
                    if (self.hasParent()) {
                        self.$parentModal.modal('show');
                        self.$parentModal.parent().modal2('setChildModal', null);
                    }
                }

            });
            var $form = this.$modalData.find('form');
            $form.submit(function(event) {
                event.preventDefault();
                var formData = $form.serialize();
                self.$button.button('loading');
                self.submit(formData);
            });
            setup(this.$modalData);
        },
        displayErrors: function(data) {
            var $newContainer = $('<div></div>').html(data);
            var newData = $newContainer.find('.modal-body').html();
            this.$modalData.find('.modal-body').html(newData).scrollTop(0);
            this.$modalData.find('button[type=submit]').button('reset');
            this.element.trigger('set_content', [this.$modalData]);
        },
        submit: function(formData) {
            var self = this;
            var $button = this.$button; // recover clicked button
            $.ajax(this.options.url, {
                type: 'POST',
                data: formData,
                error: function(data) {
                    if (null !== data.responseText) {
                        var $body = self.$modalData.find('.modal-body');
                        $body.empty();
                        // use iframe, as symfony exceptions come with their own stylesheets
                        $('<iframe />').css({width: '100%', height: '500px'}).appendTo($body).contents().find('html').empty().append(data.responseText);
                    }
                },
                success: function(data) {
                    var e = $.Event('data_loaded');
                    self.element.trigger(e, [data, $button]);
                    if (!e.isPropagationStopped()) {
                        var ok = false;
                        if (_.isObject(data) && "OK" === data.status) {
                            ok = true;
                        } else if("OK" === data) {
                            ok = true;
                        }
                        if (!ok) {
                            self.displayErrors(data);
                        } else {
                            self.close();
                            window.location.reload();
                        }
                    }
                }
            });
        },
        close: function() {
            this.$modalData.modal('hide');
            this.element.remove();
        },
        hasParent: function() {
            return this.$parentModal.length > 0;
        },
        setChildModal: function($modal) {
            this.$childModal = $modal;
        },
        hasChild: function() {
            if (null === this.$childModal) {
                return false;
            }
            if (typeof this.$childModal === "undefined") {
                return false;
            }

            return true;
        }
    });

}(jQuery);
