<?php
namespace Topalis\Kernel\Twig\Extension;

/**
 * Makes country codes available in templates
 *
 * @author Florian Pfitzer <florian.pfitzer@topalis.com>
 */
class CountryCodesExtension extends \Twig_Extension
{
    protected $cc = array(
        'AX' => "Åland Islands",
        'AD' => "Andorra",
        'AE' => "United Arab Emirates",
        'AF' => "Afghanistan",
        'AG' => "Antigua and Barbuda",
        'AI' => "Anguilla",
        'AL' => "Albania",
        'AM' => "Armenia",
        'AN' => "Netherlands Antilles",
        'AO' => "Angola",
        'AQ' => "Antarctica",
        'AR' => "Argentina",
        'AS' => "American Samoa",
        'AT' => "Austria",
        'AU' => "Australia",
        'AW' => "Aruba",
        'AZ' => "Azerbaijan",
        'BA' => "Bosnia and Herzegovina",
        'BB' => "Barbados",
        'BD' => "Bangladesh",
        'BE' => "Belgium",
        'BF' => "Burkina Faso",
        'BG' => "Bulgaria",
        'BH' => "Bahrain",
        'BI' => "Burundi",
        'BJ' => "Benin",
        'BM' => "Bermuda",
        'BN' => "Brunei Darussalam",
        'BO' => "Bolivia",
        'BR' => "Brazil",
        'BS' => "Bahamas",
        'BT' => "Bhutan",
        'BV' => "Bouvet Island",
        'BW' => "Botswana",
        'BZ' => "Belize",
        'CA' => "Canada",
        'CC' => "Cocos (Keeling) Islands",
        'CF' => "Central African Republic",
        'CH' => "Switzerland",
        'CI' => "Cote D'Ivoire (Ivory Coast)",
        'CK' => "Cook Islands",
        'CL' => "Chile",
        'CM' => "Cameroon",
        'CN' => "China",
        'CO' => "Colombia",
        'CR' => "Costa Rica",
        'CS' => "Czechoslovakia (former)",
        'CV' => "Cape Verde",
        'CX' => "Christmas Island",
        'CY' => "Cyprus",
        'CZ' => "Czech Republic",
        'DE' => "Germany",
        'DJ' => "Djibouti",
        'DK' => "Denmark",
        'DM' => "Dominica",
        'DO' => "Dominican Republic",
        'DZ' => "Algeria",
        'EC' => "Ecuador",
        'EE' => "Estonia",
        'EG' => "Egypt",
        'EH' => "Western Sahara",
        'ER' => "Eritrea",
        'ES' => "Spain",
        'ET' => "Ethiopia",
        'FI' => "Finland",
        'FJ' => "Fiji",
        'FK' => "Falkland Islands (Malvinas)",
        'FM' => "Micronesia",
        'FO' => "Faroe Islands",
        'FR' => "France",
        'FX' => "France, Metropolitan",
        'GA' => "Gabon",
        'GB' => "Great Britain (UK)",
        'GD' => "Grenada",
        'GE' => "Georgia",
        'GF' => "French Guiana",
        'GG' => "Guernsey",
        'GH' => "Ghana",
        'GI' => "Gibraltar",
        'GL' => "Greenland",
        'GM' => "Gambia",
        'GN' => "Guinea",
        'GP' => "Guadeloupe",
        'GQ' => "Equatorial Guinea",
        'GR' => "Greece",
        'GS' => "S. Georgia and S. Sandwich Isls.",
        'GT' => "Guatemala",
        'GU' => "Guam",
        'GW' => "Guinea-Bissau",
        'GY' => "Guyana",
        'HK' => "Hong Kong",
        'HM' => "Heard and McDonald Islands",
        'HN' => "Honduras",
        'HR' => "Croatia (Hrvatska)",
        'HT' => "Haiti",
        'HU' => "Hungary",
        'ID' => "Indonesia",
        'IE' => "Ireland",
        'IL' => "Israel",
        'IM' => "Isle of Man",
        'IN' => "India",
        'IO' => "British Indian Ocean Territory",
        'IS' => "Iceland",
        'IT' => "Italy",
        'JE' => "Jersey",
        'JM' => "Jamaica",
        'JO' => "Jordan",
        'JP' => "Japan",
        'KE' => "Kenya",
        'KG' => "Kyrgyzstan",
        'KH' => "Cambodia",
        'KI' => "Kiribati",
        'KM' => "Comoros",
        'KN' => "Saint Kitts and Nevis",
        'KR' => "Korea (South)",
        'KW' => "Kuwait",
        'KY' => "Cayman Islands",
        'KZ' => "Kazakhstan",
        'LA' => "Laos",
        'LC' => "Saint Lucia",
        'LI' => "Liechtenstein",
        'LK' => "Sri Lanka",
        'LS' => "Lesotho",
        'LT' => "Lithuania",
        'LU' => "Luxembourg",
        'LV' => "Latvia",
        'LY' => "Libya",
        'MA' => "Morocco",
        'MC' => "Monaco",
        'MD' => "Moldova",
        'ME' => "Montenegro",
        'MG' => "Madagascar",
        'MH' => "Marshall Islands",
        'MK' => "Macedonia",
        'ML' => "Mali",
        'MM' => "Myanmar",
        'MN' => "Mongolia",
        'MO' => "Macau",
        'MP' => "Northern Mariana Islands",
        'MQ' => "Martinique",
        'MR' => "Mauritania",
        'MS' => "Montserrat",
        'MT' => "Malta",
        'MU' => "Mauritius",
        'MV' => "Maldives",
        'MW' => "Malawi",
        'MX' => "Mexico",
        'MY' => "Malaysia",
        'MZ' => "Mozambique",
        'NA' => "Namibia",
        'NC' => "New Caledonia",
        'NE' => "Niger",
        'NF' => "Norfolk Island",
        'NG' => "Nigeria",
        'NI' => "Nicaragua",
        'NL' => "Netherlands",
        'NO' => "Norway",
        'NP' => "Nepal",
        'NR' => "Nauru",
        'NT' => "Neutral Zone",
        'NU' => "Niue",
        'NZ' => "New Zealand (Aotearoa)",
        'OM' => "Oman",
        'PA' => "Panama",
        'PE' => "Peru",
        'PF' => "French Polynesia",
        'PG' => "Papua New Guinea",
        'PH' => "Philippines",
        'PK' => "Pakistan",
        'PL' => "Poland",
        'PM' => "St. Pierre and Miquelon",
        'PN' => "Pitcairn",
        'PR' => "Puerto Rico",
        'PS' => "Palestinian Territory",
        'PT' => "Portugal",
        'PW' => "Palau",
        'PY' => "Paraguay",
        'QA' => "Qatar",
        'RE' => "Reunion",
        'RO' => "Romania",
        'RS' => "Serbia",
        'RU' => "Russian Federation",
        'RW' => "Rwanda",
        'SA' => "Saudi Arabia",
        'SB' => "Solomon Islands",
        'SC' => "Seychelles",
        'SE' => "Sweden",
        'SG' => "Singapore",
        'SH' => "St. Helena",
        'SI' => "Slovenia",
        'SJ' => "Svalbard and Jan Mayen Islands",
        'SK' => "Slovak Republic",
        'SL' => "Sierra Leone",
        'SM' => "San Marino",
        'SN' => "Senegal",
        'SR' => "Suriname",
        'ST' => "Sao Tome and Principe",
        'SU' => "USSR (former)",
        'SV' => "El Salvador",
        'SZ' => "Swaziland",
        'TC' => "Turks and Caicos Islands",
        'TD' => "Chad",
        'TF' => "French Southern Territories",
        'TG' => "Togo",
        'TH' => "Thailand",
        'TJ' => "Tajikistan",
        'TK' => "Tokelau",
        'TM' => "Turkmenistan",
        'TN' => "Tunisia",
        'TO' => "Tonga",
        'TP' => "East Timor",
        'TR' => "Turkey",
        'TT' => "Trinidad and Tobago",
        'TV' => "Tuvalu",
        'TW' => "Taiwan",
        'TZ' => "Tanzania",
        'UA' => "Ukraine",
        'UG' => "Uganda",
        'UM' => "US Minor Outlying Islands",
        'US' => "United States",
        'UY' => "Uruguay",
        'UZ' => "Uzbekistan",
        'VA' => "Vatican City State (Holy See)",
        'VC' => "Saint Vincent and the Grenadines",
        'VE' => "Venezuela",
        'VG' => "Virgin Islands (British)",
        'VI' => "Virgin Islands (U.S.)",
        'VN' => "Viet Nam",
        'VU' => "Vanuatu",
        'WF' => "Wallis and Futuna Islands",
        'WS' => "Samoa",
        'YE' => "Yemen",
        'YT' => "Mayotte",
        'ZA' => "South Africa",
        'ZM' => "Zambia"
    );

    public function getFunctions()
    {
        return array(
            new \Twig_SimpleFunction("getCountryCodes", array($this, "getCountryCodes")),
        );
    }

    public function getCountryCodes()
    {
        return $this->cc;
    }
    /**
     * Returns the name of the extension.
     *
     * @return string The extension name
     */
    public function getName()
    {
        return "country_codes";
    }
}
