<?php
namespace Topalis\Kernel\Twig\Extension;

/**
 * Form
 *
 * @author Florian Pfitzer <florian.pfitzer@topalis.com>
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class FormatReleaseNotesExtension extends \Twig_Extension
{
    public function getFunctions()
    {
        return array(
            new \Twig_SimpleFunction("format_release_notes", array($this, "format"), array("is_safe" => array("html"))),
        );
    }

    public function format($string)
    {
        $keys = array("New:", "Change:", "Bugs fixed:");
        $string = str_replace("\r\n", "\n", $string);
        $string = preg_replace("/^Release Notes[^\n]*[\n]+/", "", $string); // remove first line
        $string = preg_replace("/(.*)\n+(=)+\n/i", "<h4>\\1</h4>\n", $string); // headlines
        $string = preg_replace("/\n(".implode("|", $keys).")(\n)+/i", "<h5>\\1</h5>", $string); // keywords
        $string = preg_replace("/(<\/h[1-9]>)((#([A-Z]+\-)?[0-9]+))([^\n]*)/si", "\\1<strong>\\2</strong>\\5", $string); // tickets
        $string = preg_replace("/\n((#([A-Z]+\-)?[0-9]+))([^\n]*)/si", "\n<strong>\\2</strong>\\4", $string); // tickets

        return nl2br($string);
    }

    public function getName()
    {
        return "format_release_notes";
    }
}
