<?php
namespace Topalis\License\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Validator\Constraints\File;
use Symfony\Component\Validator\Constraints\NotBlank;

/**
 * @author Florian Pfitzer <florian.pfitzer@topalis.com>
 */
class LicenseUploadForm extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $options; // unused
        $builder
            ->add("license", "file", array(
                "label" => "admin.license.file",
                "constraints" => array(new NotBlank(), new File())
            ))
        ;
    }

    /**
     * Returns the name of this type.
     * @return string The name of this type
     */
    public function getName()
    {
        return "license_upload";
    }
}
