<?php
namespace Topalis\License\Twig;

/**
 * @author Florian Pfitzer <florian.pfitzer@to.com>
 * @author Dominic Tubach <dominic.tubach@topalis.com>
 */
class LicenseExtension extends \Twig_Extension
{
    /**
     * @var \Topalis\License\License
     */
    private $license;

    public function __construct(\Topalis\License\LicenseManager $licenseManager)
    {
        $this->license = &$licenseManager->getLicense();
    }
    public function getGlobals()
    {
        return array(
            "license" => $this->license
        );
    }

    /**
     * Returns the name of the extension.
     * @return string The extension name
     */
    public function getName()
    {
        return "license";
    }
}
