<?php
namespace Topalis\Log;

use Topalis\Admin\AdminManagerListenerInterface;

/**
 * This class is used to update the users that have WebDAV access if an admin
 * is added, updated, or deleted.
 *
 * @author Dominic Tubach <dominic.tubach@topalis.com>
 */
class WebDavAdminListener implements AdminManagerListenerInterface
{
    /**
     * @var WebDavManager
     */
    private $webDavManager;

    public function __construct(WebDavManager $webDavManager)
    {
        $this->webDavManager = $webDavManager;
    }

    /**
     * @return \Topalis\Log\WebDavManager
     */
    protected function getWebDavManager()
    {
        return $this->webDavManager;
    }

    public function adminAdded($adminId)
    {
        $adminId; // unused
        $this->getWebDavManager()->generateHtpasswd();
    }

    public function adminDeleted($adminId)
    {
        $adminId; // unused
        $this->getWebDavManager()->generateHtpasswd();
    }

    public function adminUpdated($adminId)
    {
        $adminId; // unused
        $this->getWebDavManager()->generateHtpasswd();
    }

}
