<?php
namespace Topalis\MDM\Command;

use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Input\InputOption;
use Symfony\Component\Console\Output\OutputInterface;
use Topalis\Kernel\Command\LogrotateAwareCommand;

/**
 * @author Florian Pfitzer <pfitzer@w3p.cc>
 */
class GoogleCloudMessagingCommand extends LogrotateAwareCommand
{
    protected function configure()
    {
        parent::configure();
        $this
            ->setDefinition(array(
                new InputOption("offline", null, InputOption::VALUE_OPTIONAL, "force running in offline mode", false)
            ))
            ->setDescription("send push messages to android devices over google cloud messaging")
            ->setName("mdm:gcm");
    }

    protected function execute(InputInterface $input, OutputInterface $output)
    {
        $input; // unused
        $output; // unused
        $this->getContainer()->get("config.auralis")->setCacheEnabled(false);
        $this->getContainer()->get("mdm.gcm_server")->run($input->getOption("offline"));
    }

}
