<?php
namespace Topalis\MDM\DependencyInjection;

use Symfony\Component\Config\Definition\Builder\TreeBuilder;
use Symfony\Component\Config\Definition\ConfigurationInterface;

/**
 *
 *
 * @author Florian Pfitzer <florian.pfitzer@to.com>
 */
class Configuration implements ConfigurationInterface
{

    /**
     * Generates the configuration tree builder.
     *
     * @return \Symfony\Component\Config\Definition\Builder\TreeBuilder The tree builder
     */
    public function getConfigTreeBuilder()
    {
        $treeBuilder = new TreeBuilder();
        $rootNode = $treeBuilder->root('mdm');

        $rootNode->children()
            ->scalarNode("repush_timeout")->defaultValue(43200)->end() // 12 * 60 * 60 = 12 hours
            ->scalarNode("rollout_repush_timeout")->defaultValue(600)->end() // 10 minutes
        ->end();

        return $treeBuilder;
    }
}
