<?php
namespace Topalis\MDM\Event;

use Symfony\Component\EventDispatcher\Event;
use Topalis\MDM\Entity\MdmCommand;

/**
 * MdmCommandEvent
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
abstract class MdmCommandEvent extends Event
{
    /**
     * @var \Topalis\MDM\Entity\MdmCommand
     */
    protected $command;

    public function __construct(MdmCommand $command)
    {
        $this->command = $command;
    }

    /**
     * @return \Topalis\MDM\Entity\MdmCommand
     */
    public function getCommand()
    {
        return $this->command;
    }

    /**
     * @return \Topalis\Device\Entity\Device
     */
    public function getDevice()
    {
        return $this->getCommand()->getDevice();
    }
}
