<?php
namespace Topalis\MDM\Event;

use Symfony\Component\EventDispatcher\Event;
use Topalis\MDM\Entity\MdmCommand;

/**
 * MdmCommandResendEvent
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class MdmCommandResendEvent extends MdmCommandEvent
{
    /**
     * @var \Topalis\MDM\Entity\MdmCommand
     */
    protected $newCommand;

    public function __construct(MdmCommand $oldCommand, MdmCommand $newCommand)
    {
        parent::__construct($oldCommand);
        $this->newCommand = $newCommand;
    }

    /**
     * @return \Topalis\MDM\Entity\MdmCommand
     */
    public function getNewCommand()
    {
        return $this->newCommand;
    }

    /**
     * @return \Topalis\MDM\Entity\MdmCommand
     */
    public function getOldCommand()
    {
        return $this->getCommand();
    }
}
