<?php
namespace Topalis\MDM;

use Topalis\Device\Entity\Device;
use Topalis\MDM\Entity\MdmCommand;

/**
 * This class is used in MdmService and contains objects related to an MDM
 * request.
 *
 * @author Dominic Tubach <dominic.tubach@topalis.com>
 */
class MdmServiceContext
{
    /**
     *
     * @var integer
     */
    private $certSerial;

    /**
     * @var \Topalis\Device\Entity\Device
     */
    private $device;

    /**
     * @var \Topalis\MDM\Entity\MdmCommand
     */
    private $mdmCommand;

    /**
     * @var \Topalis\Mdm\MdmRequest
     */
    private $mdmRequest;

    /**
     * @param \Topalis\MDM\MdmRequest $mdmRequest
     */
    public function __construct(MdmRequest $mdmRequest)
    {
        $this->mdmRequest = $mdmRequest;
    }

    /**
     * @return integer
     */
    public function getCertSerial()
    {
        return $this->certSerial;
    }

    /**
     * @param integer $certSerial
     */
    public function setCertSerial($certSerial)
    {
        $this->certSerial = $certSerial;
    }

    /**
     * @return \Topalis\Device\Entity\Device
     */
    public function getDevice()
    {
        return $this->device;
    }

    /**
     * @return boolean
     */
    public function hasDevice()
    {
        return $this->device !== null;
    }

    /**
     * @param \Topalis\Device\Entity\Device $device
     */
    public function setDevice(Device $device)
    {
        $this->device = $device;
    }

    /**
     * @return \Topalis\MDM\Entity\MdmCommand
     */
    public function getMdmCommand()
    {
        return $this->mdmCommand;
    }

    /**
     * @return boolean
     */
    public function hasCommand()
    {
        return $this->mdmCommand !== null;
    }

    /**
     * @param \Topalis\MDM\Entity\MdmCommand $mdmCommand
     */
    public function setMdmCommand(MdmCommand $mdmCommand)
    {
        $this->mdmCommand = $mdmCommand;
    }

    /**
     * @return \Topalis\MDM\MdmRequest
     */
    public function getMdmRequest()
    {
        return $this->mdmRequest;
    }
}
