<?php
namespace Topalis\MDM\Request;

use Topalis\Profile\Plist\CFDictionaryWrapper;
use CFPropertyList\CFDictionary;

abstract class AbstractMdmRequest extends CFDictionaryWrapper
{

    public function __construct(CFDictionary $dictionary = null)
    {
        parent::__construct($dictionary);

        if ($this->getRequestType() === null && static::REQUEST_TYPE !== null) {
            $this->setRequestType(static::REQUEST_TYPE);
        }
    }

    /**
     * @return string|NULL The request type, null if not defined.
     */
    public function getRequestType()
    {
        return $this->getValue("RequestType");
    }

    /**
     * Sets the request's type.
     *
     * @param string $requestType The request type to set.
     */
    public function setRequestType($requestType)
    {
        $this->setValue("RequestType", $requestType, self::TYPE_STRING);
    }

    /**
     * @return \CFPropertyList\CFDictionary The dictionary.
     */
    public function getDictionary()
    {
        return parent::getDictionary();
    }
}
