<?php
namespace Topalis\Menu;

use Symfony\Component\HttpFoundation\Request;
use Topalis\Util\StringUtil;

/**
 * Represents a menu item
 *
 * @author Florian Pfitzer <florian.pfitzer@topalis.com>
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class MenuItem implements MenuItemInterface
{
    protected $link;
    protected $text;
    protected $icon;

    public function __construct($link, $text, $icon = "")
    {
        $this->link = $link;
        $this->text = $text;
        $this->icon = $icon;
    }

    public function setLink($link)
    {
        $this->link = $link;

        return $this;
    }

    public function getLink()
    {
        return $this->link;
    }

    public function setText($text)
    {
        $this->text = $text;

        return $this;
    }

    public function getText()
    {
        return $this->text;
    }

    public function setIcon($icon)
    {
        $this->icon = $icon;

        return $this;
    }
    public function getIcon()
    {
        return $this->icon;
    }

    public function isActive(Request $request)
    {
        $routeName = $request->get("_route");
        return StringUtil::startsWith($routeName, $this->link);
    }

    public function getType()
    {
        return "item";
    }
}
