<?php
namespace Topalis\Profile;

use Topalis\Profile\Payload\AbstractPayload;
use Topalis\Profile\Payload\ProfileServicePayload;

// @codingStandardsIgnoreStart
/**
 * This class represents the "Profile Service" profile that is required during
 * OTA rollout.
 * @see https://developer.apple.com/library/ios/#documentation/NetworkingInternet/Conceptual/iPhoneOTAConfiguration/ConfigurationProfileExamples/ConfigurationProfileExamples.html#//apple_ref/doc/uid/TP40009505-CH4-SW4
 *
 * @author Dominic Tubach <dominic.tubach@topalis.com>
 */
// @codingStandardsIgnoreEnd
class ProfileServiceProfile extends AbstractProfile
{
    const TYPE = "Profile Service";

    public function setPayload(ProfileServicePayload $payload)
    {
        $this->clearPayloads();
        $this->regenerateUUIDs($payload->getDictionary(), true);
        AbstractPayload::set("PayloadContent", $payload->getDictionary());
        $this->payloads[] = $payload;
    }
}
