<?php
namespace Topalis\ReverseProxy\ConfigGroup;

use Topalis\ConfigGroup\ConfigGroupSectionInterface;

/**
 * @author Florian Pfitzer <florian.pfitzer@topalis.com>
 */
class ReverseProxySection implements ConfigGroupSectionInterface
{
    public function getCSS()
    {
        return "clear: left;";
    }

    public function getName()
    {
        return "secure_intranet";
    }

    public function getController()
    {
        return "TopalisReverseProxyBundle:ConfigGroup:index";
    }

    public function getTranslation()
    {
        return "admin.reverseProxy.title";
    }

    /**
     * @return string|null
     */
    public function getIcon()
    {
        return "globe";
    }

    /**
     * Route for this section
     *
     * @return string
     */
    public function getRoute()
    {
        return "admin_group_reverse_proxy";
    }
}
