<?php
namespace Topalis\System\DependencyInjection;

use Symfony\Component\Config\FileLocator;
use Symfony\Component\DependencyInjection\ContainerBuilder;
use Symfony\Component\DependencyInjection\Extension\Extension;
use Symfony\Component\DependencyInjection\Loader\YamlFileLoader;

/**
 *
 *
 * @author Dominic Tubach <dominic.tubach@topalis.com>
 */
class TopalisSystemExtension extends Extension
{
    public function load(array $configs, ContainerBuilder $container)
    {
        $configuration = $this->getConfiguration($configs, $container);
        $config = $this->processConfiguration($configuration, $configs);

        $container->setParameter("system.aliases_filename", $config['aliases_file']);
        $container->setParameter("system.clock_config_filename", $config['clock_config']);
        $container->setParameter("system.network_scripts_dir", $config['network_scripts_dir']);
        $container->setParameter("system.ntp_config_filename", $config['ntp_config']);
        $container->setParameter("system.time_zone_dir", $config['time_zone_dir']);
        $container->setParameter("system.postfix_main_config_filename", $config['postfix_main_config']);

        $loader = new YamlFileLoader($container, new FileLocator(__DIR__."/../Resources/config"));
        $loader->load("services.yml");
    }
}
