<?php
namespace Topalis\System\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * TimeConfigForm
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class TimeConfigForm extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $options; // unused
        $builder
            ->add("ntpServers", "text", array(
                "label" => "admin.global.ntpServer",
                "description" => "admin.global.ntpServerDescription",
                "constraints" => new Assert\NotBlank()
            ))
            ->add("timeZone", "timezone", array(
                "label" => "admin.global.timeZone",
                "required" => true
            ))
        ;
    }

    /**
     * Returns the name of this type.
     *
     * @return string The name of this type
     */
    public function getName()
    {
        return "time";
    }
}
