<?php
namespace Topalis\System\Validator;

use Symfony\Component\Validator\Constraint;
use Symfony\Component\Validator\ConstraintValidator;
use Symfony\Component\Validator\Exception\UnexpectedTypeException;

/**
 * Validates netmasks
 *
 * @author Florian Pfitzer <florian.pfitzer@topalis.com>
 */
class NetmaskValidator extends ConstraintValidator
{
    public function validate($value, Constraint $constraint)
    {
        /** @var $constraint Netmask */
        if (null === $value || '' === $value) {
            return;
        }

        if (!is_scalar($value) && !(is_object($value) && method_exists($value, '__toString'))) {
            throw new UnexpectedTypeException($value, 'string');
        }

        if (!in_array($value, $constraint->netmasks)) {
            $this->context->addViolation($constraint->message);
        }
    }

}
