<?php
namespace Topalis\Test\Log;

use Monolog\Logger;
use Monolog\Handler\StreamHandler;

/**
 * The ConsoleLogger can be used in test cases as logger.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class ConsoleLogger extends Logger
{
    /**
     * Constructor.
     *
     * @param string $name The logging channel. (Default: console)
     * @param boolean $stderr true to log to stderr, otherwise stdout is used.
     *     (Default: false)
     * @param array $processors Optional array of processors.
     */
    public function __construct($name = "console", $stderr = false, array $processors = array())
    {
        $handler = new StreamHandler($stderr ? "php://stderr" : "php://stdout");
        parent::__construct($name, array($handler), $processors);
    }
}
