<?php
namespace Topalis\Test;

use Topalis\Kernel\AbstractTimeProvider;

/**
 * The TestTimeProvider allows to use a specific time instead of the current
 * system time.
 *
 * @author Dominic Tubach <dominic.tubach@topalis.com>
 */
class TestTimeProvider extends AbstractTimeProvider
{
    private $time;

    public function __construct($time)
    {
        $this->time = $time;
    }

    public function getTime()
    {
        return $this->time;
    }

    public function setTime($time)
    {
        if (is_string($time)) {
            $time = strtotime($time);
        }
        $this->time = $time;
    }

}
