<?php
namespace Topalis\Update\Command;

use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * This class contains methods to perform the update to version 2.5.7
 *
 * @author Dominic Tubach <dominic.tubach@topalis.com>
 */
class UpdateHelper020507
{
    /**
     * @var ContainerInterface
     */
    private $container;

    public function __construct(ContainerInterface $container)
    {
        $this->container = $container;
    }

    /**
     * Install Wifi profiles on Android and ios devices because it was not done
     * on rollout.
     */
    public function installWifiProfiles()
    {
        $mdmAdmin = $this->container->get("mdm.admin");
        foreach ($mdmAdmin->getActiveManagedDevices() as $device) {
            $mdmAdmin->installWifiProfile($device);
        }
    }
}
