<?php
namespace Topalis\User\DependencyInjection;

use Symfony\Component\Config\Definition\Builder\TreeBuilder;
use Symfony\Component\Config\Definition\ConfigurationInterface;

/**
 * @author Dominic Tubach <dominic.tubach@topalis.com>
 */
class Configuration implements ConfigurationInterface
{

    /**
     * Generates the configuration tree builder.
     *
     * @return \Symfony\Component\Config\Definition\Builder\TreeBuilder The tree builder
     */
    public function getConfigTreeBuilder()
    {
        $treeBuilder = new TreeBuilder();
        $rootNode = $treeBuilder->root("user");
        $rootNode
            ->children()
                ->scalarNode("ldap_import_limit")->defaultValue(250)->end()
            ->end()
        ;

        return $treeBuilder;
    }
}
