<?php
namespace Topalis\User\Form\Type;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;
use Topalis\User\Entity\UserEntityManager;
use Topalis\User\Form\Transformer\UserTransformer;

/**
 * @author Florian Pfitzer <florian.pfitzer@topalis.com>
 */
class UserSelectType extends AbstractType
{
    /**
     * @var \Topalis\User\Entity\UserEntityManager
     */
    private $userManager;

    public function __construct(UserEntityManager $userManager)
    {
        $this->userManager = $userManager;
    }

    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $options; // unused
        $builder->addModelTransformer(new UserTransformer($this->userManager));
    }

    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(array(
            'error_bubbling' => false,
        ));
    }

    public function getParent()
    {
        return "genemu_jqueryselect2_hidden";
    }

    /**
     * Returns the name of this type.
     * @return string The name of this type
     */
    public function getName()
    {
        return "user_select";
    }
}
