<?php
namespace Topalis\Util\Exception\Process;

class ExecException extends \Exception
{
    private $cmd;
    private $messageContainsOutput = false;
    private $output;
    private $returnCode;

    public function __construct($cmd, $output, $returnCode, $message = null, $code = null)
    {
        $this->cmd = $cmd;
        $this->output = $output;
        $this->returnCode = $returnCode;
        if ($message === null) {
            if ($returnCode === false) {
                $message = "Could not execute '$cmd'";
            } else {
                $message = "Error executing '$cmd' (status $returnCode)";
                if (strlen($output < 100)) {
                    $message .= ": $output";
                    $this->messageContainsOutput = true;
                }
            }
        }
        parent::__construct($message, $code);
    }

    public function getCmd()
    {
        return $this->cmd;
    }

    public function getOutput()
    {
        return $this->output;
    }

    public function getReturnCode()
    {
        return $this->returnCode;
    }

    public function isMessageContainsOutput()
    {
        return $this->messageContainsOutput;
    }
}
