<?php
namespace Topalis\WebClip\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;
use Symfony\Component\Validator\Constraints as Assert;
use Topalis\ReverseProxy\Form\ReverseProxyUrlForm;
use Topalis\ReverseProxy\Validator\SimpleUrl;

/**
 *
 *
 * @author Florian Pfitzer <pfitzer@w3p.cc>
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class WebClipForm extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $options; // unused
        $builder
            ->remove("externalPath")
            ->remove("internalPath")
            ->remove("useRemoteProxy")
            ->remove("visible")
        ;

        $builder
            ->add("url", "url", array(
                "label" => "admin.webClip.url",
                "constraints" => array(new Assert\NotBlank(), new SimpleUrl())
            ))
        ;
    }

    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(array(
            "data_class" => "Topalis\WebClip\Entity\WebClip",
            "constraints" => array(),
        ));
    }

    public function getParent()
    {
        // TODO this should be the other way around
        return new ReverseProxyUrlForm(null);
    }

    public function getName()
    {
        return "web_clip";
    }
}
