<?php
namespace Topalis\WinPhone\Controller;

use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Topalis\Kernel\Controller;
use Topalis\WinPhone\Xcep\XcepServer;
use Topalis\WinPhone\Soap\SoapResponse;

/**
 * This controller provides the certificate enrollment policy service for
 * Windows Phone.
 *
 * @author Dominic Tubach <dominic.tubach@topalis.com>
 *
 * @Route("/EnrollmentServer/CertificatePolicy.svc", service="winphone.controller.certificatePolicy")
 */
class CertificatePolicyController extends Controller
{
    private function getSoapServer()
    {
        $server = new XcepServer();
        $server->setContainer($this->container);
        return $server;
    }

    /**
     * @Route("", name="win_get_policies", methods="POST")
     *
     * @return \Topalis\WinPhone\Soap\SoapResponse
     */
    public function getPoliciesAction()
    {
        $server = $this->getSoapServer();
        $content = $server->handle($this->getRequest()->getContent());
        $response = new SoapResponse($content);
        $response->headers->set("Content-Length", strlen($response->getContent()));

        return $response;
    }
}
