<?php
namespace Topalis\WinPhone\DependencyInjection;

use Symfony\Component\Config\Definition\Builder\TreeBuilder;
use Symfony\Component\Config\Definition\ConfigurationInterface;

/**
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class Configuration implements ConfigurationInterface
{

    /**
     * Generates the configuration tree builder.
     *
     * @return \Symfony\Component\Config\Definition\Builder\TreeBuilder The tree builder
     */
    public function getConfigTreeBuilder()
    {
        $treeBuilder = new TreeBuilder();
        $rootNode = $treeBuilder->root("winphone");
        $rootNode
            ->children()
                ->scalarNode("auxretryinterval")->defaultValue(3)->end()
                ->scalarNode("aux2retryinterval")->defaultValue(15)->end()
                ->scalarNode("interval_for_first_set_of_retries")->defaultValue(3)->end()
                ->scalarNode("number_of_first_retries")->defaultValue(3)->end()
                ->scalarNode("interval_for_second_set_of_retries")->defaultValue(15)->end()
                ->scalarNode("number_of_second_retries")->defaultValue(1)->end()
                ->scalarNode("interval_for_remaining_scheduled_retries")->defaultValue(15)->end()
                ->scalarNode("number_of_remaining_scheduled_retries")->defaultValue(0)->end()
            ->end()
        ;

        return $treeBuilder;
    }
}
