<?php
namespace Topalis\WinPhone\DependencyInjection;

use Symfony\Component\Config\FileLocator;
use Symfony\Component\DependencyInjection\ContainerBuilder;
use Symfony\Component\DependencyInjection\Extension\Extension;
use Symfony\Component\DependencyInjection\Loader\YamlFileLoader;

/**
 *
 * @author Dominic Tubach <dominic.tubach@topalis.com>
 *
 */
class TopalisWinPhoneExtension extends Extension
{
    public function load(array $configs, ContainerBuilder $container)
    {
        $configuration = $this->getConfiguration($configs, $container);
        $config = $this->processConfiguration($configuration, $configs);

        $container->setParameter("winphone.auxretryinterval", $config['auxretryinterval']);
        $container->setParameter("winphone.aux2retryinterval", $config['aux2retryinterval']);
        $container->setParameter("winphone.interval_for_first_set_of_retries",
            $config['interval_for_first_set_of_retries']);
        $container->setParameter("winphone.number_of_first_retries",
            $config['number_of_first_retries']);
        $container->setParameter("winphone.interval_for_second_set_of_retries",
            $config['interval_for_second_set_of_retries']);
        $container->setParameter("winphone.number_of_second_retries",
            $config['number_of_second_retries']);
        $container->setParameter("winphone.interval_for_remaining_scheduled_retries",
            $config['interval_for_remaining_scheduled_retries']);
        $container->setParameter("winphone.number_of_remaining_scheduled_retries",
            $config['number_of_remaining_scheduled_retries']);

        $loader = new YamlFileLoader($container, new FileLocator(__DIR__."/../Resources/config"));
        $loader->load("orm.yml");
        $loader->load("services.yml");
    }

}
