<?php
namespace Topalis\WinPhone\Discovery;

use Topalis\WinPhone\Soap\SoapServer;

/**
 * SOAP server that implements the Mobile Device Enrollment Protocol (MS-MDE).
 *
 * @see http://msdn.microsoft.com/en-us/library/dn409494.aspx
 * @author Dominic Tubach <dominic.tubach@topalis.com>
 */
class DiscoveryServer extends SoapServer
{
    private $enrollmentPolicyServiceUrl;

    private $enrollmentServiceUrl;

    public function __construct(array $options = null)
    {
        $wsdl = __DIR__ . "/../Resources/wsdl/discovery.wsdl";
        $options['classmap'] = array(
            "DiscoveryRequest" => "Topalis\\WinPhone\\Discovery\\Entity\\DiscoveryRequest",
            "DiscoveryResponse" => "Topalis\\WinPhone\\Discovery\\Entity\\DiscoveryResponse"
        );

        parent::__construct($wsdl, new DiscoveryService($this), $options);
    }

    public function getEnrollmentPolicyServiceUrl()
    {
        return $this->enrollmentPolicyServiceUrl;
    }

    public function setEnrollmentPolicyServiceUrl($enrollmentPolicyServiceUrl)
    {
        $this->enrollmentPolicyServiceUrl = $enrollmentPolicyServiceUrl;
    }

    public function getEnrollmentServiceUrl()
    {
        return $this->enrollmentServiceUrl;
    }

    public function setEnrollmentServiceUrl($enrollmentServiceUrl)
    {
        $this->enrollmentServiceUrl = $enrollmentServiceUrl;
    }
}
