<?php
namespace Topalis\WinPhone\Discovery;

use Topalis\WinPhone\Discovery\Entity\DiscoveryResponse;
use Topalis\WinPhone\Soap\SoapService;

/**
 * Implements the Mobile Device Enrollment Protocol (MS-MDE).
 *
 * @see http://msdn.microsoft.com/en-us/library/dn409494.aspx
 * @author Dominic Tubach <dominic.tubach@topalis.com>
 */
class DiscoveryService extends SoapService
{
    const ACTION =
        "http://schemas.microsoft.com/windows/management/2012/01/enrollment/IDiscoveryService/DiscoverResponse";
    const XMLNSA = "http://www.w3.org/2006/05/addressing";

    /*
     * Header begin
     */

    // @codingStandardsIgnoreStart
    public function Action($action)
    {
        // nothing to do
    }
    // @codingStandardsIgnoreEnd

    // @codingStandardsIgnoreStart
    public function MessageID($messageId)
    {
        $this->server->addSoapHeader(new \SoapHeader(self::XMLNSA, "RelatesTo", $messageId));
    }
    // @codingStandardsIgnoreEnd

    // @codingStandardsIgnoreStart
    public function ReplyTo($replyTo)
    {
        // noting to do
    }
    // @codingStandardsIgnoreEnd

    // @codingStandardsIgnoreStart
    public function To($to)
    {
        // nothing to do
    }
    // @codingStandardsIgnoreEnd

    /*
     * Header end
     */

    // @codingStandardsIgnoreStart
    public function Discover($request)
    {
        $request; // unused

        $this->addSoapHeader(new \SoapHeader(self::XMLNSA, "Action", self::ACTION, true));

        $result = new DiscoveryResponse();
        $result->setAuthPolicy("OnPremise");
        $result->setEnrollmentPolicyServiceUrl($this->server->getEnrollmentPolicyServiceUrl());
        $result->setEnrollmentServiceUrl($this->server->getEnrollmentServiceUrl());
        $response = new \stdClass();
        $response->DiscoverResult = $result;

        return $response;
    }
    // @codingStandardsIgnoreEnd
}
