<?php
namespace Topalis\WinPhone\MS;

use Topalis\Device\Entity\Device;

/**
 * An MSAppPolicyManager is used to get the app policy for a device.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
interface MSAppPolicyManagerInterface
{
    /**
     * @param Device $device
     *
     * @return MSAppPolicy The app policy for the specified device.
     */
    public function getPolicy(Device $device);

    /**
     * @param Device $device
     *
     * @return string The app policy for the specified device as XML.
     */
    public function getPolicyXml(Device $device);
}
