<?php
namespace Topalis\WinPhone\OMA\Provisioning;

class AppAddrCharacteristic extends Characteristic
{
    public function __construct()
    {
        parent::__construct("APPADDR");
    }

    public function getAddr()
    {
        return $this->getParmValue("ADDR");
    }

    public function setAddr($addr)
    {
        $this->setParmValue("ADDR", $addr);
    }

    public function getAddrType()
    {
        return $this->getParmValue("ADDRTYPE");
    }

    public function setAddrType($addrType)
    {
        $this->setParmValue("ADDRTYPE", $addrType);
    }

    public function getPort()
    {
        $characteristic = $this->getFirstCharacteristic("PORT");
        return $characteristic ? $characteristic->getParmValue("PORTNBR") : null;
    }

    public function setPort($port)
    {
        if ($port === null) {
            $this->clearCharacteristics("PORT");
        } else {
            $characteristic = new Characteristic("PORT");
            $characteristic->addParm(new Parm("PORTNBR", $port));
            $this->addOrReplaceCharacteristic($characteristic);
        }
    }
}
