<?php
namespace Topalis\WinPhone\OMA\Provisioning;

class CertificateCharacteristic extends Characteristic
{
    public function __construct()
    {
        parent::__construct(null);
    }

    public function getEncodedCertificate()
    {
        return $this->getParmValue("EncodedCertificate");
    }

    public function setEncodedCertificate($encodedCertificate)
    {
        $this->setParmValue("EncodedCertificate", $encodedCertificate);
        $this->setType(sha1(base64_decode($encodedCertificate)));
    }

    public function setCertificate($certificate)
    {
        $this->setParmValue("EncodedCertificate", base64_encode($certificate));
        $this->setType(sha1($certificate));
    }

    public function getIssuedBy()
    {
        return $this->getParmValue("IssuedBy");
    }

    public function setIssuedBy($issuedBy)
    {
        $this->setParmValue("IssuedBy", $issuedBy);
    }

    public function getIssuedTo()
    {
        return $this->getParmValue("IssuedTo");
    }

    public function setIssuedTo($issuedTo)
    {
        $this->setParmValue("IssuedTo", $issuedTo);
    }

    public function getValidFrom()
    {
        return $this->getParmValue("ValidFrom");
    }

    public function setValidFrom($validFrom)
    {
        $this->setParmValue("ValidFrom", $validFrom);
    }

    public function getValidTo()
    {
        return $this->getParmValue("ValidTo");
    }

    public function setValidTo($validTo)
    {
        $this->setParmValue("ValidTo", $validTo);
    }

    public function getTemplateName()
    {
        return $this->getParmValue("TemplateName");
    }

    public function setTemplateName($templateName)
    {
        $this->setParmValue("TemplateName", $templateName);
    }
}
