<?php
namespace Topalis\WinPhone\OMA\Provisioning;

class DMClientProvider extends ConfigurationServiceProvider
{
    /**
     * @var ProviderCharacteristic
     */
    private $provider;

    public function __construct()
    {
        parent::__construct("DMClient");
        $this->provider = new ProviderCharacteristic(null);
        parent::addCharacteristic($this->provider);
    }

    public function addCharacteristic(Characteristic $characteristic)
    {
        if ($characteristic instanceof ProviderCharacteristic) {
            $this->setProvider($characteristic);
        } else {
            throw new \InvalidArgumentException("The characteristic is not of type 'ProviderCharacteristic'");
        }
    }

    /**
     * @return ProviderCharacteristic
     */
    public function getProvider()
    {
        return $this->provider;
    }

    public function setProvider(ProviderCharacteristic $provider)
    {
        $this->removeCharacteristic($this->provider);
        parent::addCharacteristic($provider);
        $this->provider = $provider;
    }
}
