<?php
namespace Topalis\WinPhone\OMA\Provisioning;

/**
 * Poll characteristic for DMClient Provider in Provider characteristic.
 *
 * @author Dominic Tubach <dominic.tubach@to.com>
 * @see DMClient CSP in Windows Phone 8.1 MDM Protocol
 */
class PollCharacteristic extends Characteristic
{
    public function __construct()
    {
        parent::__construct("Poll");
    }

    public function getIntervalForFirstSetOfRetries()
    {
        return $this->getParmValue("IntervalForFirstSetOfRetries");
    }

    public function setIntervalForFirstSetOfRetries($intervalForFirstSetOfRetries)
    {
        $this->setParmValue("IntervalForFirstSetOfRetries", $intervalForFirstSetOfRetries, "integer");
    }

    public function getNumberOfFirstRetries()
    {
        return $this->getParmValue("NumberOfFirstRetries");
    }

    public function setNumberOfFirstRetries($numberOfFirstRetries)
    {
        $this->setParmValue("NumberOfFirstRetries", $numberOfFirstRetries, "integer");
    }

    public function getIntervalForSecondSetOfRetries()
    {
        return $this->getParmValue("IntervalForSecondSetOfRetries");
    }

    public function setIntervalForSecondSetOfRetries($intervalForSecondSetOfRetries)
    {
        $this->setParmValue("IntervalForSecondSetOfRetries", $intervalForSecondSetOfRetries, "integer");
    }

    public function getNumberOfSecondRetries()
    {
        return $this->getParmValue("NumberOfSecondRetries");
    }

    public function setNumberOfSecondRetries($numberOfSecondRetries)
    {
        $this->setParmValue("NumberOfSecondRetries", $numberOfSecondRetries, "integer");
    }

    public function getIntervalForRemainingScheduledRetries()
    {
        return $this->getParmValue("IntervalForRemainingScheduledRetries");
    }

    public function setIntervalForRemainingScheduledRetries($intervalForRemainingScheduledRetries)
    {
        $this->setParmValue("IntervalForRemainingScheduledRetries", $intervalForRemainingScheduledRetries, "integer");
    }

    public function getNumberOfRemainingScheduledRetries()
    {
        return $this->getParmValue("NumberOfRemainingScheduledRetries");
    }

    public function setNumberOfRemainingScheduledRetries($numberOfRemainingScheduledRetries)
    {
        $this->setParmValue("NumberOfRemainingScheduledRetries", $numberOfRemainingScheduledRetries, "integer");
    }
}
