<?php
namespace Topalis\WinPhone\OMA\Provisioning;

use Topalis\Profile\UUIDGenerator;

class ScepInstallCharacteristic extends Characteristic
{
    private $uidCharacteristic;
    private $installCharacteristic;

    public function __construct($uid = null)
    {
        parent::__construct("Scep");
        if ($uid == null) {
            $uuidGenerator = new UUIDGenerator();
            $uid = $uuidGenerator->generateUUID();
        }
        $this->uidCharacteristic = new Characteristic($uid);
        $this->installCharacteristic = new Characteristic("Install");
        $this->uidCharacteristic->addCharacteristic($this->installCharacteristic);
    }

    public function getUniqueId()
    {
        $this->uidCharacteristic->getType();
    }

    public function setUniqueId($uniqueId)
    {
        $this->uidCharacteristic->setType($uniqueId);
    }

    public function getServerURL()
    {
        return $this->installCharacteristic->getParmValue("ServerURL");
    }

    public function setServerURL($serverURL)
    {
        $this->installCharacteristic->setParmValue("ServerURL", $serverURL);
    }

    public function getChallenge()
    {
        return $this->installCharacteristic->getParmValue("Challenge");
    }

    public function setChallenge($challenge)
    {
        $this->installCharacteristic->setParmValue("Challenge", $challenge);
    }

    public function getRetryCount()
    {
        return $this->installCharacteristic->getParmValue("RetryCount");
    }

    public function setRetryCount($retryCount)
    {

    }
}
