<?php
namespace Topalis\WinPhone\OMA\SyncML\Entity\ConfigurationServiceProvider;

/**
 * Storage configuration service provider.
 *
 * @see Windows Phone 8 Enterprise Device Management Protocol
 * @author Dominic Tubach <dominic.tubach@to.com>
 */
class StorageCSP extends AbstractConfigurationServiceProvider
{
    public function __construct($cmdID = null)
    {
        parent::__construct($cmdID);
        $this->setLocURIPrefix("./Vendor/MSFT/Storage/");
        foreach ($this->getDefaults() as $locURI => $data) {
            $this->setData($locURI, $data);
        }
    }

    /**
     *
     * @return boolean true if external storage is disabled.
     */
    public function isDisabled()
    {
        return $this->isData("Disabled");
    }

    /**
     *
     * @param boolean $disabled true to disable external storage.
     */
    public function setDisabled($disabled)
    {
        $this->setData("Disabled", array("data" => $disabled ? "true" : "false", "format" => "bool"));
    }

    protected function getDefaults()
    {
        return array(
            "Disabled" => array("data" => "false", "format" => "bool"),
        );
    }
}
