<?php
namespace Topalis\WinPhone\OMA\SyncML\Entity;

class Search extends AbstractCommand
{

    /**
     *
     * @var boolean
     */
    protected $noResults;

    /**
     *
     * @var Cred
     */
    protected $cred;

    /**
     *
     * @var Target
     */
    protected $target;

    /**
     *
     * @var array
     */
    protected $sources = array();

    /**
     *
     * @var string
     */
    protected $lang;

    /**
     *
     * @var string
     */
    protected $data;

    /**
     *
     * @return boolean
     */
    public function isNoResults()
    {
        return $this->noResults;
    }

    /**
     *
     * @param boolean $noResults
     */
    public function setNoResults($noResults)
    {
        $this->noResults = $noResults;
        return $this;
    }

    /**
     *
     * @return Cred
     */
    public function getCred()
    {
        return $this->cred;
    }

    /**
     *
     * @param Cred $cred
     */
    public function setCred(Cred $cred)
    {
        $this->cred = $cred;
        return $this;
    }

    /**
     *
     * @return Target
     */
    public function getTarget()
    {
        return $this->target;
    }

    /**
     *
     * @param Target $target
     */
    public function setTarget(Target $target)
    {
        $this->target = $target;
        return $this;
    }

    public function addSource(Source $source)
    {
        $this->sources[] = $source;
    }

    /**
     *
     * @return array
     */
    public function getSources()
    {
        return $this->sources;
    }

    /**
     *
     * @param array $sources
     */
    public function setSources(array $sources)
    {
        $this->sources = $sources;
        return $this;
    }

    /**
     *
     * @return string
     */
    public function getLang()
    {
        return $this->lang;
    }

    /**
     *
     * @param string $lang
     */
    public function setLang($lang)
    {
        $this->lang = $lang;
        return $this;
    }

    /**
     *
     * @return string
     */
    public function getData()
    {
        return $this->data;
    }

    /**
     *
     * @param string $data
     */
    public function setData($data)
    {
        $this->data = $data;
        return $this;
    }
}
