<?php
namespace Topalis\WinPhone\OMA\SyncML\Entity;

class Status extends AbstractSyncMLElement
{

    /**
     *
     * @var string
     */
    protected $cmdID;

    /**
     *
     * @var string
     */
    protected $msgRef;

    /**
     *
     * @var string
     */
    protected $cmdRef;

    /**
     *
     * @var string
     */
    protected $cmd;

    /**
     *
     * @var array
     */
    protected $targetRefs = array();

    /**
     *
     * @var array
     */
    protected $sourceRefs = array();

    /**
     *
     * @var Cred
     */
    protected $cred;

    /**
     *
     * @var Chal
     */
    protected $chal;

    /**
     *
     * @var string
     */
    protected $data;

    /**
     *
     * @var array
     */
    protected $items = array();

    /**
     *
     * @return string
     */
    public function getCmdID()
    {
        return $this->cmdID;
    }

    /**
     *
     * @param string $cmdID
     */
    public function setCmdID($cmdID)
    {
        $this->cmdID = $cmdID;
        return $this;
    }

    /**
     *
     * @return string
     */
    public function getMsgRef()
    {
        return $this->msgRef;
    }

    /**
     *
     * @param string $msgRef
     */
    public function setMsgRef($msgRef)
    {
        $this->msgRef = $msgRef;
        return $this;
    }

    /**
     *
     * @return string
     */
    public function getCmdRef()
    {
        return $this->cmdRef;
    }

    /**
     *
     * @param string $cmdRef
     */
    public function setCmdRef($cmdRef)
    {
        $this->cmdRef = $cmdRef;
        return $this;
    }

    /**
     *
     * @return string
     */
    public function getCmd()
    {
        return $this->cmd;
    }

    /**
     *
     * @param string $cmd
     */
    public function setCmd($cmd)
    {
        $this->cmd = $cmd;
        return $this;
    }

    /**
     *
     * @param string $targetRef
     */
    public function addTargetRef($targetRef)
    {
        $this->targetRefs[] = $targetRef;
        return $this;
    }

    /**
     *
     * @param int $index
     * @return string|NULL
     */
    public function getTargetRef($index)
    {
        return isset($this->targetRefs[$index]) ? $this->targetRefs[$index] : null;
    }

    /**
     *
     * @return array
     */
    public function getTargetRefs()
    {
        return $this->targetRefs;
    }

    /**
     *
     * @param array $targetRefs
     */
    public function setTargetRefs(array $targetRefs)
    {
        $this->targetRefs = $targetRefs;
        return $this;
    }

    /**
     *
     * @param string $sourceRef
     */
    public function addSourceRef($sourceRef)
    {
        $this->sourceRefs[] = $sourceRef;
        return $this;
    }

    /**
     *
     * @return array
     */
    public function getSourceRefs()
    {
        return $this->sourceRefs;
    }

    /**
     *
     * @param array $sourceRefs
     */
    public function setSourceRefs(array $sourceRefs)
    {
        $this->sourceRefs = $sourceRefs;
        return $this;
    }

    /**
     *
     * @return Cred
     */
    public function getCred()
    {
        return $this->cred;
    }

    /**
     *
     * @param Cred $cred
     */
    public function setCred(Cred $cred)
    {
        $this->cred = $cred;
        return $this;
    }

    /**
     *
     * @return Chal
     */
    public function getChal()
    {
        return $this->chal;
    }

    /**
     *
     * @param Chal $chal
     */
    public function setChal(Chal $chal)
    {
        $this->chal = $chal;
        return $this;
    }

    /**
     *
     * @return string
     */
    public function getData()
    {
        return $this->data;
    }

    /**
     *
     * @param string $data
     */
    public function setData($data)
    {
        $this->data = $data;
        return $this;
    }

    /**
     *
     * @param Item $item
     */
    public function addItem(Item $item)
    {
        $this->items = $item;
        return $this;
    }

    /**
     *
     * @return array
     */
    public function getItems()
    {
        return $this->items;
    }

    /**
     *
     * @param array $items
     */
    public function setItems(array $items)
    {
        $this->items = $items;
        return $this;
    }
}
