<?php
namespace Topalis\WinPhone\OMA\SyncML\Entity;

class SyncBody extends AbstractSyncMLElement
{
    /**
     *
     * @var array
     */
    protected $statusList = array();

    /**
     *
     * @var array
     */
    protected $resultsList = array();

    /**
     *
     * @var array
     */
    protected $commands = array();

    /**
     *
     * @var boolean
     */
    protected $final;

    /**
     *
     * @param AbstractCommand $command
     */
    public function addCommand(AbstractCommand $command)
    {
        $this->commands[] = $command;
    }

    /**
     *
     * @return array
     */
    public function getCommands()
    {
        return $this->commands;
    }

    /**
     *
     * @param array $commands
     */
    public function setCommands(array $commands)
    {
        $this->commands = $commands;
        return $this;
    }

    public function addAlert(Alert $alert)
    {
        $this->addCommand($alert);
    }

    public function addAtomic(Atomic $atomic)
    {
        $this->addCommand($atomic);
    }

    public function addCopy(Copy $copy)
    {
        $this->addCommand($copy);
    }

    public function addExec(Exec $exec)
    {
        $this->addCommand($exec);
    }

    public function addGet(Get $get)
    {
        $this->addCommand($get);
    }

    public function addPut(Put $put)
    {
        $this->addCommand($put);
    }

    public function addSearch(Search $search)
    {
        $this->addCommand($search);
    }

    public function addSequence(Sequence $sequence)
    {
        $this->addCommand($sequence);
    }

    public function addSync(Sync $sync)
    {
        $this->addCommand($sync);
    }

    public function addAdd(Add $add)
    {
        $this->addCommand($add);
    }

    public function addMove(Move $move)
    {
        $this->addCommand($move);
    }

    public function addReplace(Replace $replace)
    {
        $this->addCommand($replace);
    }

    // @codingStandardsIgnoreStart
    // ignore rule Generic.PHP.ForbiddenFunctions.FoundWithAlternative
    public function addDelete(Delete $delete)
    {
        $this->addCommand($delete);
    }
    // @codingStandardsIgnoreEnd

    /**
     *
     * @param Results $results
     */
    public function addResults(Results $results)
    {
        $this->resultsList[] = $results;
        return $this;
    }

    /**
     *
     * @return array
     */
    public function getResultsList()
    {
        return $this->resultsList;
    }

    /**
     *
     * @param array $resultsList
     */
    public function setResultsList(array $resultsList)
    {
        $this->resultsList = $resultsList;
        return $this;
    }

    /**
     *
     * @param Status $status
     */
    public function addStatus(Status $status)
    {
        $this->statusList[] = $status;
        return $this;
    }

    /**
     *
     * @return array
     */
    public function getStatusList()
    {
        return $this->statusList;
    }

    /**
     *
     * @param array $statusList
     */
    public function setStatusList(array $statusList)
    {
        $this->statusList = $statusList;
        return $this;
    }

    /**
     *
     * @return boolean
     */
    public function isFinal()
    {
        return $this->final;
    }

    /**
     *
     * @param boolean $final
     */
    public function setFinal($final)
    {
        $this->final = $final;
        return $this;
    }
}
