<?php
namespace Topalis\WinPhone\OMA\SyncML\Entity;

class SyncML extends AbstractSyncMLElement
{

    /**
     *
     * @var SyncHdr
     */
    protected $syncHdr;

    /**
     *
     * @var SyncBody
     */
    protected $syncBody;

    /**
     *
     * @return SyncHdr
     */
    public function getSyncHdr()
    {
        return $this->syncHdr;
    }

    /**
     *
     * @param SyncHdr $syncHdr
     */
    public function setSyncHdr(SyncHdr $syncHdr)
    {
        $this->syncHdr = $syncHdr;
        return $this;
    }

    /**
     *
     * @return SyncBody
     */
    public function getSyncBody()
    {
        return $this->syncBody;
    }

    /**
     *
     * @param SyncBody $syncBody
     */
    public function setSyncBody(SyncBody $syncBody)
    {
        $this->syncBody = $syncBody;
        return $this;
    }

    public function toXml($formatted = false)
    {
        $doc = new \DOMDocument();
        $this->appendToDOM($doc);
        $doc->documentElement->setAttribute("xmlns", "SYNCML:SYNCML1.2");

        if ($formatted) {
            $doc->formatOutput = true;
        } else {
            $doc->preserveWhiteSpace = false;
        }

        return $doc->saveXML();
    }
}
