<?php
namespace Topalis\WinPhone\Wstep\Entity;

/**
 * This class stands for Claim originally named ClaimType
 * Meta informations extracted from the WSDL
 * - from schema : {@link http://schemas.xmlsoap.org/ws/2006/12/authorization/ws-authorization.xsd}
 * @date 2013-12-03
 */
class Claim
{
    /**
     * The Value
     * Meta informations extracted from the WSDL
     * - maxOccurs : 1
     * - minOccurs : 1
     * @var string
     */
    public $Value;
    /**
     * The Uri
     * Meta informations extracted from the WSDL
     * - use : required
     * @var anyURI
     */
    public $Uri;
    /**
     * The any
     * @var DOMDocument
     */
    public $any;
    /**
     * The Optional
     * Meta informations extracted from the WSDL
     * - use : optional
     * @var boolean
     */
    public $Optional;
    /**
     * Constructor method for ClaimType
     * @uses Claim::setValue()
     * @uses Claim::setUri()
     * @uses Claim::setAny()
     * @uses Claim::setOptional()
     * @param  string      $_value
     * @param  anyURI      $_uri
     * @param  DOMDocument $_any
     * @param  boolean     $_optional
     * @return Claim
     */
    public function __construct($_value, $_uri, $_any = null, $_optional = null)
    {
        $this->setValue($_value);
        $this->setUri($_uri);
        $this->setAny($_any);
        $this->setOptional($_optional);
    }
    /**
     * Get Value value
     * @return string
     */
    public function getValue()
    {
        return $this->Value;
    }
    /**
     * Set Value value
     * @param  string $_value the Value
     * @return string
     */
    public function setValue($_value)
    {
        return ($this->Value = $_value);
    }
    /**
     * Get Uri value
     * @return anyURI
     */
    public function getUri()
    {
        return $this->Uri;
    }
    /**
     * Set Uri value
     * @param  anyURI $_uri the Uri
     * @return anyURI
     */
    public function setUri($_uri)
    {
        return ($this->Uri = $_uri);
    }
    /**
     * Get any value
     * @uses DOMDocument::loadXML()
     * @uses DOMDocument::hasChildNodes()
     * @uses DOMDocument::saveXML()
     * @uses DOMNode::item()
     * @uses Claim::setAny()
     * @param bool true or false whether to return XML value as string or as DOMDocument
     * @return DOMDocument|null
     */
    public function getAny($_asString = true)
    {
        if (!empty($this->any) && !($this->any instanceof DOMDocument)) {
            $dom = new \DOMDocument('1.0', 'UTF-8');
            $dom->formatOutput = true;
            if ($dom->loadXML($this->any)) {
                $this->setAny($dom);
            }
            unset($dom);
        }

        return ($_asString && ($this->any instanceof DOMDocument)
            && $this->any->hasChildNodes()) ? $this->any->saveXML($this->any->childNodes->item(0)) : $this->any;
    }
    /**
     * Set any value
     * @param  DOMDocument $_any the any
     * @return DOMDocument
     */
    public function setAny($_any)
    {
        return ($this->any = $_any);
    }
    /**
     * Get Optional value
     * @return boolean|null
     */
    public function getOptional()
    {
        return $this->Optional;
    }
    /**
     * Set Optional value
     * @param  boolean $_optional the Optional
     * @return boolean
     */
    public function setOptional($_optional)
    {
        return ($this->Optional = $_optional);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
