<?php
namespace Topalis\WinPhone\Wstep\Entity;

/**
 * This class stands for Claims originally named ClaimsType
 * Meta informations extracted from the WSDL
 * - from schema : ws-trust-1.3.xsd
 * @date 2013-12-03
 */
class Claims
{
    /**
     * The any
     * @var DOMDocument
     */
    public $any;
    /**
     * The Dialect
     * Meta informations extracted from the WSDL
     * - use : optional
     * @var anyURI
     */
    public $Dialect;
    /**
     * Constructor method for ClaimsType
     * @uses Claims::setAny()
     * @uses Claims::setDialect()
     * @param  DOMDocument $_any
     * @param  anyURI      $_dialect
     * @return Claims
     */
    public function __construct($_any = null, $_dialect = null)
    {
        $this->setAny($_any);
        $this->setDialect($_dialect);
    }
    /**
     * Get any value
     * @uses DOMDocument::loadXML()
     * @uses DOMDocument::hasChildNodes()
     * @uses DOMDocument::saveXML()
     * @uses DOMNode::item()
     * @uses Claims::setAny()
     * @param bool true or false whether to return XML value as string or as DOMDocument
     * @return DOMDocument|null
     */
    public function getAny($_asString = true)
    {
        if (!empty($this->any) && !($this->any instanceof DOMDocument)) {
            $dom = new \DOMDocument('1.0', 'UTF-8');
            $dom->formatOutput = true;
            if ($dom->loadXML($this->any)) {
                $this->setAny($dom);
            }
            unset($dom);
        }

        return ($_asString && ($this->any instanceof DOMDocument)
            && $this->any->hasChildNodes()) ? $this->any->saveXML($this->any->childNodes->item(0)) : $this->any;
    }
    /**
     * Set any value
     * @param  DOMDocument $_any the any
     * @return DOMDocument
     */
    public function setAny($_any)
    {
        return ($this->any = $_any);
    }
    /**
     * Get Dialect value
     * @return anyURI|null
     */
    public function getDialect()
    {
        return $this->Dialect;
    }
    /**
     * Set Dialect value
     * @param  anyURI $_dialect the Dialect
     * @return anyURI
     */
    public function setDialect($_dialect)
    {
        return ($this->Dialect = $_dialect);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
