<?php
namespace Topalis\WinPhone\Wstep\Entity;

/**
 * This class stands for Embedded originally named EmbeddedType
 * Documentation : This type represents a reference to an embedded security token.
 * Meta informations extracted from the WSDL
 * - from schema : oasis-200401-wss-wssecurity-secext-1.0.xsd
 * @date 2013-12-03
 */
class Embedded
{
    /**
     * The any
     * @var DOMDocument
     */
    public $any;
    /**
     * The ValueType
     * @var anyURI
     */
    public $ValueType;
    /**
     * Constructor method for EmbeddedType
     * @uses Embedded::setAny()
     * @uses Embedded::setValueType()
     * @param  DOMDocument $_any
     * @param  anyURI      $_valueType
     * @return Embedded
     */
    public function __construct($_any = null, $_valueType = null)
    {
        $this->setAny($_any);
        $this->setValueType($_valueType);
    }
    /**
     * Get any value
     * @uses DOMDocument::loadXML()
     * @uses DOMDocument::hasChildNodes()
     * @uses DOMDocument::saveXML()
     * @uses DOMNode::item()
     * @uses Embedded::setAny()
     * @param bool true or false whether to return XML value as string or as DOMDocument
     * @return DOMDocument|null
     */
    public function getAny($_asString = true)
    {
        if (!empty($this->any) && !($this->any instanceof DOMDocument)) {
            $dom = new \DOMDocument('1.0', 'UTF-8');
            $dom->formatOutput = true;
            if ($dom->loadXML($this->any)) {
                $this->setAny($dom);
            }
            unset($dom);
        }

        return ($_asString && ($this->any instanceof DOMDocument)
            && $this->any->hasChildNodes()) ? $this->any->saveXML($this->any->childNodes->item(0)) : $this->any;
    }
    /**
     * Set any value
     * @param  DOMDocument $_any the any
     * @return DOMDocument
     */
    public function setAny($_any)
    {
        return ($this->any = $_any);
    }
    /**
     * Get ValueType value
     * @return anyURI|null
     */
    public function getValueType()
    {
        return $this->ValueType;
    }
    /**
     * Set ValueType value
     * @param  anyURI $_valueType the ValueType
     * @return anyURI
     */
    public function setValueType($_valueType)
    {
        return ($this->ValueType = $_valueType);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
