<?php
namespace Topalis\WinPhone\Wstep\Entity;

/**
 * This class stands for EndpointReference originally named EndpointReferenceType
 * Meta informations extracted from the WSDL
 * - from schema : ws-addr.xsd
 * @date 2013-12-03
 */
class EndpointReference
{
    /**
     * The Address
     * @var AttributedURI
     */
    public $Address;
    /**
     * The ReferenceParameters
     * @var ReferenceParameters
     */
    public $ReferenceParameters;
    /**
     * The Metadata
     * @var Metadata
     */
    public $Metadata;
    /**
     * The any
     * @var DOMDocument
     */
    public $any;
    /**
     * Constructor method for EndpointReferenceType
     * @uses EndpointReference::setAddress()
     * @uses EndpointReference::setReferenceParameters()
     * @uses EndpointReference::setMetadata()
     * @uses EndpointReference::setAny()
     * @param  AttributedURI       $_address
     * @param  ReferenceParameters $_referenceParameters
     * @param  Metadata            $_metadata
     * @param  DOMDocument         $_any
     * @return EndpointReference
     */
    public function __construct($_address = null, $_referenceParameters = null, $_metadata = null, $_any = null)
    {
        $this->setAddress($_address);
        $this->setReferenceParameters($_referenceParameters);
        $this->setMetadata($_metadata);
        $this->setAny($_any);
    }
    /**
     * Get Address value
     * @return AttributedURI|null
     */
    public function getAddress()
    {
        return $this->Address;
    }
    /**
     * Set Address value
     * @param  AttributedURI $_address the Address
     * @return AttributedURI
     */
    public function setAddress($_address)
    {
        return ($this->Address = $_address);
    }
    /**
     * Get ReferenceParameters value
     * @return ReferenceParameters|null
     */
    public function getReferenceParameters()
    {
        return $this->ReferenceParameters;
    }
    /**
     * Set ReferenceParameters value
     * @param  ReferenceParameters $_referenceParameters the ReferenceParameters
     * @return ReferenceParameters
     */
    public function setReferenceParameters($_referenceParameters)
    {
        return ($this->ReferenceParameters = $_referenceParameters);
    }
    /**
     * Get Metadata value
     * @return Metadata|null
     */
    public function getMetadata()
    {
        return $this->Metadata;
    }
    /**
     * Set Metadata value
     * @param  Metadata $_metadata the Metadata
     * @return Metadata
     */
    public function setMetadata($_metadata)
    {
        return ($this->Metadata = $_metadata);
    }
    /**
     * Get any value
     * @uses DOMDocument::loadXML()
     * @uses DOMDocument::hasChildNodes()
     * @uses DOMDocument::saveXML()
     * @uses DOMNode::item()
     * @uses EndpointReference::setAny()
     * @param bool true or false whether to return XML value as string or as DOMDocument
     * @return DOMDocument|null
     */
    public function getAny($_asString = true)
    {
        if (!empty($this->any) && !($this->any instanceof DOMDocument)) {
            $dom = new \DOMDocument('1.0', 'UTF-8');
            $dom->formatOutput = true;
            if ($dom->loadXML($this->any)) {
                $this->setAny($dom);
            }
            unset($dom);
        }

        return ($_asString && ($this->any instanceof DOMDocument)
            && $this->any->hasChildNodes()) ? $this->any->saveXML($this->any->childNodes->item(0)) : $this->any;
    }
    /**
     * Set any value
     * @param  DOMDocument $_any the any
     * @return DOMDocument
     */
    public function setAny($_any)
    {
        return ($this->any = $_any);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
