<?php
namespace Topalis\WinPhone\Wstep\Entity;

/**
 * This class stands for FaultcodeEnum originally named FaultcodeEnum
 * Meta informations extracted from the WSDL
 * - from schema : oasis-200401-wss-wssecurity-secext-1.0.xsd
 * @date 2013-12-03
 */
class FaultcodeEnum
{
    /**
     * Constant for value 'wsse:UnsupportedSecurityToken'
     * @return string 'wsse:UnsupportedSecurityToken'
     */
    const VALUE_WSSE_UNSUPPORTEDSECURITYTOKEN = 'wsse:UnsupportedSecurityToken';
    /**
     * Constant for value 'wsse:UnsupportedAlgorithm'
     * @return string 'wsse:UnsupportedAlgorithm'
     */
    const VALUE_WSSE_UNSUPPORTEDALGORITHM = 'wsse:UnsupportedAlgorithm';
    /**
     * Constant for value 'wsse:InvalidSecurity'
     * @return string 'wsse:InvalidSecurity'
     */
    const VALUE_WSSE_INVALIDSECURITY = 'wsse:InvalidSecurity';
    /**
     * Constant for value 'wsse:InvalidSecurityToken'
     * @return string 'wsse:InvalidSecurityToken'
     */
    const VALUE_WSSE_INVALIDSECURITYTOKEN = 'wsse:InvalidSecurityToken';
    /**
     * Constant for value 'wsse:FailedAuthentication'
     * @return string 'wsse:FailedAuthentication'
     */
    const VALUE_WSSE_FAILEDAUTHENTICATION = 'wsse:FailedAuthentication';
    /**
     * Constant for value 'wsse:FailedCheck'
     * @return string 'wsse:FailedCheck'
     */
    const VALUE_WSSE_FAILEDCHECK = 'wsse:FailedCheck';
    /**
     * Constant for value 'wsse:SecurityTokenUnavailable'
     * @return string 'wsse:SecurityTokenUnavailable'
     */
    const VALUE_WSSE_SECURITYTOKENUNAVAILABLE = 'wsse:SecurityTokenUnavailable';
    /**
     * Return true if value is allowed
     * @uses self::VALUE_WSSE_UNSUPPORTEDSECURITYTOKEN
     * @uses self::VALUE_WSSE_UNSUPPORTEDALGORITHM
     * @uses self::VALUE_WSSE_INVALIDSECURITY
     * @uses self::VALUE_WSSE_INVALIDSECURITYTOKEN
     * @uses self::VALUE_WSSE_FAILEDAUTHENTICATION
     * @uses self::VALUE_WSSE_FAILEDCHECK
     * @uses self::VALUE_WSSE_SECURITYTOKENUNAVAILABLE
     * @param  mixed $_value value
     * @return bool  true|false
     */
    public static function valueIsValid($_value)
    {
        return in_array($_value, array(
            self::VALUE_WSSE_UNSUPPORTEDSECURITYTOKEN,
            self::VALUE_WSSE_UNSUPPORTEDALGORITHM,
            self::VALUE_WSSE_INVALIDSECURITY,
            self::VALUE_WSSE_INVALIDSECURITYTOKEN,
            self::VALUE_WSSE_FAILEDAUTHENTICATION,
            self::VALUE_WSSE_FAILEDCHECK,
            self::VALUE_WSSE_SECURITYTOKENUNAVAILABLE));
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
