<?php
namespace Topalis\WinPhone\Wstep\Entity;

/**
 * This class stands for Manifest originally named ManifestType
 * Meta informations extracted from the WSDL
 * - from schema : xmldsig-core-schema.xsd
 * @date 2013-12-03
 */
class Manifest
{
    /**
     * The Reference
     * @var Reference
     */
    public $Reference;
    /**
     * The Id
     * Meta informations extracted from the WSDL
     * - use : optional
     * @var ID
     */
    public $Id;
    /**
     * Constructor method for ManifestType
     * @uses Manifest::setReference()
     * @uses Manifest::setId()
     * @param  Reference $_reference
     * @param  ID        $_id
     * @return Manifest
     */
    public function __construct($_reference = null, $_id = null)
    {
        $this->setReference($_reference);
        $this->setId($_id);
    }
    /**
     * Get Reference value
     * @return Reference|null
     */
    public function getReference()
    {
        return $this->Reference;
    }
    /**
     * Set Reference value
     * @param  Reference $_reference the Reference
     * @return Reference
     */
    public function setReference($_reference)
    {
        return ($this->Reference = $_reference);
    }
    /**
     * Get Id value
     * @return ID|null
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param  ID $_id the Id
     * @return ID
     */
    public function setId($_id)
    {
        return ($this->Id = $_id);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
