<?php
namespace Topalis\WinPhone\Wstep\Entity;

/**
 * This class stands for Object originally named ObjectType
 * Meta informations extracted from the WSDL
 * - from schema : xmldsig-core-schema.xsd
 * @date 2013-12-03
 */
class Object
{
    /**
     * The any
     * @var DOMDocument
     */
    public $any;
    /**
     * The Id
     * Meta informations extracted from the WSDL
     * - use : optional
     * @var ID
     */
    public $Id;
    /**
     * The MimeType
     * Meta informations extracted from the WSDL
     * - use : optional
     * @var string
     */
    public $MimeType;
    /**
     * The Encoding
     * Meta informations extracted from the WSDL
     * - use : optional
     * @var anyURI
     */
    public $Encoding;
    /**
     * Constructor method for ObjectType
     * @uses Object::setAny()
     * @uses Object::setId()
     * @uses Object::setMimeType()
     * @uses Object::setEncoding()
     * @param  DOMDocument $_any
     * @param  ID          $_id
     * @param  string      $_mimeType
     * @param  anyURI      $_encoding
     * @return Object
     */
    public function __construct($_any = null, $_id = null, $_mimeType = null, $_encoding = null)
    {
        $this->setAny($_any);
        $this->setId($_id);
        $this->setMimeType($_mimeType);
        $this->setEncoding($_encoding);
    }
    /**
     * Get any value
     * @uses DOMDocument::loadXML()
     * @uses DOMDocument::hasChildNodes()
     * @uses DOMDocument::saveXML()
     * @uses DOMNode::item()
     * @uses Object::setAny()
     * @param bool true or false whether to return XML value as string or as DOMDocument
     * @return DOMDocument|null
     */
    public function getAny($_asString = true)
    {
        if (!empty($this->any) && !($this->any instanceof DOMDocument)) {
            $dom = new \DOMDocument('1.0', 'UTF-8');
            $dom->formatOutput = true;
            if ($dom->loadXML($this->any)) {
                $this->setAny($dom);
            }
            unset($dom);
        }

        return ($_asString && ($this->any instanceof DOMDocument)
            && $this->any->hasChildNodes()) ? $this->any->saveXML($this->any->childNodes->item(0)) : $this->any;
    }
    /**
     * Set any value
     * @param  DOMDocument $_any the any
     * @return DOMDocument
     */
    public function setAny($_any)
    {
        return ($this->any = $_any);
    }
    /**
     * Get Id value
     * @return ID|null
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param  ID $_id the Id
     * @return ID
     */
    public function setId($_id)
    {
        return ($this->Id = $_id);
    }
    /**
     * Get MimeType value
     * @return string|null
     */
    public function getMimeType()
    {
        return $this->MimeType;
    }
    /**
     * Set MimeType value
     * @param  string $_mimeType the MimeType
     * @return string
     */
    public function setMimeType($_mimeType)
    {
        return ($this->MimeType = $_mimeType);
    }
    /**
     * Get Encoding value
     * @return anyURI|null
     */
    public function getEncoding()
    {
        return $this->Encoding;
    }
    /**
     * Set Encoding value
     * @param  anyURI $_encoding the Encoding
     * @return anyURI
     */
    public function setEncoding($_encoding)
    {
        return ($this->Encoding = $_encoding);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
