<?php
namespace Topalis\WinPhone\Wstep\Entity;

/**
 * This class stands for Participants originally named ParticipantsType
 * Meta informations extracted from the WSDL
 * - from schema : ws-trust-1.3.xsd
 * @date 2013-12-03
 */
class Participants
{
    /**
     * The Primary
     * Meta informations extracted from the WSDL
     * - minOccurs : 0
     * @var Participant
     */
    public $Primary;
    /**
     * The Participant
     * Meta informations extracted from the WSDL
     * - maxOccurs : unbounded
     * - minOccurs : 0
     * @var Participant
     */
    public $Participant;
    /**
     * The any
     * @var DOMDocument
     */
    public $any;
    /**
     * Constructor method for ParticipantsType
     * @uses Participants::setPrimary()
     * @uses Participants::setParticipant()
     * @uses Participants::setAny()
     * @param  Participant  $_primary
     * @param  Participant  $_participant
     * @param  DOMDocument  $_any
     * @return Participants
     */
    public function __construct($_primary = null, $_participant = null, $_any = null)
    {
        $this->setPrimary($_primary);
        $this->setParticipant($_participant);
        $this->setAny($_any);
    }
    /**
     * Get Primary value
     * @return Participant|null
     */
    public function getPrimary()
    {
        return $this->Primary;
    }
    /**
     * Set Primary value
     * @param  Participant $_primary the Primary
     * @return Participant
     */
    public function setPrimary($_primary)
    {
        return ($this->Primary = $_primary);
    }
    /**
     * Get Participant value
     * @return Participant|null
     */
    public function getParticipant()
    {
        return $this->Participant;
    }
    /**
     * Set Participant value
     * @param  Participant $_participant the Participant
     * @return Participant
     */
    public function setParticipant($_participant)
    {
        return ($this->Participant = $_participant);
    }
    /**
     * Get any value
     * @uses DOMDocument::loadXML()
     * @uses DOMDocument::hasChildNodes()
     * @uses DOMDocument::saveXML()
     * @uses DOMNode::item()
     * @uses Participants::setAny()
     * @param bool true or false whether to return XML value as string or as DOMDocument
     * @return DOMDocument|null
     */
    public function getAny($_asString = true)
    {
        if (!empty($this->any) && !($this->any instanceof DOMDocument)) {
            $dom = new \DOMDocument('1.0', 'UTF-8');
            $dom->formatOutput = true;
            if ($dom->loadXML($this->any)) {
                $this->setAny($dom);
            }
            unset($dom);
        }

        return ($_asString && ($this->any instanceof DOMDocument)
            && $this->any->hasChildNodes()) ? $this->any->saveXML($this->any->childNodes->item(0)) : $this->any;
    }
    /**
     * Set any value
     * @param  DOMDocument $_any the any
     * @return DOMDocument
     */
    public function setAny($_any)
    {
        return ($this->any = $_any);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
