<?php
namespace Topalis\WinPhone\Wstep\Entity;

/**
 * This class stands for ProblemAction originally named ProblemActionType
 * Meta informations extracted from the WSDL
 * - from schema : ws-addr.xsd
 * @date 2013-12-03
 */
class ProblemAction
{
    /**
     * The Action
     * @var AttributedURI
     */
    public $Action;
    /**
     * The SoapAction
     * Meta informations extracted from the WSDL
     * - minOccurs : 0
     * @var anyURI
     */
    public $SoapAction;
    /**
     * Constructor method for ProblemActionType
     * @uses ProblemAction::setAction()
     * @uses ProblemAction::setSoapAction()
     * @param  AttributedURI $_action
     * @param  anyURI        $_soapAction
     * @return ProblemAction
     */
    public function __construct($_action = null, $_soapAction = null)
    {
        $this->setAction($_action);
        $this->setSoapAction($_soapAction);
    }
    /**
     * Get Action value
     * @return AttributedURI|null
     */
    public function getAction()
    {
        return $this->Action;
    }
    /**
     * Set Action value
     * @param  AttributedURI $_action the Action
     * @return AttributedURI
     */
    public function setAction($_action)
    {
        return ($this->Action = $_action);
    }
    /**
     * Get SoapAction value
     * @return anyURI|null
     */
    public function getSoapAction()
    {
        return $this->SoapAction;
    }
    /**
     * Set SoapAction value
     * @param  anyURI $_soapAction the SoapAction
     * @return anyURI
     */
    public function setSoapAction($_soapAction)
    {
        return ($this->SoapAction = $_soapAction);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
