<?php
namespace Topalis\WinPhone\Wstep\Entity;

/**
 * This class stands for RSAKeyValue originally named RSAKeyValueType
 * Meta informations extracted from the WSDL
 * - from schema : xmldsig-core-schema.xsd
 * @date 2013-12-03
 */
class RSAKeyValue
{
    /**
     * The Modulus
     * @var base64Binary
     */
    public $Modulus;
    /**
     * The Exponent
     * @var base64Binary
     */
    public $Exponent;
    /**
     * Constructor method for RSAKeyValueType
     * @uses RSAKeyValue::setModulus()
     * @uses RSAKeyValue::setExponent()
     * @param  base64Binary $_modulus
     * @param  base64Binary $_exponent
     * @return RSAKeyValue
     */
    public function __construct($_modulus = null, $_exponent = null)
    {
        $this->setModulus($_modulus);
        $this->setExponent($_exponent);
    }
    /**
     * Get Modulus value
     * @return base64Binary|null
     */
    public function getModulus()
    {
        return $this->Modulus;
    }
    /**
     * Set Modulus value
     * @param  base64Binary $_modulus the Modulus
     * @return base64Binary
     */
    public function setModulus($_modulus)
    {
        return ($this->Modulus = $_modulus);
    }
    /**
     * Get Exponent value
     * @return base64Binary|null
     */
    public function getExponent()
    {
        return $this->Exponent;
    }
    /**
     * Set Exponent value
     * @param  base64Binary $_exponent the Exponent
     * @return base64Binary
     */
    public function setExponent($_exponent)
    {
        return ($this->Exponent = $_exponent);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
