<?php
namespace Topalis\WinPhone\Wstep\Entity;

/**
 * This class stands for RequestSecurityTokenResponse originally named RequestSecurityTokenResponseType
 * Meta informations extracted from the WSDL
 * - from schema : ws-trust-1.3.xsd
 * @date 2013-12-03
 */
class RequestSecurityTokenResponse
{
    /**
     * The TokenType
     * @var anyURI
     */
    public $TokenType;
    /**
     * The DispositionMessage
     * @var DispositionMessage
     */
    public $DispositionMessage;
    /**
     * The BinarySecurityToken
     * @var BinarySecurityToken
     */
    public $BinarySecurityToken;
    /**
     * The KeyExchangeToken
     * @var KeyExchangeToken
     */
    public $KeyExchangeToken;
    /**
     * The RequestedSecurityToken
     * @var RequestedSecurityToken
     */
    public $RequestedSecurityToken;
    /**
     * The RequestID
     * @var string
     */
    public $RequestID;
    /**
     * The any
     * @var DOMDocument
     */
    public $any;
    /**
     * The Context
     * Meta informations extracted from the WSDL
     * - use : optional
     * @var anyURI
     */
    public $Context;
    /**
     * Constructor method for RequestSecurityTokenResponseType
     * @uses RequestSecurityTokenResponse::setTokenType()
     * @uses RequestSecurityTokenResponse::setDispositionMessage()
     * @uses RequestSecurityTokenResponse::setBinarySecurityToken()
     * @uses RequestSecurityTokenResponse::setKeyExchangeToken()
     * @uses RequestSecurityTokenResponse::setRequestedSecurityToken()
     * @uses RequestSecurityTokenResponse::setRequestID()
     * @uses RequestSecurityTokenResponse::setAny()
     * @uses RequestSecurityTokenResponse::setContext()
     * @param  anyURI                       $_tokenType
     * @param  DispositionMessage           $_dispositionMessage
     * @param  BinarySecurityToken          $_binarySecurityToken
     * @param  KeyExchangeToken             $_keyExchangeToken
     * @param  RequestedSecurityToken       $_requestedSecurityToken
     * @param  string                       $_requestID
     * @param  DOMDocument                  $_any
     * @param  anyURI                       $_context
     * @return RequestSecurityTokenResponse
     */
    public function __construct($_tokenType = null, $_dispositionMessage = null,
        $_binarySecurityToken = null, $_keyExchangeToken = null, $_requestedSecurityToken = null,
        $_requestID = null, $_any = null, $_context = null)
    {
        $this->setTokenType($_tokenType);
        $this->setDispositionMessage($_dispositionMessage);
        $this->setBinarySecurityToken($_binarySecurityToken);
        $this->setKeyExchangeToken($_keyExchangeToken);
        $this->setRequestedSecurityToken($_requestedSecurityToken);
        $this->setRequestID($_requestID);
        $this->setAny($_any);
        $this->setContext($_context);
    }
    /**
     * Get TokenType value
     * @return anyURI|null
     */
    public function getTokenType()
    {
        return $this->TokenType;
    }
    /**
     * Set TokenType value
     * @param  anyURI $_tokenType the TokenType
     * @return anyURI
     */
    public function setTokenType($_tokenType)
    {
        return ($this->TokenType = $_tokenType);
    }
    /**
     * Get DispositionMessage value
     * @return DispositionMessage|null
     */
    public function getDispositionMessage()
    {
        return $this->DispositionMessage;
    }
    /**
     * Set DispositionMessage value
     * @param  DispositionMessage $_dispositionMessage the DispositionMessage
     * @return DispositionMessage
     */
    public function setDispositionMessage($_dispositionMessage)
    {
        return ($this->DispositionMessage = $_dispositionMessage);
    }
    /**
     * Get BinarySecurityToken value
     * @return BinarySecurityToken|null
     */
    public function getBinarySecurityToken()
    {
        return $this->BinarySecurityToken;
    }
    /**
     * Set BinarySecurityToken value
     * @param  BinarySecurityToken $_binarySecurityToken the BinarySecurityToken
     * @return BinarySecurityToken
     */
    public function setBinarySecurityToken($_binarySecurityToken)
    {
        return ($this->BinarySecurityToken = $_binarySecurityToken);
    }
    /**
     * Get KeyExchangeToken value
     * @return KeyExchangeToken|null
     */
    public function getKeyExchangeToken()
    {
        return $this->KeyExchangeToken;
    }
    /**
     * Set KeyExchangeToken value
     * @param  KeyExchangeToken $_keyExchangeToken the KeyExchangeToken
     * @return KeyExchangeToken
     */
    public function setKeyExchangeToken($_keyExchangeToken)
    {
        return ($this->KeyExchangeToken = $_keyExchangeToken);
    }
    /**
     * Get RequestedSecurityToken value
     * @return RequestedSecurityToken|null
     */
    public function getRequestedSecurityToken()
    {
        return $this->RequestedSecurityToken;
    }
    /**
     * Set RequestedSecurityToken value
     * @param  RequestedSecurityToken $_requestedSecurityToken the RequestedSecurityToken
     * @return RequestedSecurityToken
     */
    public function setRequestedSecurityToken($_requestedSecurityToken)
    {
        return ($this->RequestedSecurityToken = $_requestedSecurityToken);
    }
    /**
     * Get RequestID value
     * @return string|null
     */
    public function getRequestID()
    {
        return $this->RequestID;
    }
    /**
     * Set RequestID value
     * @param  string $_requestID the RequestID
     * @return string
     */
    public function setRequestID($_requestID)
    {
        return ($this->RequestID = $_requestID);
    }
    /**
     * Get any value
     * @uses DOMDocument::loadXML()
     * @uses DOMDocument::hasChildNodes()
     * @uses DOMDocument::saveXML()
     * @uses DOMNode::item()
     * @uses RequestSecurityTokenResponse::setAny()
     * @param bool true or false whether to return XML value as string or as DOMDocument
     * @return DOMDocument|null
     */
    public function getAny($_asString = true)
    {
        if (!empty($this->any) && !($this->any instanceof DOMDocument)) {
            $dom = new \DOMDocument('1.0', 'UTF-8');
            $dom->formatOutput = true;
            if ($dom->loadXML($this->any)) {
                $this->setAny($dom);
            }
            unset($dom);
        }

        return ($_asString && ($this->any instanceof DOMDocument)
            && $this->any->hasChildNodes()) ? $this->any->saveXML($this->any->childNodes->item(0)) : $this->any;
    }
    /**
     * Set any value
     * @param  DOMDocument $_any the any
     * @return DOMDocument
     */
    public function setAny($_any)
    {
        return ($this->any = $_any);
    }
    /**
     * Get Context value
     * @return anyURI|null
     */
    public function getContext()
    {
        return $this->Context;
    }
    /**
     * Set Context value
     * @param  anyURI $_context the Context
     * @return anyURI
     */
    public function setContext($_context)
    {
        return ($this->Context = $_context);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
