<?php
namespace Topalis\WinPhone\Wstep\Entity;

/**
 * This class stands for RetrievalMethod originally named RetrievalMethodType
 * Meta informations extracted from the WSDL
 * - from schema : xmldsig-core-schema.xsd
 * @date 2013-12-03
 */
class RetrievalMethod
{
    /**
     * The Transforms
     * @var Transforms
     */
    public $Transforms;
    /**
     * The URI
     * @var anyURI
     */
    public $URI;
    /**
     * The Type
     * Meta informations extracted from the WSDL
     * - use : optional
     * @var anyURI
     */
    public $Type;
    /**
     * Constructor method for RetrievalMethodType
     * @uses RetrievalMethod::setTransforms()
     * @uses RetrievalMethod::setURI()
     * @uses RetrievalMethod::setType()
     * @param  Transforms      $_transforms
     * @param  anyURI          $_uRI
     * @param  anyURI          $_type
     * @return RetrievalMethod
     */
    public function __construct($_transforms = null, $_uRI = null, $_type = null)
    {
        $this->setTransforms($_transforms);
        $this->setURI($_uRI);
        $this->setType($_type);
    }
    /**
     * Get Transforms value
     * @return Transforms|null
     */
    public function getTransforms()
    {
        return $this->Transforms;
    }
    /**
     * Set Transforms value
     * @param  Transforms $_transforms the Transforms
     * @return Transforms
     */
    public function setTransforms($_transforms)
    {
        return ($this->Transforms = $_transforms);
    }
    /**
     * Get URI value
     * @return anyURI|null
     */
    public function getURI()
    {
        return $this->URI;
    }
    /**
     * Set URI value
     * @param  anyURI $_uRI the URI
     * @return anyURI
     */
    public function setURI($_uRI)
    {
        return ($this->URI = $_uRI);
    }
    /**
     * Get Type value
     * @return anyURI|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @param  anyURI $_type the Type
     * @return anyURI
     */
    public function setType($_type)
    {
        return ($this->Type = $_type);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
