<?php
namespace Topalis\WinPhone\Wstep\Entity;

/**
 * This class stands for Signature originally named SignatureType
 * Meta informations extracted from the WSDL
 * - from schema : xmldsig-core-schema.xsd
 * @date 2013-12-03
 */
class Signature
{
    /**
     * The SignedInfo
     * @var SignedInfo
     */
    public $SignedInfo;
    /**
     * The SignatureValue
     * @var SignatureValue
     */
    public $SignatureValue;
    /**
     * The KeyInfo
     * @var KeyInfo
     */
    public $KeyInfo;
    /**
     * The Object
     * @var Object
     */
    public $Object;
    /**
     * The Id
     * Meta informations extracted from the WSDL
     * - use : optional
     * @var ID
     */
    public $Id;
    /**
     * Constructor method for SignatureType
     * @uses Signature::setSignedInfo()
     * @uses Signature::setSignatureValue()
     * @uses Signature::setKeyInfo()
     * @uses Signature::setObject()
     * @uses Signature::setId()
     * @param  SignedInfo     $_signedInfo
     * @param  SignatureValue $_signatureValue
     * @param  KeyInfo        $_keyInfo
     * @param  Object         $_object
     * @param  ID             $_id
     * @return Signature
     */
    public function __construct($_signedInfo = null, $_signatureValue = null, $_keyInfo = null,
        $_object = null, $_id = null)
    {
        $this->setSignedInfo($_signedInfo);
        $this->setSignatureValue($_signatureValue);
        $this->setKeyInfo($_keyInfo);
        $this->setObject($_object);
        $this->setId($_id);
    }
    /**
     * Get SignedInfo value
     * @return SignedInfo|null
     */
    public function getSignedInfo()
    {
        return $this->SignedInfo;
    }
    /**
     * Set SignedInfo value
     * @param  SignedInfo $_signedInfo the SignedInfo
     * @return SignedInfo
     */
    public function setSignedInfo($_signedInfo)
    {
        return ($this->SignedInfo = $_signedInfo);
    }
    /**
     * Get SignatureValue value
     * @return SignatureValue|null
     */
    public function getSignatureValue()
    {
        return $this->SignatureValue;
    }
    /**
     * Set SignatureValue value
     * @param  SignatureValue $_signatureValue the SignatureValue
     * @return SignatureValue
     */
    public function setSignatureValue($_signatureValue)
    {
        return ($this->SignatureValue = $_signatureValue);
    }
    /**
     * Get KeyInfo value
     * @return KeyInfo|null
     */
    public function getKeyInfo()
    {
        return $this->KeyInfo;
    }
    /**
     * Set KeyInfo value
     * @param  KeyInfo $_keyInfo the KeyInfo
     * @return KeyInfo
     */
    public function setKeyInfo($_keyInfo)
    {
        return ($this->KeyInfo = $_keyInfo);
    }
    /**
     * Get Object value
     * @return Object|null
     */
    public function getObject()
    {
        return $this->Object;
    }
    /**
     * Set Object value
     * @param  Object $_object the Object
     * @return Object
     */
    public function setObject($_object)
    {
        return ($this->Object = $_object);
    }
    /**
     * Get Id value
     * @return ID|null
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param  ID $_id the Id
     * @return ID
     */
    public function setId($_id)
    {
        return ($this->Id = $_id);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
