<?php
namespace Topalis\WinPhone\Wstep\Entity;

/**
 * This class stands for SignatureProperty originally named SignaturePropertyType
 * Meta informations extracted from the WSDL
 * - from schema : xmldsig-core-schema.xsd
 * @date 2013-12-03
 */
class SignatureProperty
{
    /**
     * The Target
     * Meta informations extracted from the WSDL
     * - use : required
     * @var anyURI
     */
    public $Target;
    /**
     * The any
     * @var DOMDocument
     */
    public $any;
    /**
     * The Id
     * Meta informations extracted from the WSDL
     * - use : optional
     * @var ID
     */
    public $Id;
    /**
     * Constructor method for SignaturePropertyType
     * @uses SignatureProperty::setTarget()
     * @uses SignatureProperty::setAny()
     * @uses SignatureProperty::setId()
     * @param  anyURI            $_target
     * @param  DOMDocument       $_any
     * @param  ID                $_id
     * @return SignatureProperty
     */
    public function __construct($_target, $_any = null, $_id = null)
    {
        $this->setTarget($_target);
        $this->setAny($_any);
        $this->setId($_id);
    }
    /**
     * Get Target value
     * @return anyURI
     */
    public function getTarget()
    {
        return $this->Target;
    }
    /**
     * Set Target value
     * @param  anyURI $_target the Target
     * @return anyURI
     */
    public function setTarget($_target)
    {
        return ($this->Target = $_target);
    }
    /**
     * Get any value
     * @uses DOMDocument::loadXML()
     * @uses DOMDocument::hasChildNodes()
     * @uses DOMDocument::saveXML()
     * @uses DOMNode::item()
     * @uses SignatureProperty::setAny()
     * @param bool true or false whether to return XML value as string or as DOMDocument
     * @return DOMDocument|null
     */
    public function getAny($_asString = true)
    {
        if (!empty($this->any) && !($this->any instanceof DOMDocument)) {
            $dom = new \DOMDocument('1.0', 'UTF-8');
            $dom->formatOutput = true;
            if ($dom->loadXML($this->any)) {
                $this->setAny($dom);
            }
            unset($dom);
        }

        return ($_asString && ($this->any instanceof DOMDocument)
            && $this->any->hasChildNodes()) ? $this->any->saveXML($this->any->childNodes->item(0)) : $this->any;
    }
    /**
     * Set any value
     * @param  DOMDocument $_any the any
     * @return DOMDocument
     */
    public function setAny($_any)
    {
        return ($this->any = $_any);
    }
    /**
     * Get Id value
     * @return ID|null
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param  ID $_id the Id
     * @return ID
     */
    public function setId($_id)
    {
        return ($this->Id = $_id);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
