<?php
namespace Topalis\WinPhone\Wstep\Entity;

/**
 * This class stands for UseKey originally named UseKeyType
 * Meta informations extracted from the WSDL
 * - from schema : ws-trust-1.3.xsd
 * @date 2013-12-03
 */
class UseKey
{
    /**
     * The any
     * @var DOMDocument
     */
    public $any;
    /**
     * The Sig
     * Meta informations extracted from the WSDL
     * - use : optional
     * @var anyURI
     */
    public $Sig;
    /**
     * Constructor method for UseKeyType
     * @uses UseKey::setAny()
     * @uses UseKey::setSig()
     * @param  DOMDocument $_any
     * @param  anyURI      $_sig
     * @return UseKey
     */
    public function __construct($_any = null, $_sig = null)
    {
        $this->setAny($_any);
        $this->setSig($_sig);
    }
    /**
     * Get any value
     * @uses DOMDocument::loadXML()
     * @uses DOMDocument::hasChildNodes()
     * @uses DOMDocument::saveXML()
     * @uses DOMNode::item()
     * @uses UseKey::setAny()
     * @param bool true or false whether to return XML value as string or as DOMDocument
     * @return DOMDocument|null
     */
    public function getAny($_asString = true)
    {
        if (!empty($this->any) && !($this->any instanceof DOMDocument)) {
            $dom = new \DOMDocument('1.0', 'UTF-8');
            $dom->formatOutput = true;
            if ($dom->loadXML($this->any)) {
                $this->setAny($dom);
            }
            unset($dom);
        }

        return ($_asString && ($this->any instanceof DOMDocument)
            && $this->any->hasChildNodes()) ? $this->any->saveXML($this->any->childNodes->item(0)) : $this->any;
    }
    /**
     * Set any value
     * @param  DOMDocument $_any the any
     * @return DOMDocument
     */
    public function setAny($_any)
    {
        return ($this->any = $_any);
    }
    /**
     * Get Sig value
     * @return anyURI|null
     */
    public function getSig()
    {
        return $this->Sig;
    }
    /**
     * Set Sig value
     * @param  anyURI $_sig the Sig
     * @return anyURI
     */
    public function setSig($_sig)
    {
        return ($this->Sig = $_sig);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
