<?php
namespace Topalis\WinPhone\Xcep\Entity;

/**
 * This class stands for CertificateEnrollmentPolicy originally named CertificateEnrollmentPolicy
 * Meta informations extracted from the WSDL
 * - from schema : xcep.xsd
 * @date 2013-12-10
 */
class CertificateEnrollmentPolicy
{
    /**
     * The policyOIDReference
     * @var int
     */
    public $policyOIDReference;

    /**
     * The cAs
     * Meta informations extracted from the WSDL
     * - nillable : true
     * @var CAReferenceCollection
     */
    public $cAs;

    /**
     * The attributes
     * @var Attributes
     */
    public $attributes;

    /**
     * The any
     * @var DOMDocument
     */
    public $any;

    /**
     * Constructor method for CertificateEnrollmentPolicy
     * @uses CertificateEnrollmentPolicy::setPolicyOIDReference()
     * @uses CertificateEnrollmentPolicy::setCAs()
     * @uses CertificateEnrollmentPolicy::setAttributes()
     * @uses CertificateEnrollmentPolicy::setAny()
     * @param int $_policyOIDReference
     * @param CAReferenceCollection $_cAs
     * @param Attributes $_attributes
     * @param DOMDocument $_any
     * @return CertificateEnrollmentPolicy
     */
    public function __construct($_policyOIDReference = null, $_cAs = null, $_attributes = null, $_any = null)
    {
        $this->setPolicyOIDReference($_policyOIDReference);
        $this->setCAs($_cAs);
        $this->setAttributes($_attributes);
        $this->setAny($_any);
    }

    /**
     * Get policyOIDReference value
     * @return int|null
     */
    public function getPolicyOIDReference()
    {
        return $this->policyOIDReference;
    }

    /**
     * Set policyOIDReference value
     * @param int $_policyOIDReference the policyOIDReference
     * @return int
     */
    public function setPolicyOIDReference($_policyOIDReference)
    {
        return ($this->policyOIDReference = $_policyOIDReference);
    }

    /**
     * Get cAs value
     * @return CAReferenceCollection|null
     */
    public function getCAs()
    {
        return $this->cAs;
    }

    /**
     * Set cAs value
     * @param CAReferenceCollection $_cAs the cAs
     * @return CAReferenceCollection
     */
    public function setCAs($_cAs)
    {
        return ($this->cAs = $_cAs);
    }

    /**
     * Get attributes value
     * @return Attributes|null
     */
    public function getAttributes()
    {
        return $this->attributes;
    }

    /**
     * Set attributes value
     * @param Attributes $_attributes the attributes
     * @return Attributes
     */
    public function setAttributes($_attributes)
    {
        return ($this->attributes = $_attributes);
    }

    /**
     * Get any value
     * @uses DOMDocument::loadXML()
     * @uses DOMDocument::hasChildNodes()
     * @uses DOMDocument::saveXML()
     * @uses DOMNode::item()
     * @uses CertificateEnrollmentPolicy::setAny()
     * @param bool true or false whether to return XML value as string or as DOMDocument
     * @return DOMDocument|null
     */
    public function getAny($_asString = true)
    {
        if (!empty($this->any) && !($this->any instanceof DOMDocument)) {
            $dom = new \DOMDocument('1.0', 'UTF-8');
            $dom->formatOutput = true;
            if ($dom->loadXML($this->any)) {
                $this->setAny($dom);
            }

            unset($dom);
        }

        return ($_asString && ($this->any instanceof DOMDocument)
            && $this->any->hasChildNodes()) ? $this->any->saveXML($this->any->childNodes->item(0)) : $this->any;
    }

    /**
     * Set any value
     * @param DOMDocument $_any the any
     * @return DOMDocument
     */
    public function setAny($_any)
    {
        return ($this->any = $_any);
    }

    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }

}
