<?php
namespace Topalis\WinPhone\Xcep\Entity;

/**
 * This class stands for CryptoProviders originally named CryptoProviders
 * Meta informations extracted from the WSDL
 * - from schema : xcep.xsd
 * @date 2013-12-10
 */
class CryptoProviders
{
    /**
     * The provider
     * Meta informations extracted from the WSDL
     * - maxOccurs : unbounded
     * - minOccurs : 1
     * @var string
     */
    public $provider;

    /**
     * Constructor method for CryptoProviders
     * @uses CryptoProviders::setProvider()
     * @param string $_provider
     * @return CryptoProviders
     */
    public function __construct($_provider)
    {
        $this->setProvider($_provider);
    }

    /**
     * Get provider value
     * @return string
     */
    public function getProvider()
    {
        return $this->provider;
    }

    /**
     * Set provider value
     * @param string $_provider the provider
     * @return string
     */
    public function setProvider($_provider)
    {
        return ($this->provider = $_provider);
    }

    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }

}
