<?php
namespace Topalis\WinPhone\Xcep\Entity;

/**
 * This class stands for EnrollmentPermission originally named EnrollmentPermission
 * Meta informations extracted from the WSDL
 * - from schema : xcep.xsd
 * @date 2013-12-10
 */
class EnrollmentPermission
{
    /**
     * The enroll
     * @var boolean
     */
    public $enroll;

    /**
     * The autoEnroll
     * @var boolean
     */
    public $autoEnroll;

    /**
     * Constructor method for EnrollmentPermission
     * @uses EnrollmentPermission::setEnroll()
     * @uses EnrollmentPermission::setAutoEnroll()
     * @param boolean $_enroll
     * @param boolean $_autoEnroll
     * @return EnrollmentPermission
     */
    public function __construct($_enroll = null, $_autoEnroll = null)
    {
        $this->setEnroll($_enroll);
        $this->setAutoEnroll($_autoEnroll);
    }

    /**
     * Get enroll value
     * @return boolean|null
     */
    public function getEnroll()
    {
        return $this->enroll;
    }

    /**
     * Set enroll value
     * @param boolean $_enroll the enroll
     * @return boolean
     */
    public function setEnroll($_enroll)
    {
        return ($this->enroll = $_enroll);
    }

    /**
     * Get autoEnroll value
     * @return boolean|null
     */
    public function getAutoEnroll()
    {
        return $this->autoEnroll;
    }

    /**
     * Set autoEnroll value
     * @param boolean $_autoEnroll the autoEnroll
     * @return boolean
     */
    public function setAutoEnroll($_autoEnroll)
    {
        return ($this->autoEnroll = $_autoEnroll);
    }

    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }

}
