<?php
namespace Topalis\WinPhone\Xcep\Entity;

/**
 * This class stands for ExtensionCollection originally named ExtensionCollection
 * Meta informations extracted from the WSDL
 * - from schema : xcep.xsd
 * @date 2013-12-10
 */
class ExtensionCollection
{
    /**
     * The extension
     * Meta informations extracted from the WSDL
     * - maxOccurs : unbounded
     * - minOccurs : 1
     * @var Extension
     */
    public $extension;

    /**
     * Constructor method for ExtensionCollection
     * @uses ExtensionCollection::setExtension()
     * @param Extension $_extension
     * @return ExtensionCollection
     */
    public function __construct($_extension)
    {
        $this->setExtension($_extension);
    }

    /**
     * Get extension value
     * @return Extension
     */
    public function getExtension()
    {
        return $this->extension;
    }

    /**
     * Set extension value
     * @param Extension $_extension the extension
     * @return Extension
     */
    public function setExtension($_extension)
    {
        return ($this->extension = $_extension);
    }

    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }

}
