<?php
namespace Topalis\WinPhone\Xcep\Entity;

/**
 * This class stands for GetPolicies originally named GetPolicies
 * Meta informations extracted from the WSDL
 * - from schema : xcep.xsd
 * @date 2013-12-10
 */
class GetPolicies
{
    /**
     * The client
     * @var Client
     */
    public $client;

    /**
     * The requestFilter
     * Meta informations extracted from the WSDL
     * - nillable : true
     * @var RequestFilter
     */
    public $requestFilter;

    /**
     * Constructor method for GetPolicies
     * @uses GetPolicies::setClient()
     * @uses GetPolicies::setRequestFilter()
     * @param Client $_client
     * @param RequestFilter $_requestFilter
     * @return GetPolicies
     */
    public function __construct($_client = null, $_requestFilter = null)
    {
        $this->setClient($_client);
        $this->setRequestFilter($_requestFilter);
    }

    /**
     * Get client value
     * @return Client|null
     */
    public function getClient()
    {
        return $this->client;
    }

    /**
     * Set client value
     * @param Client $_client the client
     * @return Client
     */
    public function setClient($_client)
    {
        return ($this->client = $_client);
    }

    /**
     * Get requestFilter value
     * @return RequestFilter|null
     */
    public function getRequestFilter()
    {
        return $this->requestFilter;
    }

    /**
     * Set requestFilter value
     * @param RequestFilter $_requestFilter the requestFilter
     * @return RequestFilter
     */
    public function setRequestFilter($_requestFilter)
    {
        return ($this->requestFilter = $_requestFilter);
    }

    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }

}
