<?php
namespace Topalis\WinPhone\Xcep\Entity;

/**
 * This class stands for KeyArchivalAttributes originally named KeyArchivalAttributes
 * Meta informations extracted from the WSDL
 * - from schema : xcep.xsd
 * @date 2013-12-10
 */
class KeyArchivalAttributes
{
    /**
     * The symmetricAlgorithmOIDReference
     * @var int
     */
    public $symmetricAlgorithmOIDReference;

    /**
     * The symmetricAlgorithmKeyLength
     * @var unsignedInt
     */
    public $symmetricAlgorithmKeyLength;

    /**
     * Constructor method for KeyArchivalAttributes
     * @uses KeyArchivalAttributes::setSymmetricAlgorithmOIDReference()
     * @uses KeyArchivalAttributes::setSymmetricAlgorithmKeyLength()
     * @param int $_symmetricAlgorithmOIDReference
     * @param unsignedInt $_symmetricAlgorithmKeyLength
     * @return KeyArchivalAttributes
     */
    public function __construct($_symmetricAlgorithmOIDReference = null, $_symmetricAlgorithmKeyLength = null)
    {
        $this->setSymmetricAlgorithmOIDReference($_symmetricAlgorithmOIDReference);
        $this->setSymmetricAlgorithmKeyLength($_symmetricAlgorithmKeyLength);
    }

    /**
     * Get symmetricAlgorithmOIDReference value
     * @return int|null
     */
    public function getSymmetricAlgorithmOIDReference()
    {
        return $this->symmetricAlgorithmOIDReference;
    }

    /**
     * Set symmetricAlgorithmOIDReference value
     * @param int $_symmetricAlgorithmOIDReference the symmetricAlgorithmOIDReference
     * @return int
     */
    public function setSymmetricAlgorithmOIDReference($_symmetricAlgorithmOIDReference)
    {
        return ($this->symmetricAlgorithmOIDReference = $_symmetricAlgorithmOIDReference);
    }

    /**
     * Get symmetricAlgorithmKeyLength value
     * @return unsignedInt|null
     */
    public function getSymmetricAlgorithmKeyLength()
    {
        return $this->symmetricAlgorithmKeyLength;
    }

    /**
     * Set symmetricAlgorithmKeyLength value
     * @param unsignedInt $_symmetricAlgorithmKeyLength the symmetricAlgorithmKeyLength
     * @return unsignedInt
     */
    public function setSymmetricAlgorithmKeyLength($_symmetricAlgorithmKeyLength)
    {
        return ($this->symmetricAlgorithmKeyLength = $_symmetricAlgorithmKeyLength);
    }

    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }

}
