<?php
namespace Topalis\WinPhone\Xcep\Entity;

/**
 * This class stands for OIDCollection originally named OIDCollection
 * Meta informations extracted from the WSDL
 * - from schema : xcep.xsd
 * @date 2013-12-10
 */
class OIDCollection
{
    /**
     * The oID
     * Meta informations extracted from the WSDL
     * - maxOccurs : unbounded
     * - minOccurs : 1
     * @var OID
     */
    public $oID;

    /**
     * Constructor method for OIDCollection
     * @uses OIDCollection::setOID()
     * @param OID $_oID
     * @return OIDCollection
     */
    public function __construct($_oID)
    {
        $this->setOID($_oID);
    }

    /**
     * Get oID value
     * @return OID
     */
    public function getOID()
    {
        return $this->oID;
    }

    /**
     * Set oID value
     * @param OID $_oID the oID
     * @return OID
     */
    public function setOID($_oID)
    {
        return ($this->oID = $_oID);
    }

    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }

}
