<?php
namespace Topalis\WinPhone\Xcep\Entity;

/**
 * This class stands for PolicyCollection originally named PolicyCollection
 * Meta informations extracted from the WSDL
 * - from schema : xcep.xsd
 * @date 2013-12-10
 */
class PolicyCollection
{
    /**
     * The policy
     * Meta informations extracted from the WSDL
     * - maxOccurs : unbounded
     * - minOccurs : 1
     * @var CertificateEnrollmentPolicy
     */
    public $policy;

    /**
     * Constructor method for PolicyCollection
     * @uses PolicyCollection::setPolicy()
     * @param CertificateEnrollmentPolicy $_policy
     * @return PolicyCollection
     */
    public function __construct($_policy)
    {
        $this->setPolicy($_policy);
    }

    /**
     * Get policy value
     * @return CertificateEnrollmentPolicy
     */
    public function getPolicy()
    {
        return $this->policy;
    }

    /**
     * Set policy value
     * @param CertificateEnrollmentPolicy $_policy the policy
     * @return CertificateEnrollmentPolicy
     */
    public function setPolicy($_policy)
    {
        return ($this->policy = $_policy);
    }

    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }

}
