<?php
namespace Topalis\WinPhone\Xcep\Entity;

/**
 * This class stands for PrivateKeyAttributes originally named PrivateKeyAttributes
 * Meta informations extracted from the WSDL
 * - from schema : xcep.xsd
 * @date 2013-12-10
 */
class PrivateKeyAttributes
{
    /**
     * The minimalKeyLength
     * @var unsignedInt
     */
    public $minimalKeyLength;

    /**
     * The keySpec
     * Meta informations extracted from the WSDL
     * - nillable : true
     * @var unsignedInt
     */
    public $keySpec;

    /**
     * The keyUsageProperty
     * Meta informations extracted from the WSDL
     * - nillable : true
     * @var unsignedInt
     */
    public $keyUsageProperty;

    /**
     * The permissions
     * Meta informations extracted from the WSDL
     * - nillable : true
     * @var string
     */
    public $permissions;

    /**
     * The algorithmOIDReference
     * Meta informations extracted from the WSDL
     * - nillable : true
     * @var int
     */
    public $algorithmOIDReference;

    /**
     * The cryptoProviders
     * Meta informations extracted from the WSDL
     * - nillable : true
     * @var CryptoProviders
     */
    public $cryptoProviders;

    /**
     * Constructor method for PrivateKeyAttributes
     * @uses PrivateKeyAttributes::setMinimalKeyLength()
     * @uses PrivateKeyAttributes::setKeySpec()
     * @uses PrivateKeyAttributes::setKeyUsageProperty()
     * @uses PrivateKeyAttributes::setPermissions()
     * @uses PrivateKeyAttributes::setAlgorithmOIDReference()
     * @uses PrivateKeyAttributes::setCryptoProviders()
     * @param unsignedInt $_minimalKeyLength
     * @param unsignedInt $_keySpec
     * @param unsignedInt $_keyUsageProperty
     * @param string $_permissions
     * @param int $_algorithmOIDReference
     * @param CryptoProviders $_cryptoProviders
     * @return PrivateKeyAttributes
     */
    public function __construct($_minimalKeyLength = null, $_keySpec = null, $_keyUsageProperty = null,
        $_permissions = null, $_algorithmOIDReference = null, $_cryptoProviders = null)
    {
        $this->setMinimalKeyLength($_minimalKeyLength);
        $this->setKeySpec($_keySpec);
        $this->setKeyUsageProperty($_keyUsageProperty);
        $this->setPermissions($_permissions);
        $this->setAlgorithmOIDReference($_algorithmOIDReference);
        $this->setCryptoProviders($_cryptoProviders);
    }

    /**
     * Get minimalKeyLength value
     * @return unsignedInt|null
     */
    public function getMinimalKeyLength()
    {
        return $this->minimalKeyLength;
    }

    /**
     * Set minimalKeyLength value
     * @param unsignedInt $_minimalKeyLength the minimalKeyLength
     * @return unsignedInt
     */
    public function setMinimalKeyLength($_minimalKeyLength)
    {
        return ($this->minimalKeyLength = $_minimalKeyLength);
    }

    /**
     * Get keySpec value
     * @return unsignedInt|null
     */
    public function getKeySpec()
    {
        return $this->keySpec;
    }

    /**
     * Set keySpec value
     * @param unsignedInt $_keySpec the keySpec
     * @return unsignedInt
     */
    public function setKeySpec($_keySpec)
    {
        return ($this->keySpec = $_keySpec);
    }

    /**
     * Get keyUsageProperty value
     * @return unsignedInt|null
     */
    public function getKeyUsageProperty()
    {
        return $this->keyUsageProperty;
    }

    /**
     * Set keyUsageProperty value
     * @param unsignedInt $_keyUsageProperty the keyUsageProperty
     * @return unsignedInt
     */
    public function setKeyUsageProperty($_keyUsageProperty)
    {
        return ($this->keyUsageProperty = $_keyUsageProperty);
    }

    /**
     * Get permissions value
     * @return string|null
     */
    public function getPermissions()
    {
        return $this->permissions;
    }

    /**
     * Set permissions value
     * @param string $_permissions the permissions
     * @return string
     */
    public function setPermissions($_permissions)
    {
        return ($this->permissions = $_permissions);
    }

    /**
     * Get algorithmOIDReference value
     * @return int|null
     */
    public function getAlgorithmOIDReference()
    {
        return $this->algorithmOIDReference;
    }

    /**
     * Set algorithmOIDReference value
     * @param int $_algorithmOIDReference the algorithmOIDReference
     * @return int
     */
    public function setAlgorithmOIDReference($_algorithmOIDReference)
    {
        return ($this->algorithmOIDReference = $_algorithmOIDReference);
    }

    /**
     * Get cryptoProviders value
     * @return CryptoProviders|null
     */
    public function getCryptoProviders()
    {
        return $this->cryptoProviders;
    }

    /**
     * Set cryptoProviders value
     * @param CryptoProviders $_cryptoProviders the cryptoProviders
     * @return CryptoProviders
     */
    public function setCryptoProviders($_cryptoProviders)
    {
        return ($this->cryptoProviders = $_cryptoProviders);
    }

    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }

}
