<?php
namespace Topalis\WinPhone\Xcep\Entity;

/**
 * This class stands for RARequirements originally named RARequirements
 * Meta informations extracted from the WSDL
 * - from schema : xcep.xsd
 * @date 2013-12-10
 */
class RARequirements
{
    /**
     * The rASignatures
     * @var unsignedInt
     */
    public $rASignatures;

    /**
     * The rAEKUs
     * Meta informations extracted from the WSDL
     * - nillable : true
     * @var OIDReferenceCollection
     */
    public $rAEKUs;

    /**
     * The rAPolicies
     * Meta informations extracted from the WSDL
     * - nillable : true
     * @var OIDReferenceCollection
     */
    public $rAPolicies;

    /**
     * Constructor method for RARequirements
     * @uses RARequirements::setRASignatures()
     * @uses RARequirements::setRAEKUs()
     * @uses RARequirements::setRAPolicies()
     * @param unsignedInt $_rASignatures
     * @param OIDReferenceCollection $_rAEKUs
     * @param OIDReferenceCollection $_rAPolicies
     * @return RARequirements
     */
    public function __construct($_rASignatures = null, $_rAEKUs = null, $_rAPolicies = null)
    {
        $this->setRASignatures($_rASignatures);
        $this->setRAEKUs($_rAEKUs);
        $this->setRAPolicies($_rAPolicies);
    }

    /**
     * Get rASignatures value
     * @return unsignedInt|null
     */
    public function getRASignatures()
    {
        return $this->rASignatures;
    }

    /**
     * Set rASignatures value
     * @param unsignedInt $_rASignatures the rASignatures
     * @return unsignedInt
     */
    public function setRASignatures($_rASignatures)
    {
        return ($this->rASignatures = $_rASignatures);
    }

    /**
     * Get rAEKUs value
     * @return OIDReferenceCollection|null
     */
    public function getRAEKUs()
    {
        return $this->rAEKUs;
    }

    /**
     * Set rAEKUs value
     * @param OIDReferenceCollection $_rAEKUs the rAEKUs
     * @return OIDReferenceCollection
     */
    public function setRAEKUs($_rAEKUs)
    {
        return ($this->rAEKUs = $_rAEKUs);
    }

    /**
     * Get rAPolicies value
     * @return OIDReferenceCollection|null
     */
    public function getRAPolicies()
    {
        return $this->rAPolicies;
    }

    /**
     * Set rAPolicies value
     * @param OIDReferenceCollection $_rAPolicies the rAPolicies
     * @return OIDReferenceCollection
     */
    public function setRAPolicies($_rAPolicies)
    {
        return ($this->rAPolicies = $_rAPolicies);
    }

    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }

}
