<?php
namespace Topalis\WinPhone\Xcep\Entity;

/**
 * This class stands for RequestFilter originally named RequestFilter
 * Meta informations extracted from the WSDL
 * - from schema : xcep.xsd
 * @date 2013-12-10
 */
class RequestFilter
{
    /**
     * The policyOIDs
     * Meta informations extracted from the WSDL
     * - nillable : true
     * @var FilterOIDCollection
     */
    public $policyOIDs;

    /**
     * The any
     * @var DOMDocument
     */
    public $any;

    /**
     * Constructor method for RequestFilter
     * @uses RequestFilter::setPolicyOIDs()
     * @uses RequestFilter::setAny()
     * @param FilterOIDCollection $_policyOIDs
     * @param DOMDocument $_any
     * @return RequestFilter
     */
    public function __construct($_policyOIDs = null, $_any = null)
    {
        $this->setPolicyOIDs($_policyOIDs);
        $this->setAny($_any);
    }

    /**
     * Get policyOIDs value
     * @return FilterOIDCollection|null
     */
    public function getPolicyOIDs()
    {
        return $this->policyOIDs;
    }

    /**
     * Set policyOIDs value
     * @param FilterOIDCollection $_policyOIDs the policyOIDs
     * @return FilterOIDCollection
     */
    public function setPolicyOIDs($_policyOIDs)
    {
        return ($this->policyOIDs = $_policyOIDs);
    }

    /**
     * Get any value
     * @uses DOMDocument::loadXML()
     * @uses DOMDocument::hasChildNodes()
     * @uses DOMDocument::saveXML()
     * @uses DOMNode::item()
     * @uses RequestFilter::setAny()
     * @param bool true or false whether to return XML value as string or as DOMDocument
     * @return DOMDocument|null
     */
    public function getAny($_asString = true)
    {
        if (!empty($this->any) && !($this->any instanceof DOMDocument)) {
            $dom = new \DOMDocument('1.0', 'UTF-8');
            $dom->formatOutput = true;
            if ($dom->loadXML($this->any)) {
                $this->setAny($dom);
            }

            unset($dom);
        }

        return ($_asString && ($this->any instanceof DOMDocument)
            && $this->any->hasChildNodes()) ? $this->any->saveXML($this->any->childNodes->item(0)) : $this->any;
    }

    /**
     * Set any value
     * @param DOMDocument $_any the any
     * @return DOMDocument
     */
    public function setAny($_any)
    {
        return ($this->any = $_any);
    }

    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }

}
