<?php namespace Ashb\PngUncrush;

use Illuminate\Support\ServiceProvider;
use \Illuminate\Foundation\AliasLoader;

class PngUncrushServiceProvider extends ServiceProvider {

	/**
	 * Indicates if loading of the provider is deferred.
	 *
	 * @var bool
	 */
	protected $defer = false;

	/**
	 * Bootstrap the application events.
	 *
	 * @return void
	 */
	public function boot()
	{
		$this->package('ashb/png-uncrush');
	}

	/**
	 * Register the service provider.
	 *
	 * @return void
	 */
	public function register()
	{
        $this->app['cFPropertyList'] = $this->app->share(function($app)
        {
            return new CFPropertyList\CFPropertyList;
        });
        $this->app['pPngUncrush'] = $this->app->share(function($app)
        {
            return new PPngUncrush\PPngUncrush;
        });

        $this->app->booting(function()
        {
            $loader = AliasLoader::getInstance();
            $loader->alias('CFPropertyList', 'Ashb\PngUncrush\Facades\CFPropertyList');
            $loader->alias('PPngUncrush', 'Ashb\PngUncrush\Facades\PPngUncrush');
        });
	}

	/**
	 * Get the services provided by the provider.
	 *
	 * @return array
	 */
	public function provides()
	{
		return array('png-uncrush');
	}

}