<?php

use Symfony\Component\ClassLoader\ApcClassLoader;
use Symfony\Component\HttpFoundation\Request;

$loader = include_once __DIR__.'/../app/bootstrap.php.cache';

$env = getenv("SYMFONY_ENV") ?: "prod";
$debug = getenv("SYMFONY_DEBUG") || $env !== "prod";

// Use APC for autoloading to improve performance
// Change 'sf2' by the prefix you want in order to prevent key conflict with another application
// @codingStandardsIgnoreStart
/*
$loader = new ApcClassLoader('sf2', $loader);
$loader->register(true);
*/
// @codingStandardsIgnoreEnd

require_once __DIR__.'/../app/AppKernel.php';
$kernel = new AppKernel($env, $debug);
// don't load class cache for easier debugging
if (!isset($_GET['XDEBUG_SESSION_START'])) {
    $kernel->loadClassCache();
}

if ($env === "prod") {
    include_once __DIR__.'/../app/AppCache.php';
    $kernel = new AppCache($kernel);
}

$request = Request::createFromGlobals();
$response = $kernel->handle($request);
$response->send();
$kernel->terminate($request, $response);
