<?php
namespace Topalis\Profile\Payload;

// @codingStandardsIgnoreStart
/**
 * Represents an AirPrint payload.
 * This payload configures connections to AirPrint printers on the device.
 * @see https://developer.apple.com/library/ios/featuredarticles/iPhoneConfigurationProfileRef/iPhoneConfigurationProfileRef.pdf#//apple_ref/doc/uid/TP40010206-CH1-SW39
 * @since iOS 7.0
 *
 * @author Dominic Tubach <dominic.tubach@topalis.com>
 */
// @codingStandardsIgnoreEnd
class AirPrintPayload extends AbstractPayload
{
    const TYPE = "com.apple.airprint";

    public function getServers()
    {
        return $this->getSubTypeArray("AirPrint", 'Topalis\Profile\Payload\Data\AirPrintServer');
    }

    public function setServers(array $servers = null)
    {
        $this->setSubTypeArray("AirPrint", $servers);
    }
}
