<?php
namespace Topalis\Profile\Payload\Android;

use Topalis\Profile\Annotation\Payload\Key;
use Topalis\Profile\Payload\AbstractPayload;

/**
 * @Key(name="SSID", type="String")
 * @Key(name="IsHidden", type="boolean", default="false")
 * @Key(name="EncryptionType", type="String")
 * @Key(name="Password", type="String")
 * @Key(name="ProxyType", type="String")
 * @Key(name="ProxyHost", type="String")
 * @Key(name="ProxyPort", type="Number")
 *
 * @author Florian Pfitzer <pfitzer@w3p.cc>
 */
class WifiPayload extends AbstractPayload
{
    const TYPE = "de.auralis.android.wifi";

    public function setSSID($sSID)
    {
        $this->setValue("SSID", $sSID, self::TYPE_STRING);
    }

    public function getSSID()
    {
        return $this->getValue("SSID");
    }

    public function setIsHidden($isHidden)
    {
        $this->setValue("IsHidden", $isHidden, self::TYPE_BOOLEAN);
    }

    public function isIsHidden()
    {
        return $this->getValue("IsHidden", false);
    }

    public function setEncryptionType($encryptionType)
    {
        $this->setValue("EncryptionType", $encryptionType, self::TYPE_STRING);
    }

    public function getEncryptionType()
    {
        return $this->getValue("EncryptionType");
    }

    public function setPassword($password)
    {
        $this->setValue("Password", $password, self::TYPE_STRING);
    }

    public function getPassword()
    {
        return $this->getValue("Password");
    }

    public function setProxyHost($proxyHost)
    {
        $this->setValue("ProxyHost", $proxyHost, self::TYPE_STRING);
    }

    public function getProxyHost()
    {
        return $this->getValue("ProxyHost");
    }

    public function setProxyPort($proxyPort)
    {
        $this->setValue("ProxyPort", $proxyPort, self::TYPE_NUMBER);
    }

    public function getProxyPort()
    {
        return $this->getValue("ProxyPort");
    }

    public function setProxyType($proxyType)
    {
        $this->setValue("ProxyType", $proxyType, self::TYPE_STRING);
    }

    public function getProxyType()
    {
        return $this->getValue("ProxyType");
    }
}
