<?php
namespace Topalis\Profile\Payload\Data;

use Topalis\Profile\Annotation\Payload\Key;
use Topalis\Profile\Payload\AbstractPayload;

/**
 * @Key(name="Action", type="string")
 * @Key(name="InterfaceTypeMatch", type="string")
 * @Key(name="SSIDMatch", type="string")
 * @Key(name="URLStringProbe", type="string")
 * @author Florian Pfitzer <pfitzer@w3p.cc>
 */
class OnDemandRule extends AbstractPayload
{
    const TYPE = null;
    protected static $defaultVersion = null;

    public function setAction($action)
    {
        $this->setValue("Action", $action, self::TYPE_STRING);
    }

    public function getAction()
    {
        return $this->getValue("Action");
    }

    public function setInterfaceTypeMatch($interfaceTypeMatch)
    {
        $this->setValue("InterfaceTypeMatch", $interfaceTypeMatch, self::TYPE_STRING);
    }

    public function getInterfaceTypeMatch()
    {
        return $this->getValue("InterfaceTypeMatch");
    }

    public function setSSIDMatch($sSIDMatch)
    {
        $this->setValue("SSIDMatch", $sSIDMatch, self::TYPE_STRING);
    }

    public function getSSIDMatch()
    {
        return $this->getValue("SSIDMatch");
    }

    public function setURLStringProbe($uRLStringProbe)
    {
        $this->setValue("URLStringProbe", $uRLStringProbe, self::TYPE_STRING);
    }

    public function getURLStringProbe()
    {
        return $this->getValue("URLStringProbe");
    }
}
