<?php
namespace Topalis\Profile\Payload;

// @codingStandardsIgnoreStart
/**
 * This class represents a Single Sign-On Account payload.
 * @see https://developer.apple.com/library/ios/featuredarticles/iPhoneConfigurationProfileRef/iPhoneConfigurationProfileRef.pdf#//apple_ref/doc/uid/TP40010206-CH1-SW44
 * @since iOS 7.0
 *
 * @author Dominic Tubach <dominic.tubach@topalis.com>
 */
// @codingStandardsIgnoreEnd
class SingleSignOnAccountPayload extends AbstractPayload
{
    const TYPE = "com.apple.sso";

    public function getName()
    {
        return $this->getValue("Name");
    }

    public function setName($name)
    {
        $this->setValue("Name", $name, self::TYPE_STRING);
    }

    public function getKerberos()
    {
        return $this->getValue("Kerberos");
    }

    public function setKerberos(array $kerberos = null)
    {
        $this->setValue("Kerberos", $kerberos, self::TYPE_DICTIONARY);
    }
}
